#include <utility.h>
#include <ansi_c.h>
#include <userint.h>
#include <gpib.h>
#include "globales.h"
#include <formatio.h>
#include "analyseur_reseau.h"
#include "UIR_analyseur.h"
#include "plugin.h"

PInstrument anritsu =
{
	NULL, // Rempli par 'nouveau'
	
	NULL, // rempli aprs nouveau (par liste.c)
	NULL,
	NULL,
	NULL,
	NULL,
	
	analyseur_nouveau,
	analyseur_liberer,
	analyseur_configure,
	analyseur_getconfig,
	analyseur_get_nom,
	analyseur_set_nom,
	arreter_interruption_analyseur,
	miseenplace_int_analyseur,
	analyseur_init,
	NULL,
	analyseur_execute,
	NULL,

	analyseur_nb_voie,
	analyseur_get_nom_voie,
	analyseur_get_taille_voie,
	analyseur_mesure,
	analyseur_indices,
	analyseur_numero,

	NULL,
	NULL,
	NULL,
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

int CVICALLBACK OK_analyseur (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	infos_analyseur *structu;
	structu = (infos_analyseur *)callbackData;

	switch (event)
		{
		case EVENT_COMMIT:
		
			GetCtrlVal (panel,PANEL_NUMERIC_7 , &structu->adresse_gpib);
			GetCtrlVal (panel,PANEL_config    , &structu->Configuration); 
			GetCtrlVal (panel,PANEL_START     , &structu->Range_Start); 
			GetCtrlVal (panel,PANEL_STOP      , &structu->Range_Stop); 
			GetCtrlVal (panel,PANEL_START_2   , &structu->Gate_Start); 
			GetCtrlVal (panel,PANEL_STOP_2    , &structu->Gate_Stop); 
			GetCtrlVal (panel,PANEL_SWEEP_2   , &structu->ConfigS); 
			GetCtrlVal (panel,PANEL_SWEEP_3   , &structu->Freq_Temp); 
			GetCtrlVal (panel,PANEL_SWEEP_4   , &structu->Gate); 
			GetCtrlVal (panel,PANEL_STRING    , structu->cheminfichierload);
			GetCtrlVal (panel,PANEL_AUTOSCALE , &structu->autoscale); 
			
			DiscardPanel (panel); 
			
			break;
		}
	return 0;
}

static int analyseur_init(PInstrument *analyseur)
{
	char chaine[255];
	int err=0,id_analyseur=0, cpt_voie;
	short shorttmp=0;
	int panel=0;
	char cheminfichierload[MAX_PATHNAME_LEN]; 
	
	infos_analyseur *data_analyseur = analyseur->structure; 
		data_analyseur->zone_memoire[0]=0.0;
		data_analyseur->zone_memoire[1]=0.0;
		
	err = ibfind("GPIB0");
	if (err & ERR)
	{
		MessagePopup ("Problme de carte", "Carte GPIB non dtecte");
		return -1;
	}
	
	
	
	// Dtection d'un instrument  l'adresse indique
	id_analyseur = ibdev (0, data_analyseur->adresse_gpib, NO_SAD, T10s, 1, 1);
	ibclr (id_analyseur);		
	ibln (id_analyseur,data_analyseur->adresse_gpib, NO_SAD, &shorttmp); 
	if (shorttmp== 0) 
		{
		MessagePopup ("Attention", "Il faudrait allumer l'analyseur");
		return -1;
		}

	data_analyseur->identificateur = id_analyseur; 
	
	ibecr(id_analyseur, "*IDN?");
	ibrd(id_analyseur, chaine, 250);
	if (strstr (chaine, "ANRITSU,MS4623B") == NULL) 
	{
		MessagePopup ("Erreur", "Modle non support par ce module !");
		return -1;
	}
	
	
	if ( data_analyseur->panel == 0)
		if ( ( panel = LoadPanel (0, "UIR_analyseur.uir", PANEL)) < 0)
			return -1;
		else
			data_analyseur->panel = panel;	
   
	if (strlen(data_analyseur->cheminfichierload) != 0)
		if (charger(id_analyseur,data_analyseur->cheminfichierload) < 0)
			return -1;
			
	Envoisuranalyseur(data_analyseur);  		
	
	data_analyseur->stop_interruption = RQS; 
	data_analyseur->numero_mesure = 0;

	sprintf(chaine,"%s","ONCP"); 
	ibwrt(id_analyseur,chaine,strlen(chaine));
	ibrd(id_analyseur,chaine,30);
	sscanf(chaine,"%i",&data_analyseur->nombrepoint);
	
	return 0;
}

/* Fonction de mise en place de l'interruption Renvoit CMPL (0x0100) en cas de succs.*/
static int miseenplace_int_analyseur(PInstrument *analyseur)
{
	infos_analyseur *data_analyseur = analyseur->structure;
	int err=0;
	char chaine[255],nico[20];
		int lock;
	
//modif Nico 06/10/2005 suite pb avec interruption Anritsu
	do
	{
		err=ibrsp(data_analyseur->identificateur,nico);
	} while (err & 0x800);
//fin modif Nico	

	err=ibecr(data_analyseur->identificateur,"*CLS");
	err=ibecr(data_analyseur->identificateur,"IEM 8");
	err=ibecr(data_analyseur->identificateur,"HLD");
	// Activation de l'interruption  la fin des mesures sur le frquencemtre
	if ((err = ibecr (data_analyseur->identificateur, "*SRE 128")) & ERR) // Activation
	{
		sprintf(chaine,"Impossible d'initialiser l'interruption (analyseur)");
		MessagePopup("Attention !!!",chaine);
		return err;
	}
	
/*	sprintf(chaine, "GPIB0:%i", data_analyseur->identificateur);
	lock = analyseur->gestion_lock(chaine);
	CmtGetLock(lock);*/

	// Nettoyage du registre d'interruptions
	ibecr(data_analyseur->identificateur,"*ESR?");
	ibrd(data_analyseur->identificateur,chaine,10);
	
	// Mise en place de l'interruption
	err = ibnotify (data_analyseur->identificateur, data_analyseur->stop_interruption, CB_interruption_analyseur, analyseur);
	if (err & ERR)
	{
		sprintf(chaine,"Impossible d'initialiser l'analyseur");
		MessagePopup("Attention !!!",chaine);
		return -1;
	}
	
	// lancement d'une mesure
	if ((err = ibecr (data_analyseur->identificateur, "TRS;WFS"))& ERR) // dclenchement immdiat
	{
		sprintf(chaine,"Impossible de lancer une mesure");
		MessagePopup("Attention !!!",chaine);
		ibnotify (data_analyseur->identificateur, 0, CB_interruption_analyseur, NULL); //Dsactivation de l'interruption
		return err;
	}
	return err;
}
	

int __stdcall CB_interruption_analyseur(int boardOrDevice, int localsta, int localerr, long localcntl, void *callbackData)
{
	PInstrument *analyseur = (PInstrument *)callbackData;
	infos_analyseur *data_analyseur = analyseur->structure;
	
	char chaine[256], srq_resp;
	int cpt_voie;
	char tmp[255];
	int lock=-1;
	
	//data_analyseur = (infos_analyseur *)callbackData;

	switch (localsta)
	{
		case ERR:
			return 0;
		default:
			sprintf(chaine, "GPIB0:%i", data_analyseur->identificateur);
			lock = analyseur->gestion_lock(chaine);
			CmtGetLock(lock);
		
			// Rcupration des mesures
			recupvertical(data_analyseur, data_analyseur->mesures[0], data_analyseur->mesures[1]);
			recuphorizontal(data_analyseur, data_analyseur->indices);
			
			// Incrmentation du nombre de mesures.
		    data_analyseur->numero_mesure++; 

			// Nettoyage du registre d'interruptions
			ibecr(boardOrDevice,"*CLS"); // Peut etre un peu violent (mais a verifier si on peut faire autrement)
			//ibrd(boardOrDevice,chaine,10);
			ibrsp (boardOrDevice, &srq_resp);
			
			Autoscale(data_analyseur);
			
			// relancement d'une mesure
			ibecr (boardOrDevice, "TRS;WFS"); // lancement d'un sweep
	
			CmtReleaseLock(lock);
			return data_analyseur->stop_interruption; // Pour ractiver l'interruption
			break;
		
	}
	return 0;
}

static void arreter_interruption_analyseur(PInstrument *analyseur)
{
	infos_analyseur *data_analyseur = analyseur->structure;
	
	if (data_analyseur->stop_interruption == 0) // dj arrt
		return;
		
	//dsactivation de l'interruption
	data_analyseur->stop_interruption = 0;
	
	//libration de l'identificateur
	//ibonl (data_freq->identificateur, 0);
}

static void analyseur_nouveau(PInstrument **analyseur)
{
	*analyseur = (PInstrument *)malloc(sizeof(PInstrument));
	memcpy (*analyseur, &anritsu, sizeof(PInstrument));
	(*analyseur)->structure = malloc(sizeof(infos_analyseur));
	((infos_analyseur *)(*analyseur)->structure)->adresse_gpib = 6;
	((infos_analyseur *)(*analyseur)->structure)->cheminfichierload[0] = 0;
	sprintf(((infos_analyseur *)(*analyseur)->structure)->nom_instru, "Analyseur de reseau");
}

static void analyseur_liberer(PInstrument *analyseur)
{
	free(analyseur->structure);
	free(analyseur);
}

static void analyseur_get_nom(PInstrument *analyseur, char *nom_instru)
{
	memcpy(nom_instru, ((infos_analyseur *)analyseur->structure)->nom_instru, TAILLE_NOM_INSTRU-1);
}

static void analyseur_set_nom(PInstrument *analyseur, char *nom_instru)
{
	memcpy(((infos_analyseur *)analyseur->structure)->nom_instru, nom_instru, TAILLE_NOM_INSTRU-1);
	((infos_analyseur *)analyseur->structure)->nom_instru[TAILLE_NOM_INSTRU-1] = NULL;
}

static void analyseur_configure(PInstrument *analyseur)
{
	infos_analyseur *structu = analyseur->structure;
	int panel;
	if ((panel = LoadPanel (0, "UIR_analyseur.uir", PANEL)) < 0)
		return ;
	
	SetCtrlVal (panel,PANEL_NUMERIC_7 , structu->adresse_gpib);
	SetCtrlVal (panel,PANEL_config    , structu->Configuration); 
	SetCtrlVal (panel,PANEL_START     , structu->Range_Start); 
	SetCtrlVal (panel,PANEL_STOP      , structu->Range_Stop); 
	SetCtrlVal (panel,PANEL_START_2   , structu->Gate_Start); 
	SetCtrlVal (panel,PANEL_STOP_2    , structu->Gate_Stop); 
	SetCtrlVal (panel,PANEL_SWEEP_2   , structu->ConfigS); 
	SetCtrlVal (panel,PANEL_SWEEP_3   , structu->Freq_Temp); 
	SetCtrlVal (panel,PANEL_SWEEP_4   , structu->Gate); 
	SetCtrlVal (panel,PANEL_STRING    , structu->cheminfichierload);
	SetCtrlVal (panel,PANEL_AUTOSCALE , structu->autoscale);
	
	SetCtrlAttribute (panel, PANEL_BUTTON_OK, ATTR_CALLBACK_DATA, structu);
	SetCtrlAttribute (panel, PANEL_BUTTON_6, ATTR_CALLBACK_DATA, structu);
	SetCtrlAttribute (panel, PANEL_BUTTON_RAZ, ATTR_CALLBACK_DATA, structu);
	SetCtrlAttribute (panel, PANEL_BUTTON_recup, ATTR_CALLBACK_DATA, structu); 
	
	DisplayPanel (panel);
}

static void analyseur_getconfig(PInstrument *analyseur, void** p_strct, void** p_member,
								size_t* p_size, char* p_bool)
{
	infos_analyseur* data = analyseur->structure;

	*p_strct = (void*)(data);
	*p_member = (void*)&(data->mesures);
	
	*p_bool = 0; // On utilise les 2 pointeurs et pas la taille.
}

static int analyseur_nb_voie(PInstrument *analyseur)
{
	int cpt_voie, num_voies_actives = 0;
	infos_analyseur *data_analyseur = analyseur->structure;
	
	if(data_analyseur->Configuration>=5)
		{
		 return 2; 
		}
	else
		{
		return 1;  
		} 
}

static void analyseur_get_nom_voie(PInstrument *analyseur, int voie, char *nom_voie)
{
	int cpt_voie;
	infos_analyseur *data_analyseur = analyseur->structure;
	nom_voie[0] = NULL;
	
	
	// Le nom depend du mode, mais un nom generique est peut etre suffisant (voir avec Nicolas)
	switch(voie)
	{ 
		case 1:
			switch(data_analyseur->Configuration)
				{
				case 1:
					sprintf(nom_voie, "Log Magnitude");
					break;
				case 2:
					sprintf(nom_voie, "Phase");
					break;
				case 3:
					sprintf(nom_voie, "Linear Magnitude");
					break;
				case 4:
					sprintf(nom_voie, "Smith chart");
					break;
				case 5:
					sprintf(nom_voie, "Log Magnitude");
					break;
				case 6:
					sprintf(nom_voie, "Linear Magnitude");
					break;	
				}
			break;
		case 2:
		 		sprintf(nom_voie, "Phase");
			break;
	}
}

static int analyseur_get_taille_voie(PInstrument *analyseur, int voie)
{
	infos_analyseur *data_analyseur = analyseur->structure; 

	char chaine[30];
	int nbpoint=0;
	char ordre[30]; 
	int id_analyseur=data_analyseur->identificateur;

	// Depend de la calibration, donc demander a chaque fois, ou demander une fois et memoriser dans la structure
	return data_analyseur->nombrepoint;
}

static void analyseur_mesure(PInstrument *analyseur, int voie, double *mesure)
{
	infos_analyseur *data_analyseur = analyseur->structure;
	
	memcpy(mesure, data_analyseur->mesures[voie-1], data_analyseur->nombrepoint * sizeof(double));
}

static void analyseur_indices(PInstrument *analyseur, int voie, double *indices)
{
	infos_analyseur *data_analyseur = analyseur->structure;
	
	memcpy(indices, data_analyseur->indices, data_analyseur->nombrepoint * sizeof(double));
}

static unsigned int analyseur_numero(PInstrument *analyseur, int voie)
{
	infos_analyseur *data_analyseur = analyseur->structure;
	
	// Doit retourner le numero de mesure
	return data_analyseur->numero_mesure;
}

static void analyseur_execute (PInstrument *analyseur, char *chaine) // La fonction devrait, dans l'idal, ne pas tre blocante (pour le bon fonctionnement du squenceur)
{
	infos_analyseur *data_analyseur = analyseur->structure;
	// Interprtation de 'chaine'
	// Envoi vers l'appareil
	// Mise  jour du panel pour le pilotage manuel
	 char chaine2[30],chaine1[30],type[30];
	 int id_analyseur= data_analyseur->identificateur;
	 float start=0;
	 float stop=0;
	 float start2=0;
	 float stop2=0;
	 int retval = 0;  
	 
	char tmp[255];
	int lock=-1;

	sprintf(tmp, "GPIB0:%i", data_analyseur->identificateur);
	lock = analyseur->gestion_lock(tmp);
	CmtGetLock(lock); // Pour ne pas parler  l'appareil en mme temps que l'interruption.

	strcpy(tmp, chaine);
	StringUpperCase (tmp);	
	
 	  
//////////////////////////////////////////////
	if (strcmp(tmp,"FWTG")==0)
		{
		ibecr2(id_analyseur,"FGT");
		ibecr(id_analyseur,"GON");
		}
		else if (strcmp(tmp,"FNTG")==0)
		{
		ibecr2(id_analyseur,"FQD");
		ibecr(id_analyseur,"GOF");
		}
		else if(strcmp(tmp,"TWTG")==0)
		{
		ibecr2(id_analyseur,"TBP");
		ibecr(id_analyseur,"GON");
		}
		else if (strcmp(tmp,"TNTG")==0)
		{
		ibecr2(id_analyseur,"TBP");
		ibecr(id_analyseur,"GOF");
		}
///////////////////////////////////////////////////////////////////////////////////////		
		else if (sscanf(tmp,"GATE_START=%f",&start)==1)
		{
		   sprintf(chaine2,"%s %e","GST",start2);
   		   ibwrt(id_analyseur,chaine2,strlen(chaine2));
		}
		else if (sscanf(tmp,"GATE_STOP=%f",&stop)==1)
		{
		   sprintf(chaine2,"%s %e","GSP",stop);
   		   ibwrt(id_analyseur,chaine,strlen(chaine));
		}
		else if (sscanf(tmp,"RANGE_STOP=%f",&stop2)==1)
		{
		   sprintf(chaine2,"%s %e","ZSP",stop2);
   		   ibwrt(id_analyseur,chaine2,strlen(chaine2));
		}
		else if (sscanf(tmp,"RANGE_START=%f",&start2)==1)
		{				  
		   sprintf(chaine2,"%s %e","ZST",start2);
   		   ibwrt(id_analyseur,chaine2,strlen(chaine2));
		 }
///////////////////////////////////////////////////////////////////////////////////////	

		else if (sscanf(tmp,"SAVE %s",chaine1)==1) 
			sauvegarde(id_analyseur,chaine1);
			
///////////////////////////////////////////////////////////////////////////////////////		
		
	if(data_analyseur->Configuration>=5) 
	{
///////////////////////////////////////////////////////////////////////////////////////	
	 	if (strcmp(tmp,"LOGPHASE S11")==0)
		ibecr(id_analyseur,"CH1;S11;MPH");
			
		else if (strcmp(tmp,"LOGPHASE S12")==0)
			ibecr(id_analyseur,"CH1;S12;MPH");
			
		else if (strcmp(tmp,"LOGPHASE S21")==0)
			ibecr(id_analyseur,"CH1;S21;MPH");
				
		else if (strcmp(tmp,"LOGPHASE S22")==0)
			ibecr(id_analyseur,"CH1;S22;MPH");
			
///////////////////////////////////////////////////////////////////////////////////////			
		else if (strcmp(tmp,"LINPHASE S11")==0)
			ibecr(id_analyseur,"CH1;S11;LPH");
			
		else if (strcmp(tmp,"LINPHASE S12")==0)
			ibecr(id_analyseur,"CH1;S12;LPH");
			
		else if (strcmp(tmp,"LINPHASE S21")==0)
			ibecr(id_analyseur,"CH1;S21;LPH");
			
		else if (strcmp(tmp,"LINPHASE S22")==0)
			ibecr(id_analyseur,"CH1;S22;LPH");
	}
	else
///////////////////////////////////////////////////////////////		
		if (strcmp(tmp,"LOG S11")==0)
			ibecr2(id_analyseur,"CH1;S11;MAG");
			 
		else if (strcmp(tmp,"LOG S12")==0)
			ibecr(id_analyseur,"CH1;S12;MAG");
				
		else if (strcmp(tmp,"LOG S21")==0)
			ibecr(id_analyseur,"CH1;S21;MAG");
			
		else if (strcmp(tmp,"LOG S22")==0)
			ibecr(id_analyseur,"CH1;S22;MAG");
///////////////////////////////////////////////////////////////////////////////////////	
		else if (strcmp(tmp,"LIN S11")==0)
			ibecr(id_analyseur,"CH1;S11;LIN");
		
		else if (strcmp(tmp,"LIN S12")==0)
			ibecr(id_analyseur,"CH1;S12;LIN");
			
		else if (strcmp(tmp,"LIN S21")==0)
			ibecr(id_analyseur,"CH1;S11;LIN");
			
		else if (strcmp(tmp,"LIN S22")==0)
			ibecr(id_analyseur,"CH1;S22;LIN");
///////////////////////////////////////////////////////////////////////////////////////				
		else if (strcmp(tmp,"PHASE S11")==0)
			ibecr(id_analyseur,"CH1;S11;PHA");
		
		else if (strcmp(tmp,"PHASE S12")==0)
			ibecr(id_analyseur,"CH1;S12;PHA");
				
		else if (strcmp(tmp,"PHASE S21")==0)
			ibecr(id_analyseur,"CH1;S21;PHA");
					
		else if (strcmp(tmp,"PHASE S22")==0)
			ibecr(id_analyseur,"CH1;S22;PHA");
///////////////////////////////////////////////////////////////////////////////////////				

		CmtReleaseLock(lock);
		
	return;
}
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////

static void debut(int id_analyseur)
{
	char chaine[60],reponse[70];
	chaine[59]=0;
	  	
  	sprintf(chaine,"%s","LSB;OID");
	ibwrt(id_analyseur,chaine,strlen(chaine));
		
	ibrd (id_analyseur, reponse,64);

	sprintf(chaine,"%s","PDT0;*IDN?");
	ibwrt(id_analyseur,chaine,strlen(chaine));
		
	ibrd (id_analyseur, reponse,64);
}

static void fin(int id_analyseur)
{
	char chaine[60],reponse[70];
	chaine[59]=0;
	  	
	sprintf(chaine,"%s","TIN");
	ibwrt(id_analyseur,chaine,strlen(chaine));
	 
	sprintf(chaine,"%s","RTL");
	ibwrt(id_analyseur,chaine,strlen(chaine));
   
	sprintf(chaine,"%s","*ESE 0;IEM 0;ILM 0;*SRE 0;PDT0");
	ibwrt(id_analyseur,chaine,strlen(chaine));

	sprintf(chaine,"%s","RTL");
	ibwrt(id_analyseur,chaine,strlen(chaine));
}

//////////////////////////////////////CHARGER////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
int CVICALLBACK Choix_Fichier_Cal (int panel, int control, int event, 
				void *callbackData, int eventData1, int eventData2)
{
	int retval = 0; 
	

	infos_analyseur *structu;

	structu = (infos_analyseur *)callbackData;

	switch (event)
		{
		case EVENT_COMMIT:
		
			
			retval = FileSelectPopup ("", "*.cal", "*.cal",
									  "Choisir le fichier  charger",
									  VAL_LOAD_BUTTON, 0, 0, 1, 1,
									  structu->cheminfichierload);
			if (retval<=0)
				return 0;
				
			SetCtrlVal (panel,PANEL_STRING , structu->cheminfichierload); 	
				
		  	break;
		}
	return 0;
} 

static int charger(int id_analyseur,char*cheminfichierload)
{
	char chaine[60],reponse[70],chaine3[30],*charg2;
	char *chaine2="C:\\A.CAL";
	char v=15,v2=13;
	int charg=0,toto=3;
	int tt=6;
	
 	FILE *fichier_load; 
 	
	fichier_load = fopen(cheminfichierload, "rb"); 
	if (fichier_load == NULL)
	{
		MessagePopup("Fichier de calibration", "Fichier de calibration non trouv !");
		return -1;
	}
		
	debut(id_analyseur);
  	
  	fseek(fichier_load,0,2);
	charg= ftell(fichier_load);
	toto=feof(fichier_load);
	
	sprintf(chaine3,"DISKWR \"%s\", #%d%d",chaine2,tt,charg);
	
	charg2 = malloc((charg+strlen(chaine3)+1)*sizeof(char)); 
  	
  	sprintf(charg2,"%s",chaine3);
  	fseek(fichier_load,0,0);
  	
  	fread(charg2+strlen(chaine3),sizeof(char),charg,fichier_load); 

  	charg2[charg+strlen(chaine3)]=0x0A;
  	
  	ibwrt(id_analyseur,charg2,charg+strlen(chaine3)+1);
	
	free(charg2);
	
	sprintf(chaine,"RECALL \"%s\"",chaine2);			
	ibwrt(id_analyseur,chaine,strlen(chaine));

	ibtmo(id_analyseur, v);
	sprintf(chaine,"%s%c","*CLS;*ESE 255;*SRE 48",NLend);
	ibwrt(id_analyseur,chaine,strlen(chaine));

	sprintf(chaine,"%s%c","*OPC;TXX? ",NLend);
	ibwrt(id_analyseur,chaine,strlen(chaine));
	
    ibwait(0, 0x0000);
	
	ibrd (id_analyseur, reponse,64);

	sprintf(chaine,"%s%c","*CLS ",NLend);
	ibwrt(id_analyseur,chaine,strlen(chaine));

	ibtmo(id_analyseur, v2);
	
	fin(id_analyseur);
		
	fclose(fichier_load); 
	return 0;
}

static void Envoisuranalyseur(infos_analyseur *data_analyseur)
{
	
	char chaine[30];
	int id_analyseur = data_analyseur->identificateur;
	chaine[29]=0;
	
	//ibecr(data_analyseur->identificateur, "FMB");
	
	switch (data_analyseur->Configuration)
			{
				case 1:
				 {
				 FreqTemp(data_analyseur);
				 sprintf(chaine,"%s","MAG");
				 fonction(chaine,data_analyseur);
				 break;
				 }
				
				case 2:
				 {
				 FreqTemp(data_analyseur);
				sprintf(chaine,"%s","PHA");
				fonction(chaine,data_analyseur);
				 break;
				 }
			 	
				case 3:
				 {
				 FreqTemp(data_analyseur);
				 sprintf(chaine,"%s","LIN"); 
				 fonction(chaine,data_analyseur);
				 break;
				 }
			 
			 	case 4:
				 {
				 FreqTemp(data_analyseur);
				 sprintf(chaine,"%s","SMI");
				 fonction(chaine,data_analyseur);
				 break;
				 }
				 
				case 5:
				 {	
				 FreqTemp(data_analyseur);
				 sprintf(chaine,"%s","MPH");
				 fonction(chaine,data_analyseur);
				 break;
				 } 
				 
				case 6:
				 {
				 FreqTemp(data_analyseur);
				 sprintf(chaine,"%s","LPH");
				 fonction(chaine,data_analyseur);
				 break;
				 }
			break;
			}
	return ;
}

static void fonction (char *chaine, infos_analyseur *data_analyseur)
{
	char chaine2[30];
	int id_analyseur = data_analyseur->identificateur;

	
	switch (data_analyseur->ConfigS)
		{
			case 1:
			 {
			 sprintf(chaine2,"%s%s","CH1;S11;",chaine);
			 ibwrt(id_analyseur,chaine2,strlen(chaine2));
			 Autoscale(data_analyseur);
			 break;
			 }

			case 2:
			 {
			 sprintf(chaine2,"%s%s","CH1;S12;",chaine);
			 ibwrt(id_analyseur,chaine2,strlen(chaine2));
			 Autoscale(data_analyseur); 
			 break;
			 }
		 	
			case 3:
			 {
			 sprintf(chaine2,"%s%s","CH1;S21;",chaine);
			 ibwrt(id_analyseur,chaine2,strlen(chaine2));
			 Autoscale(data_analyseur); 
			 break;
			 }
		 
			case 4:
			 {
			 sprintf(chaine2,"%s%s","CH1;S22;",chaine);
			 ibwrt(id_analyseur,chaine2,strlen(chaine2));
			 Autoscale(data_analyseur); 
			 break;
			 }
		break;
 		}
	return;
}

static void FreqTemp(infos_analyseur *data_analyseur)
{
  char chaine[30];
  int id_analyseur = data_analyseur->identificateur;
  chaine[29]=0;
  	   
   			switch (data_analyseur->Freq_Temp)
			{
				case 1:
				 {
				  sprintf(chaine,"%s","FQD");
   				  ibwrt(id_analyseur,chaine,strlen(chaine));
   				  break;
				 }
				
				case 2:
				 {
				  sprintf(chaine,"%s","TBP");
   				  ibwrt(id_analyseur,chaine,strlen(chaine));
   				  AffGate(data_analyseur);
   				  AffRange(data_analyseur);
   				  break;
				 }
  				case 3:
				 {
				  sprintf(chaine,"%s","FGT");
   				  ibwrt(id_analyseur,chaine,strlen(chaine));
   				  AffGate(data_analyseur);
   				  break;
				 }
			break;
	 		}
	return ;
}

static void AffGate(infos_analyseur *data_analyseur)
{
	char chaine[30];
	int id_analyseur = data_analyseur->identificateur;
	
	switch (data_analyseur->Gate)
				{
				case 1:
				{
				sprintf(chaine,"%s","GOF");
   		   		ibwrt(id_analyseur,chaine,strlen(chaine));
				break;
				}
				case 2:
				{
				sprintf(chaine,"%s","GON");
   		   		ibwrt(id_analyseur,chaine,strlen(chaine));
   		   		sprintf(chaine,"%s %e","GSP",data_analyseur->Gate_Start);
   		   		ibwrt(id_analyseur,chaine,strlen(chaine));
		   		sprintf(chaine,"%s %e","GST",data_analyseur->Gate_Stop);
   		   		ibwrt(id_analyseur,chaine,strlen(chaine));
				break;
				}
				case 3:
				{
				sprintf(chaine,"%s","GDS");
   		   		ibwrt(id_analyseur,chaine,strlen(chaine));
				break;
				}
			break;
			}
}

static void AffRange(infos_analyseur *data_analyseur)
{
	char chaine[30];
	int id_analyseur = data_analyseur->identificateur;
	
	sprintf(chaine,"%s %e","ZSP",data_analyseur->Range_Start);
	ibwrt(id_analyseur,chaine,strlen(chaine));
	sprintf(chaine,"%s %e","ZST",data_analyseur->Range_Stop);
	ibwrt(id_analyseur,chaine,strlen(chaine));
}

static void Autoscale(infos_analyseur *data_analyseur)
{
	char chaine[30];
	int id_analyseur = data_analyseur->identificateur;
	
	if(data_analyseur->autoscale ==0)
		{
		sprintf(chaine,"%s","ASC");
		ibwrt(id_analyseur,chaine,strlen(chaine));
		}

}

/////////////////////////////////////////////////////////////////////////////////////////////

static void Cacher_Start_Stop(int panelHandle)
{
  int Valeur_sweep_3=0; 
  char chaine[30];
  chaine[29]=0;
  
   GetCtrlVal (panelHandle,PANEL_SWEEP_3  , &Valeur_sweep_3); 
   		
	if(Valeur_sweep_3==2)
		{
		 SetCtrlAttribute (panelHandle, PANEL_START, ATTR_DIMMED, 0); 
	 	 SetCtrlAttribute (panelHandle, PANEL_STOP, ATTR_DIMMED, 0);
	 	 Gate_aff(panelHandle);
	 	} 
	else
		{
	     SetCtrlAttribute (panelHandle, PANEL_START, ATTR_DIMMED, 1); 
		 SetCtrlAttribute (panelHandle, PANEL_STOP, ATTR_DIMMED, 1);
		 Gate_aff(panelHandle);
		}
}

static void Gate_aff(int panelHandle)
{
   	int Valeur_sweep_3=0;
   	int dim=0;
   
	GetCtrlVal (panelHandle,PANEL_SWEEP_3 , &Valeur_sweep_3);
	if(Valeur_sweep_3>=2)
		{
	  	SetCtrlAttribute (panelHandle, PANEL_START_2, ATTR_DIMMED, 0); 
	 	SetCtrlAttribute (panelHandle, PANEL_STOP_2, ATTR_DIMMED, 0);
	  	SetCtrlAttribute (panelHandle, PANEL_SWEEP_4, ATTR_DIMMED, 0);
		}
	else
		{
      	SetCtrlAttribute (panelHandle, PANEL_START_2, ATTR_DIMMED, 1); 
	  	SetCtrlAttribute (panelHandle, PANEL_STOP_2, ATTR_DIMMED, 1);
	  	SetCtrlAttribute (panelHandle, PANEL_SWEEP_4, ATTR_DIMMED, 1);
	 	}
}

/////////////////////////////////////////////////////////////////////////////////////////////
static void recuphorizontal(infos_analyseur *data_analyseur, double *horiz)
{
	char ordre[30];
	int id_analyseur = data_analyseur->identificateur;
	int nbpoint = data_analyseur->nombrepoint;  
	
			switch (data_analyseur->Freq_Temp)
			{
				case 1:
				 {
				 sprintf(ordre,"%s","OFV");
				 RecupAXE1(ordre,id_analyseur,nbpoint, horiz); 
				 break;
				 }
				
				case 2:
				 {
				 sprintf(ordre,"%s","OTV");
				 RecupAXE1(ordre,id_analyseur,nbpoint, horiz); 
				 break;
				 }
				case 3:
				 {
				 sprintf(ordre,"%s","OFV");
				 RecupAXE1(ordre,id_analyseur,nbpoint, horiz); 
				 break;
				 }
			break;
			}
		return;	
}    

static void recupvertical(infos_analyseur *data_analyseur, double *vertical1, double *vertical2)
{
	char ordre[30];
	char chaine[30];
	int id_analyseur = data_analyseur->identificateur;
	int nbpoint = data_analyseur->nombrepoint;  

	sprintf(ordre,"%s","OFD");

	if(data_analyseur->Configuration>=5)
		{
		RecupAXE2(ordre,id_analyseur,nbpoint, vertical1, vertical2);
		}
	else
		{
		RecupAXE1(ordre,id_analyseur,nbpoint, vertical1); 
		}
	 
} 

static void RecupAXE1(char *ordre,int id_analyseur,int nbpoint, double *axe)
{
	char channel[60],chaine2[1],*rep;
	float chaine7=0;
	float chaine5=0;
	int i=0,j=0;
	float lec=0,nb=0;
	
	ibwrt(id_analyseur,ordre,strlen(ordre));
	ibrd(id_analyseur, channel,strlen("#"));
    ibrd(id_analyseur, chaine2 , 1);
     
   	sscanf(chaine2,"%f",&nb);
    ibrd(id_analyseur, channel ,nb);
    
    sscanf(channel,"%f",&lec);
	
    rep = malloc((lec+1)*sizeof(char));
    ibrd(id_analyseur,rep,lec+1);
    
   		for(j=0;j<nbpoint;j++)
    	{
    	sscanf((rep+i),"%f",&chaine7);
    	axe[j] = chaine7;
    	i+=19;
    	}
	free(rep);
}		

static void RecupAXE2(char *ordre,int id_analyseur,int nbpoint, double *mag, double *phase)
{
	char channel[60],chaine2[1],*rep;
	float chaine7=0;
	float chaine5=0;
	int i=0,j,n=0;
	float lec=0,nb=0;

	ibwrt(id_analyseur,ordre,strlen(ordre));
	ibrd(id_analyseur, channel,strlen("#"));
    ibrd(id_analyseur, chaine2 , 1);
     
   	sscanf(chaine2,"%f",&nb);
    ibrd(id_analyseur, channel ,nb);
    
    sscanf(channel,"%f",&lec);

    rep = malloc((lec+1)*sizeof(char));
    ibrd(id_analyseur,rep,lec+1);
    
  			for(j=0;j<nbpoint;j++)
    		{
   			sscanf((rep+i),"%f",&chaine7);
    		mag[j] = chaine7;
    		i+=19*2;
   			}
   			i=19;
   			for(j=0;j<nbpoint;j++)
    		{
    		sscanf((rep+i),"%f",&chaine5);
    		phase[j] = chaine5;
    		i+=19*2;
    		} 
    	free(rep);
}    
 	

int CVICALLBACK Choix_fonc (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
		
			Cacher_Start_Stop(panel);
			Gate_aff(panel);
			
			break;
		}
	return 0;
}

int CVICALLBACK RAZ_fichier_cal (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	char chaine[MAX_PATHNAME_LEN];
	infos_analyseur *data_analyseur = (infos_analyseur *)callbackData;
	
	switch (event)
		{
		case EVENT_COMMIT:

			data_analyseur->cheminfichierload[0] = 0;
			sprintf(chaine,"%s", data_analyseur->cheminfichierload);
			SetCtrlVal (panel,PANEL_STRING , chaine); 
		  
			break;
		}
	return 0;
}

int CVICALLBACK recup (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	 
	infos_analyseur *data_analyseur = (infos_analyseur *)callbackData;
	int id_analyseur=0;
	
	id_analyseur = ibdev (0, 6, NO_SAD, T10s, 1, 1);
	
	switch (event)
		{
		case EVENT_COMMIT:
		
			demGate(id_analyseur,panel);
			RecupStartstop(id_analyseur,panel);
			RecupGate(id_analyseur,panel);
			demgraf(id_analyseur,panel);
			demFT(id_analyseur,panel);
			demS(id_analyseur,panel);
			Cacher_Start_Stop(panel);
			Gate_aff(panel);
			
			break;
		}
	return 0;
}

static void demGate(int id_analyseur,int panelHandle)
{
	char chaine[30];
	//int id_analyseur = data_analyseur->identificateur; 
	int ref=0;
	
 	sprintf(chaine,"%s","GOF?");
	ibwrt(id_analyseur,chaine,strlen(chaine));
	ibrd(id_analyseur,chaine,30); 
 	sscanf(chaine,"%d",&ref);
 	
 		switch (ref)
			{
				case 0:
				 {
				 SetCtrlVal (panelHandle,PANEL_SWEEP_4  ,1); 
				 break;
				 }
				
				case 1:
				 {
				 SetCtrlVal (panelHandle,PANEL_SWEEP_4  ,2); 
				 break;
				 }
			 	
				case 2:
				 {
				 SetCtrlVal (panelHandle,PANEL_SWEEP_4  ,3); 
				 break;
				 }
			break;
			}   
		return; 
}
static void RecupStartstop(int id_analyseur,int panelHandle)
{
	char chaine[30];
	float ref=0;
//	int id_analyseur = data_analyseur->identificateur;
   
 	sprintf(chaine,"%s","ZSP?");
	ibwrt(id_analyseur,chaine,strlen(chaine));
	ibrd(id_analyseur,chaine,30); 
	 sscanf(chaine,"%f",&ref);
	SetCtrlVal (panelHandle,PANEL_STOP , ref); 
	
	sprintf(chaine,"%s","ZST?");
	ibwrt(id_analyseur,chaine,strlen(chaine));
	ibrd(id_analyseur,chaine,30); 
	 sscanf(chaine,"%f",&ref);
	SetCtrlVal (panelHandle,PANEL_START  , ref);
}

static void RecupGate(int id_analyseur,int panelHandle)
{
	char chaine[30];
	float ref=0;
    int gate=0;
//    int id_analyseur = data_analyseur->identificateur;
   
 	sprintf(chaine,"%s","GSP?");
	ibwrt(id_analyseur,chaine,strlen(chaine));
	ibrd(id_analyseur,chaine,30); 
	 sscanf(chaine,"%f",&ref);
	SetCtrlVal (panelHandle,PANEL_STOP_2 , ref); 
	
	sprintf(chaine,"%s","GST?");
	ibwrt(id_analyseur,chaine,strlen(chaine));
	ibrd(id_analyseur,chaine,30); 
	 sscanf(chaine,"%f",&ref);
	SetCtrlVal (panelHandle,PANEL_START_2  , ref);
	
	GetCtrlVal (panelHandle,PANEL_SWEEP_3 , &gate); 
	if(gate==3)
	{
	SetCtrlVal (panelHandle,PANEL_SWEEP_4  , 2);
	}
	else
	{
	demGate(id_analyseur,panelHandle);
	}
}   

static void demgraf(int id_analyseur,int panelHandle)
{
	char chaine[30];
	int ref=0;
//	int id_analyseur = data_analyseur->identificateur;

 	sprintf(chaine,"%s","GRF?");
	ibwrt(id_analyseur,chaine,strlen(chaine));
	ibrd(id_analyseur,chaine,30); 
 	sscanf(chaine,"%d",&ref);
 	
 		switch (ref)
			{
				case 1:
				 {
				 SetCtrlVal (panelHandle,PANEL_config  ,1); 
				 break;
				 }
				
				case 2:
				 {
				 SetCtrlVal (panelHandle,PANEL_config  ,2); 
				 break;
				 }
			 	
				case 3:
				 {
				 SetCtrlVal (panelHandle,PANEL_config  ,5); 
				 break;
				 }
			 
			 	case 4:
				 {
				 SetCtrlVal (panelHandle,PANEL_config  ,4); 
				 break;
				 }
				 
				case 10:
				 {	
				 SetCtrlVal (panelHandle,PANEL_config  ,3); 
				 break;
				 } 
				 
				case 11:
				 {
				 SetCtrlVal (panelHandle,PANEL_config  ,6); 
				 break;
				 }
			break;
			}
		return;
				
} 	

static void demS(int id_analyseur,int panelHandle)
{
	char chaine[30];
	int ref=0;
//	int id_analyseur = data_analyseur->identificateur;

 	sprintf(chaine,"%s","SXX?");
	ibwrt(id_analyseur,chaine,strlen(chaine));
	ibrd(id_analyseur,chaine,30); 
 	sscanf(chaine,"%d",&ref);
 	
 		switch (ref)
			{
				case 11:
				 {
				 SetCtrlVal (panelHandle,PANEL_SWEEP_2  ,1); 
				 break;
				 }
				
				case 12:
				 {
				 SetCtrlVal (panelHandle,PANEL_SWEEP_2  ,2); 
				 break;
				 }
			 	
				case 21:
				 {
				 SetCtrlVal (panelHandle,PANEL_SWEEP_2  ,3); 
				 break;
				 }
			 
			 	case 22:
				 {
				 SetCtrlVal (panelHandle,PANEL_SWEEP_2  ,4); 
				 break;
				 }
			break;
			}
		return;
	
}

static void demFT(int id_analyseur,int panelHandle)
{
	char chaine[30];
	int ref=0;
//	int id_analyseur = data_analyseur->identificateur;

 	sprintf(chaine,"%s","TDX?");
	ibwrt(id_analyseur,chaine,strlen(chaine));
	ibrd(id_analyseur,chaine,30); 
 	sscanf(chaine,"%d",&ref);
 	
 		switch (ref)
			{
				case 0:
				 {
				 SetCtrlVal (panelHandle,PANEL_SWEEP_3  ,1); 
				 break;
				 }
				
				case 1:
				 {
				 SetCtrlVal (panelHandle,PANEL_SWEEP_3  ,3); 
				 break;
				 }
			 	
				case 4:
				 {
				 SetCtrlVal (panelHandle,PANEL_SWEEP_3  ,2); 
				 break;
				 }
				 
			break;
			}
		return;
	
}
static void sauvegarde(int id_analyseur,char *chaine3)
{
	static char cheminappli[MAX_PATHNAME_LEN];
	char cheminfichiersave[MAX_PATHNAME_LEN];
	char chaine[60],reponse[70],type1[30],chaine1[60];
	char channel[10],chaine2[2],*rep;
	int i;
    int nb,lec3;
	int retval = 0, mode=0;
	
	FILE *fichier_save;
	chaine[59]=0; 
	
	
   fichier_save = fopen(chaine3, "wb");
    
	sprintf (chaine1, "%s\\%s","C:",chaine3);
	
	sprintf(chaine,"SAVE \"%s\"",chaine1);
	ibwrt(id_analyseur,chaine,strlen(chaine));
	
	sprintf(chaine,"DISKRD \"%s\"",chaine1);
	ibwrt(id_analyseur,chaine,strlen(chaine));
	
	ibrd(id_analyseur, channel,strlen("#"));
    ibrd(id_analyseur, chaine2 , 1);
    chaine2[1]=0;
    
   	sscanf(chaine2,"%i",&nb);
    ibrd(id_analyseur, channel ,nb);
    channel[nb]=0;
    
    sscanf(channel,"%i",&lec3);
    
    rep = malloc((lec3+1)*sizeof(char));
    
    ibrd(id_analyseur,rep,lec3+1);
    
    fwrite(rep,sizeof(char),lec3,fichier_save);  
    free(rep);
  
	sprintf(chaine,"DEL \"%s\"",chaine1);
	ibwrt(id_analyseur,chaine,strlen(chaine));

   fclose(fichier_save);
 }
