#include <userint.h>
#include <ansi_c.h>
#include "plugin.h"
#include "Calculatrice.h"
#include <utility.h>
#include "UIR_calc.h"

PInstrument Calculatrice =
{
	NULL, // rempli par nouveau
	
	NULL, // rempli aprs nouveau (par liste.c)
	NULL,
	NULL,
	NULL,
	NULL,

	bidon_nouveau,
	bidon_liberer,
	bidon_configure,
	bidon_get_config,
	bidon_get_nom,
	bidon_set_nom,
	NULL,
	NULL,
	bidon_init,
	NULL, // status
	NULL, // execute
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,

	bidon_nb_voie,
	bidon_get_nom_voie,
	bidon_mesure,
	bidon_calculer,

	NULL,
	NULL,
	NULL,
	NULL,
	
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

static void bidon_nouveau (PInstrument **bidon)
{
	*bidon = (PInstrument *)malloc(sizeof(PInstrument));
	memcpy (*bidon, &Calculatrice, sizeof(PInstrument));
	(*bidon)->structure = malloc(sizeof(infos_calcul));
	sprintf(((infos_calcul *)(*bidon)->structure)->nom_pilot, "Calculatrice");
	sprintf(((infos_calcul *)(*bidon)->structure)->chaine, "A B C + *");
	// total: 3 malloc
}

static void bidon_liberer (PInstrument *bidon)
{
	free(bidon->structure);
	free(bidon);
	// total: 3 free
}

static void bidon_configure (PInstrument *bidon)
{
	infos_calcul *data = bidon->structure;

	int panel;
	if ((panel = LoadPanel (0, "UIR_calc.uir", P_config)) < 0)
		return ;

	SetCtrlAttribute (panel, P_config_COMMANDBUTTON, ATTR_CALLBACK_DATA, data);
	bidon->init_liste_voie(panel, P_config_RING1);
	bidon->init_liste_voie(panel, P_config_RING2);
	bidon->init_liste_voie(panel, P_config_RING3);
	
	SetCtrlVal(panel, P_config_RING1, data->tatoo_voie1);
	SetCtrlVal(panel, P_config_RING2, data->tatoo_voie2);
	SetCtrlVal(panel, P_config_RING3, data->tatoo_voie3);
	SetCtrlVal(panel, P_config_STRING, data->chaine);
	
	DisplayPanel (panel); // Affiche la fentre
}

static void bidon_get_config(PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool)
{
	infos_calcul* data = instrument->structure;

	*p_strct = (void*)data;
	*p_member = (void*)&(data->stack);
	
	*p_bool = 0;
}

static int bidon_nb_voie (PInstrument *instrument)
{
	return 1;
}

static void bidon_get_nom_voie (PInstrument *instrument, int voie, char *nom_voie)
{
	sprintf(nom_voie, "Voie 1");
}

static void bidon_get_nom (PInstrument *bidon, char *nom_instru)
{
	memcpy(nom_instru, ((infos_calcul *)bidon->structure)->nom_pilot, TAILLE_NOM_INSTRU-1);
}

static void bidon_set_nom (PInstrument *bidon, char *nom_instru)
{
	memcpy(((infos_calcul *)bidon->structure)->nom_pilot, nom_instru, TAILLE_NOM_INSTRU-1);
	((infos_calcul *)bidon->structure)->nom_pilot[TAILLE_NOM_INSTRU-1] = NULL;
}

static double bidon_mesure (PInstrument *instrument, int voie)
{
	return ((infos_calcul *)instrument->structure)->mesure;
}

static void bidon_calculer (PInstrument *instrument)//, ptr_buff_circu *buffer_circu, ptr_buff2D_circu *buffer2D_circu)
{
	ptr_buff_circu *buffer1;
	ptr_buff_circu *buffer2;
	ptr_buff_circu *buffer3;
	double mesure1 = 0, mesure2 = 0,mesure3=0;

	buffer1 = instrument->get_buffer_from_tatoo(((infos_calcul *)instrument->structure)->tatoo_voie1);
	buffer2 = instrument->get_buffer_from_tatoo(((infos_calcul *)instrument->structure)->tatoo_voie2);
	buffer3 = instrument->get_buffer_from_tatoo(((infos_calcul *)instrument->structure)->tatoo_voie3);
	if (buffer1 != NULL)
		mesure1 = buffer1->mesure[buffer1->dernier_indice];
	if (buffer2 != NULL)
		mesure2 = buffer2->mesure[buffer2->dernier_indice];
	if (buffer3 != NULL)
		mesure3 = buffer3->mesure[buffer3->dernier_indice];
	
	calculer(instrument->structure, mesure1, mesure2, mesure3);
	return;
}

static int bidon_init (PInstrument *instrument)
{
	return 0; // negatif = erreur
}

int CVICALLBACK OK_config_calcul_bidon (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	int parametre;
	
	infos_calcul *structu_bidon;
	structu_bidon = (infos_calcul *)callbackData;
	
	switch (event)
		{
		case EVENT_COMMIT:
			
			GetCtrlVal(panel, P_config_RING1, structu_bidon->tatoo_voie1);
			GetCtrlVal(panel, P_config_RING2, structu_bidon->tatoo_voie2);
			GetCtrlVal(panel, P_config_RING3, structu_bidon->tatoo_voie3);
			GetCtrlVal(panel, P_config_STRING,structu_bidon->chaine);
			
			DiscardPanel(panel);
			break;
		}
	return 0;
}


static void empile(infos_calcul *structu_bidon,double value) 
{
	int stack_height=structu_bidon->stack_height;
	
	if (stack_height != STACK_SIZE)
	{
		structu_bidon->stack[stack_height] = value;
		++stack_height;
		structu_bidon->stack_height=stack_height;
	}
}

static double depile(infos_calcul *structu_bidon) 
{
	if (structu_bidon->stack_height == 0)
		return 0;
	return structu_bidon->stack[--structu_bidon->stack_height];
	
}


static void calculer(infos_calcul *structu_bidon,double mesure1,double mesure2,double mesure3)
{	
	int i;
	double value;
	char *chaine =structu_bidon->chaine ;
	char resultat[30];
	
		structu_bidon->stack_height = 0;
			i=0;
			while (sscanf(&chaine[i], "%s", resultat) == 1) //chaine[i] != 0)
			{
				if (strlen(resultat)== 1) // trouver UN caractere
					switch (resultat[0])
					{
					case 'A':
						empile(structu_bidon,mesure1);
						break;
					case 'B':
						empile(structu_bidon,mesure2);
						break;
					case 'C':
						empile(structu_bidon,mesure3);
						break;
			
					case '+':
						empile(structu_bidon,depile(structu_bidon) + depile(structu_bidon));
						break;
					case '-':
						value = depile(structu_bidon);
						empile(structu_bidon,depile(structu_bidon) - value);
						break;
					case '*':
						empile(structu_bidon,depile(structu_bidon) * depile(structu_bidon));
						break;
					case '/':
						value = depile(structu_bidon);
						empile(structu_bidon,depile(structu_bidon) / value);
						break;
					case '^':
						value = depile(structu_bidon);
						empile(structu_bidon,pow(depile(structu_bidon),value));
						break;
					case '%':
						value = depile(structu_bidon);
						empile(structu_bidon,(int)depile(structu_bidon) % (int)value);
						break;
					case '0':
					case '1':
					case '2':
					case '3':
					case '4':
					case '5':
					case '6':
					case '7':
					case '8':
					case '9':
						sscanf(resultat, "%lf", &value);
						empile(structu_bidon,value);
						break;
					
					}
					
				else if (strcmp(resultat,"ln") == 0)
					{
					empile(structu_bidon,log(depile(structu_bidon)));
					}
				else if (strcmp(resultat,"log") == 0)
					{
					empile(structu_bidon,log10(depile(structu_bidon)));
					}
				else if (strcmp(resultat,"exp") == 0) // cherche "exp"
					{
					empile(structu_bidon,exp(depile(structu_bidon)));
					}
				else if (strcmp(resultat,"sqrt") == 0) // cherche "exp"
					{
					empile(structu_bidon,sqrt(depile(structu_bidon)));
					}
				else if (strcmp(resultat,"sin") == 0) // cherche "exp"
					{
					empile(structu_bidon,sin(depile(structu_bidon)));
					}
				else if (strcmp(resultat,"cos") == 0) // cherche "exp"
					{
					empile(structu_bidon,cos(depile(structu_bidon)));
					}	
				else if (1 == sscanf(resultat, "%lf", &value)) // obtenir une valeur en double
					empile(structu_bidon,value);
				
				while( (chaine[i] != ' ') && (chaine[i] != 0)) i++; // On cherche l'espace
				if (chaine[i] != 0) i++; // Et on demarre apres
			}
			//SetCtrlVal(panelhandle,PANEL_NUMERIC,depile());
			structu_bidon->mesure=depile(structu_bidon);
}
