#include "UIR_graphtab.h"
#include <easytab.h>
#include <gpib.h>
#include <utility.h>
#include <formatio.h>
#include <toolbox.h>
#include <ansi_c.h>
#include <cvirte.h>		
#include <userint.h>
#include "Interface.h" // Prototypes callback graphiques

#include "plugin.h"
#include "liste.h" // Prototypes fonctions

#include "save.h"
#include "reader.h"


/* Ca marche de folie ce matheval ! */
#include <matheval.h>
#define BUFFER_SIZE 256

void hop(void);
/* ----------------- */

static int panelCommande;
static int panelTimer;
static int panelSynchro;

static int plugintab;

static int panelInstru; // Plugin d'instruments
static int panelGraphs;

int nb_graphs = 1;

static FILE *f_sequenceur = NULL;

int Lock_port_parallele = 0;

static char cheminappli[MAX_PATHNAME_LEN];
static char surveillance[MAX_PATHNAME_LEN];

static tmaillon *list_inst = NULL;

// Etat de l'acquisition
static int etat = 0; // 0 = pas d'acquisition, 1 = acquisition
static int duree_restante = 0; // en secondes
static int echantillon_a_la_demande = 0;

int main (int argc, char *argv[])
{
	int err;
	void *f;

	#ifdef _CVI_DEBUG_
	//CVIDynamicMemoryInfo ("Start", NULL, NULL, DYNAMIC_MEMORY_SHOW_ALLOCATED_MEMORY);
	#endif

	SetSystemAttribute (ATTR_TASKBAR_BUTTON_VISIBLE, 0); // Pas de bouton par dfaut, les fentres ont leur propre bouton si besoin

	if (InitCVIRTE (0, argv, 0) == 0)
		return -1;	/* out of memory */
	if ((panelCommande = LoadPanel (0, "Interface.uir", P_Commande)) < 0)
		return -1;
	if ((panelTimer = LoadPanel (panelCommande, "Interface.uir", PANEL_Time)) < 0)
		return -1;
	if ((panelSynchro = LoadPanel (0, "Interface.uir", P_Synchro)) < 0)
		return -1;


	plugintab = EasyTab_ConvertFromCanvas (panelCommande, P_Commande_PLUGINTAB);
	err = EasyTab_LoadPanels (panelCommande, plugintab, 1, "Interface.uir", __CVIUserHInst,
                          P_Instru, &panelInstru, 0);
                          
	err = EasyTab_LoadPanels (panelCommande, plugintab, 1, "Interface.uir", __CVIUserHInst,
                          P_Graphs, &panelGraphs, 0);

	// Initialisatio du smaphore de protection du port parallle
	CmtNewLock (NULL, 0, &Lock_port_parallele);
	
	// Future faon d'utiliser les locks
	init_gestion_lock();
                                                   
	err = ibsic(0);
	err = ibsic(1);
	

	DisplayPanel (panelCommande);
	
	RunUserInterface ();

	//EasyTab_RemovePanel(panelCommande, plugintab, panelInstru);
	//EasyTab_RemovePanel(panelCommande, plugintab, panelGraphs);
	
	DiscardPanel(panelCommande);
	DiscardPanel(panelTimer);
	DiscardPanel(panelSynchro);
	
	// Libration de la mmoire (appareils)
	Effacer_liste_inst(list_inst);
	
	#ifdef _CVI_DEBUG_
	//CVIDynamicMemoryInfo ("Quit", NULL, NULL, DYNAMIC_MEMORY_SHOW_ALLOCATED_MEMORY);
	#endif
	
	return 0;
}

int CVICALLBACK Prog_Ajouter (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
{
	int panelAjou;
	
	switch (event)
	{
		case EVENT_COMMIT:	
			//hop();
			if ((panelAjou = LoadPanel (0, "Interface.uir", PANEL_Ajou)) < 0)
				return -1;
			Reserver_buffer_circu(list_inst);
			remplir_liste_instru(panelAjou);
			DisplayPanel (panelAjou);
		break;
	}
	return 0;
}

int CVICALLBACK Prog_Ajouter_Annuler (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			DiscardPanel (panel); // Dtruit la fentre
		break;
	}
	return 0;
}

int CVICALLBACK Prog_Ajouter_OK (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
{
	PInstrument *instrument = NULL;
	char Type_Appareil[255];
	char nom_instru[TAILLE_NOM_INSTRU];
	
	switch (event)
	{
		case EVENT_COMMIT:
			
			GetCtrlVal (panel, PANEL_Ajou_RING_Ajou_Type, Type_Appareil); // Rcupration du type d'appareil
			instrument = Nouvel_instrument(Type_Appareil);
			if (instrument == NULL)
			{
				DiscardPanel (panel); // Dtruit la fentre
				MessagePopup ("ATTENTION !", "Instrument non support");
				break;
			}
			instrument->configure(instrument);
			list_inst = Inserer_instru(list_inst, Type_Appareil, instrument, get_tatoo());
			
			instrument->get_nom_instru(instrument, nom_instru); // Nom par dfaut
			InsertListItem (panelInstru, P_Instru_LISTBOX_Liste, -1, nom_instru, 0);
			
			DiscardPanel (panel); // Dtruit la fentre
			
		break;
	}
	return 0;
}

int CVICALLBACK Prog_Supprimer (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
{
	int Compteur;
	tmaillon *suppression = list_inst;
	int Nombre_Elements = 0, Actif = 0;

	switch (event)
	{
		case EVENT_COMMIT:
		
			GetNumListItems (panel, P_Instru_LISTBOX_Liste, &Nombre_Elements);
			for (Compteur=0;Compteur<Nombre_Elements;Compteur++)
			{
				// L'lment est-il slctionn ?
				IsListItemChecked (panel, P_Instru_LISTBOX_Liste, Compteur, &Actif);
				if (Actif)
				{
					DeleteListItem (panel, P_Instru_LISTBOX_Liste, Compteur--, 1); // Efface l'lment slectionn de la liste
					list_inst = Supprimer_instru (list_inst, suppression);
					break;
				}
				suppression = suppression->suivant;
			}
			break;
	}
	return 0;
}

int CVICALLBACK Prog_Proprietes (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
{
	int Compteur;
	tmaillon *proprietes = list_inst;
	int Nombre_Elements = 0, Actif = 0;
	
	switch (event)
	{
		case EVENT_COMMIT:
			 // Rcupration du nombre d'lments dans la liste d'instruments
			GetNumListItems (panel, P_Instru_LISTBOX_Liste, &Nombre_Elements);
			 // On parcours la liste
			for (Compteur=0;Compteur<Nombre_Elements;Compteur++)
			{
				// A la recherche de l'lment slectionn
				IsListItemChecked (panel, P_Instru_LISTBOX_Liste, Compteur, &Actif);
				if (Actif)
				{
					proprietes->plugin->configure(proprietes->plugin);
					break;
				}			  
				proprietes = proprietes->suivant;
			}
			break;
	}

	return 0;
}

int CVICALLBACK Prog_PiloterI (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
{
	int Compteur;
	tmaillon *proprietes = list_inst;
	int Nombre_Elements = 0, Actif = 0;
	
	switch (event)
	{
		case EVENT_COMMIT:
			 // Rcupration du nombre d'lments dans la liste des courbes
			GetNumListItems (panel, P_Instru_LISTBOX_Liste, &Nombre_Elements);
			 // On parcours la liste
			for (Compteur=0;Compteur<Nombre_Elements;Compteur++)
			{
				// A la recherche de l'lment slectionn
				IsListItemChecked (panel, P_Instru_LISTBOX_Liste, Compteur, &Actif);
				if (Actif)
				{
					if (proprietes->plugin->piloter != NULL)
						proprietes->plugin->piloter(proprietes->plugin);
					break;
				}			  
				proprietes = proprietes->suivant;
			}
			break;
	}

	return 0;
}

int CVICALLBACK Prog_Renommer (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	int panelRenommer;
	int Compteur;
	tmaillon *proprietes = list_inst;
	int Nombre_Elements = 0, Actif = 0;
	char nom_instru[TAILLE_NOM_INSTRU];
	
	switch (event)
		{
		case EVENT_COMMIT:
			 // Rcupration du nombre d'lments dans la liste d'instruments
			GetNumListItems (panel, P_Instru_LISTBOX_Liste, &Nombre_Elements);
			 // On parcours la liste
			for (Compteur=0;Compteur<Nombre_Elements;Compteur++)
			{
				// A la recherche de l'lment slectionn
				IsListItemChecked (panel, P_Instru_LISTBOX_Liste, Compteur, &Actif);
				if (Actif)
				{
					if ((panelRenommer = LoadPanel (0, "Interface.uir", P_RENOMMER)) < 0)
						return -1;
					proprietes->plugin->get_nom_instru(proprietes->plugin, nom_instru);
					SetCtrlAttribute (panelRenommer, P_RENOMMER_COMMANDBUTTON, ATTR_CALLBACK_DATA, proprietes->plugin);
					SetCtrlAttribute (panelRenommer, P_RENOMMER_NOM_INSTRUMENT, ATTR_MAX_ENTRY_LENGTH, TAILLE_NOM_INSTRU-1);
					SetCtrlVal(panelRenommer, P_RENOMMER_NOM_INSTRUMENT, nom_instru);
					DisplayPanel (panelRenommer);
					break;
				}			  
				proprietes = proprietes->suivant;
			}
			break;
		}
	return 0;
}

int CVICALLBACK OK_RENOMMER (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	char nom_instru[TAILLE_NOM_INSTRU];
	PInstrument *instrument;
	int Compteur;
	tmaillon *proprietes = list_inst;
	int Nombre_Elements = 0;
	
	instrument = callbackData;
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (panel, P_RENOMMER_NOM_INSTRUMENT, nom_instru);
			instrument->set_nom_instru(instrument, nom_instru);
			
			// mise a jour graphique (j'ai pas trouve moins lourd et SR pour trouver l'indice dans la liste)
			GetNumListItems (panelInstru, P_Instru_LISTBOX_Liste, &Nombre_Elements);
			 // On parcours la liste
			for (Compteur=0;Compteur<Nombre_Elements;Compteur++)
			{
				// A la recherche de l'lment slectionn
				if (proprietes->plugin == instrument) // si les pointeurs correspondent, c'est que c'est trs certainement le bon instrument (mais une supression et un ajout entre temps ont peut etre fausse la manoeuvre)
				{
					ReplaceListItem (panelInstru, P_Instru_LISTBOX_Liste, Compteur, nom_instru, 0);
					break;
				}			  
				proprietes = proprietes->suivant;
			}

			DiscardPanel(panel);
			break;
		}
	return 0;
}

int CVICALLBACK Prog_Supprimer_Tout_Instru (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	int Reponse = 0;

	if (event == EVENT_COMMIT)
	{
		Reponse = ConfirmPopup ("ATTENTION", "Voulez vous vraiment effacer tous les instruments ?");
		if (Reponse == 1)
		{
			ClearListCtrl (panel, P_Instru_LISTBOX_Liste); // Efface tous les lments de la liste des intruments
        	
        	list_inst = Effacer_liste_inst(list_inst);
       	}
       }
    return 0;
}

int CVICALLBACK Prog_Quitter (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			// Destruction du verrou sur le port parallle
			CmtDiscardLock (Lock_port_parallele);
			
			// Future version de la gestion des locks
			fin_gestion_lock();
			
			// Quitte le programme
			QuitUserInterface (0);
			break;
	}
	return 0;
}

int CVICALLBACK Prog_Liste (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	tmaillon *proprietes = list_inst;
	int Compteur, Nombre_Elements=0, Actif;
	
	switch (event)
	{
		case EVENT_MARK_STATE_CHANGE:
			// Empche la slection de deux instruments en mme temps
			GetNumListItems (panel, P_Instru_LISTBOX_Liste, &Nombre_Elements);
			for (Compteur=0;Compteur<Nombre_Elements;Compteur++)
			{
				CheckListItem (panel, P_Instru_LISTBOX_Liste, Compteur, Compteur == eventData2 );
			}
			break;
		case EVENT_LEFT_DOUBLE_CLICK:
			if (etat == 1) return 0;
			 // Rcupration du nombre d'lments dans la liste d'instruments
			GetNumListItems (panel, P_Instru_LISTBOX_Liste, &Nombre_Elements);
			 // On parcours la liste
			Reserver_buffer_circu(list_inst);
			for (Compteur=0;Compteur<Nombre_Elements;Compteur++)
			{
				// A la recherche de l'lment slectionn
				IsListItemChecked (panel, P_Instru_LISTBOX_Liste, Compteur, &Actif);
				if (Actif)
				{
					proprietes->plugin->configure(proprietes->plugin);
					break;
				}			  
				proprietes = proprietes->suivant;
			}
			break;
	}
	return 0;
}

int CVICALLBACK Prog_Sauvegarde (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	tmaillon *list_locale = list_inst;
	char chaine[500];
	char nom_instru[TAILLE_NOM_INSTRU];
	char cheminfichiersave[MAX_PATHNAME_LEN]; 
	int retval = 0;
	float tmp=1.0;
	FILE *fichier_save;
	
	void* tmp_strct;
	void* tmp_member;
	size_t tmp_size;
	char bool;
	
	char str_tmp[256];
	
	char chemin2[MAX_PATHNAME_LEN];
	
	int i_tmp;
	
	SAVE_INFOS sifs;
	
	switch (event)
		{
		case EVENT_COMMIT:
			
			retval = FileSelectPopup (cheminappli, ".sav", "*.sav",
									  "Choisir le fichier d'enregistrement",
									  VAL_SAVE_BUTTON, 0, 0, 1, 1,
									  cheminfichiersave);
									  
									  
			if (retval<=0)
				return -1;
		
//------------------ SAUVEGARDES DES INFOS GENERALES : xxx.sav.gen ---------------								
									  
			strcpy(chemin2,cheminfichiersave);									  
			strcat(chemin2,".gen");
			
			fichier_save = fopen(chemin2, "w");
			
			if (fichier_save==NULL) // Impossible d'ouvrir le fichier
				return MessagePopup ("Attention", "Impossible d'ouvrir le fichier");
			
			
			fprintf(fichier_save,";Fichier de sauvegarde des rglages gnraux.\n");
			fprintf(fichier_save, "init_tatoo=%d;\n", status_tatoo());
			
			
			GetCtrlVal(panelGraphs, P_Graphs_N_nbpointsgraphs, &i_tmp);
			fprintf(fichier_save, "nb_pts_graph=%d;\n", i_tmp);
			
			GetCtrlVal(panelCommande, P_Commande_N_sous_ech_2D, &i_tmp);
			fprintf(fichier_save, "sous_ech_2D=%d;\n", i_tmp);
			
			GetCtrlVal(panelGraphs, P_Graphs_N_mid, &i_tmp); 
			fprintf(fichier_save, "div_mid=%d;\n", i_tmp);
			
			GetCtrlVal(panelGraphs, P_Graphs_N_long, &i_tmp); 
			fprintf(fichier_save, "div_long=%d;\n", i_tmp);
			
			fprintf(fichier_save, "nb_graphes=%d;\n", nb_graphs);
			
			GetCtrlVal(panelCommande, P_Commande_Mode_Fichier, &i_tmp);
			fprintf(fichier_save, "mode_fichier=%d;\n", i_tmp);
			
			// Sauvegarde de la frquence d'chantillonage
			GetCtrlVal (panelCommande, P_Commande_N_TEch, &tmp);
			fprintf(fichier_save,"frequence_ech=%f;\n",tmp);
			
			fclose(fichier_save);
			
//------------------ SAUVEGARDES DES CONFIGS INSTRUMENTS : xxx.sav ---------------	

			// Initialise la structure
			init_save(&sifs);
				
			while (list_locale) // Les instruments
			{
				tmp_strct = NULL;
				tmp_member = NULL;
				tmp_size = 0;
				bool = -1;
				
				(list_locale->plugin->get_memory)(list_locale->plugin,
												&tmp_strct, &tmp_member, &tmp_size, &bool);
				
				switch(bool)
				{
					case 0: // Debut / Fin
					
						add_struct_to_save_A(&sifs, tmp_strct, tmp_member, list_locale->Type_Apareil, list_locale->tatoo, "TODO");
						
						break;
						
					case 1: // Debut / Taille
					
						add_struct_to_save_B(&sifs, tmp_strct, tmp_size, list_locale->Type_Apareil, list_locale->tatoo, "TODO");
					
						break;
						
					default:
						MessagePopup("Erreur","Un plugin n'a pas correctement rpondu au get_memory().");
						break;
				}
				
				list_locale = list_locale->suivant;
			}
			
			save_all(cheminfichiersave,&sifs);
			
			// Libre toute la mmoire
			free_all(&sifs);
			
			break;
		}
	return 0;
}

int CVICALLBACK Prog_Charger_Fichier (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	char Chaine_lue[50];
	char Donnees_lues[500];
	char cheminfichierload[MAX_PATHNAME_LEN]; 
	char nom_instru[TAILLE_NOM_INSTRU];
	FILE *f;
	int retval = 0;
	int tatoo;
	PInstrument *instrument = NULL;
	float tmp=1.0;
	int i;
	char type_instrument[256];
	char nom_instrument[256];
	int i_tmp = 0;

	void* tmp_strct;
	void* tmp_member;
	size_t tmp_size;
	char bool;
	
	tmaillon* liste_instru;

	char chemin2[MAX_PATHNAME_LEN];
	
	SAVE_INFOS sifs;
	
	DICTIONARY dico;
	
	double d_tmp;
	

	switch (event)
	{
		case EVENT_COMMIT:

			retval = FileSelectPopup (cheminappli, "*.sav", "*.sav",
									  "Choisir le fichier  charger",
									  VAL_LOAD_BUTTON, 0, 0, 1, 1,
									  cheminfichierload); 
									  
			if (retval<=0)
				return -1;
			
//------------------ CHARGEMENT DES INFOS GENERALES : xxx.sav.gen ---------------								

			strcpy(chemin2,cheminfichierload);									  
			strcat(chemin2,".gen");
			
			reader_init(&dico);
			
			reader_load_file(chemin2,&dico);
			
			// Frquence d'chantillonage.
			d_tmp = reader_return_double("frequence_ech",&dico);
			SetCtrlVal (panelCommande, P_Commande_N_TEch, d_tmp);
			
			// Nombre de points du graphique
			i_tmp = reader_return_int("nb_pts_graph",&dico);
			SetCtrlVal (panelGraphs, P_Graphs_N_nbpointsgraphs, i_tmp);
			
			// Sous echantillonage 2D.
			i_tmp = reader_return_int("sous_ech_2D",&dico);
			SetCtrlVal (panelCommande, P_Commande_N_sous_ech_2D, i_tmp);
			
			// Division echantillonnage graphe moyen terme.
			i_tmp = reader_return_int("div_mid",&dico);
			SetCtrlVal (panelGraphs, P_Graphs_N_mid, i_tmp);

			// Division echantillonnage graphe moyen terme.
			i_tmp = reader_return_int("div_long",&dico);
			SetCtrlVal (panelGraphs, P_Graphs_N_long, i_tmp);
			
			nb_graphs = reader_return_int("nb_graphes", &dico);
			SetCtrlVal(panelGraphs, P_Graphs_NUMERIC, nb_graphs);
			
			init_tatoo( reader_return_int("init_tatoo", &dico));
			
			
			SetCtrlVal(panelCommande,P_Commande_Mode_Fichier,reader_return_int("mode_fichier",&dico));
			
			reader_free(&dico);

//------------------ CHARGEMENT DES CONFIGURATIONS D'INSTRUMENTS : xxx.sav ---------------								
			
			ClearListCtrl (panelInstru, P_Instru_LISTBOX_Liste);
			list_inst = Effacer_liste_inst(list_inst);
			
			init_save(&sifs);
			
			// Il faudra rcuprer le nom de l'instrument pour le mettre dans le plugin
			// APRES l'appel  Nouvel_instrument
			for(i=1;get_struct_type(cheminfichierload,i,type_instrument)
			                   && get_struct_tatoo(cheminfichierload,i,&tatoo);i++)
			{
			
				instrument = Nouvel_instrument(type_instrument); // on teste voir si le type d'instrument est support
				
				if (instrument != NULL) // instrument reconnu
				{
					// On le met dans la liste des instruments (la liste interne, pas la liste graphique)
					list_inst = Inserer_instru(list_inst, type_instrument, instrument, tatoo);
					
					// On empile la structure
					tmp_strct = NULL;
					tmp_member = NULL;
					tmp_size = 0;
					bool = -1;

					(instrument->get_memory)(instrument,&tmp_strct, &tmp_member, &tmp_size, &bool);
				
					switch(bool)
					{
						case 0: // Debut / Fin
					
							// On rcupre la structure de l'instrument
							add_struct_to_save_A(&sifs, tmp_strct, tmp_member, "INUTILE", 0, "");
						
							break;
						
						case 1: // Debut / Taille
					
							// On rcupre la structure de l'instrument
							add_struct_to_save_B(&sifs, tmp_strct, tmp_size, "INUTILE", 0, "");
					
							break;
						
						default:
							MessagePopup("Erreur","Un plugin n'a pas correctement rpondu au get_memory().");
							break;
					}
					
				}
			
			
			}

			// On rempli les structures obtenues juste avant avec le contenu du fichier de sauvegarde
			load_all(cheminfichierload,&sifs);
			
			free_all(&sifs);
			
			liste_instru = list_inst;

			// On met  jour la liste graphique
			while(liste_instru)
			{
				instrument = liste_instru->plugin;
			
				(instrument->get_nom_instru)(instrument, nom_instrument);
			
				InsertListItem (panelInstru, P_Instru_LISTBOX_Liste, -1, nom_instrument, 0);
				
				liste_instru = liste_instru->suivant;
			}
				
			
			break;
			
	}
	return 0;
}

int CVICALLBACK Prog_Acquisition (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	char cheminfichierseq[MAX_PATHNAME_LEN];
	char cheminfichierenreg[MAX_PATHNAME_LEN];
	tmaillon *list_acq;
	int err;
	int Mode_fichier;
	float Tech; //Priode d'chantillonage
	int i_tmp;
	
	
	
	switch (event)
	{
		case EVENT_COMMIT:
			switch (etat)
			{
				case 0:
				
					if (list_inst == NULL)
						return MessagePopup ("Attention","Aucun appareil de mesures n'est prsent dans la liste");
					
					Mode_boutons_acq(panelCommande, panelInstru, panelGraphs);
					
					// TODO: c'est ptet un peu lourd de le faire tout le temps, ca...
					Reserver_buffer_circu(list_inst); // On met  jour la liste des voies

					// Initialisation des instruments
					list_acq = list_inst;
					if (list_acq)
					{
						afficher_status(panelCommande, "Initialisation des instruments en cours");
						while (list_acq)
						{
							if (list_acq->plugin->init)
							{
								err = list_acq->plugin->init(list_acq->plugin);
								if (err<0)
								{
									MessagePopup("Attention","L'initialisation a chou");
									afficher_status(panelCommande, "Initialisation des instruments choue");
									Mode_boutons_stopped(panelCommande, panelInstru, panelGraphs);
									return err ;
								}
							}
							list_acq = list_acq->suivant;
						}
						afficher_status(panelCommande, "Initialisation des instruments russie");
					}

					// TODO: c'est ptet un peu lourd de le faire tout le temps, ca...
					Reserver_buffer_circu(list_inst); // On met  jour la liste des voies

					// Lancement des mesures sur instruments
					list_acq = list_inst;
					if (list_acq)
					{
						afficher_status(panelCommande, "Lancement des mesures (instruments)");
						while (list_acq)
						{
							if (list_acq->plugin->start)
							{
								err = list_acq->plugin->start(list_acq->plugin);
								if (err & 0x8000)
								{
									MessagePopup("Attention","Impossible de lancer toutes les mesures");
									afficher_status(panelCommande, "Mesures impossibles");
									afficher_status(panelCommande, "Arrt des instruments");
									arret_instru(list_inst);
									Mode_boutons_stopped(panelCommande, panelInstru, panelGraphs);
									return err ;
								}
							}
							list_acq = list_acq->suivant;
						} 
						afficher_status(panelCommande, "Mesures lances (instruments)");
					}

					// Rcupration de la priode d'chantillonage
					GetCtrlVal(panelCommande,P_Commande_N_TEch,&Tech);
					
					// Rcupration chantillons  la demande ou non
					GetCtrlVal(panelCommande, P_Commande_CHECKBOX, &echantillon_a_la_demande);
					if (echantillon_a_la_demande == 1) SetCtrlAttribute (panelCommande, P_Commande_CHECKBOX, ATTR_DIMMED, 0);

					Reserver_buffer_circu(list_inst); // On met  jour la liste des voies
					Init_buffer_circu(panelCommande, panelGraphs); // On l'initialise
					
					// Idem pour les appareils 2D
					err = Init_buffer2D_circu(list_inst);
					if (err <0)
						MessagePopup("AIE", "Problme de malloc (!). C'est pas un comportement normal"); // TODO: peut mieux faire
					
					GetCtrlVal(panelGraphs, P_Graphs_NUMERIC, &i_tmp);
					
					// Init graph 2D/3D et table
					Init2D(i_tmp);
					Init3D();
					
					afficher_status(panelCommande, "Acquisition en cours");
					// Configuration de la frquence d'chantillonage
					SetCtrlAttribute (panelTimer, PANEL_Time_TIMER_echantillon,ATTR_INTERVAL,Tech);
					// Activation du timer d'chantillonage
					SetCtrlAttribute (panelTimer, PANEL_Time_TIMER_echantillon,ATTR_ENABLED, 1);
					
					GetCtrlVal (panelCommande, P_Commande_Mode_Fichier, &Mode_fichier);
					
					// Rcupration dure limite
					GetCtrlVal(panelCommande, P_Commande_TimeLimit, &duree_restante);
					duree_restante *= 60;
					// Avec -1 on dsactive le mode d'acquisition limite
					if (Mode_fichier != 3) duree_restante = -1;

					switch (Mode_fichier)
					{
						case 0: // Acquisition continue
						case 3: // Acquisition limite
							if (FileSelectPopup (cheminappli, "*.xls", "*.xls", "Choisir le fichier d'enregistrement des rsultats", VAL_SAVE_BUTTON, 0, 0, 1, 1, cheminfichierenreg) > 0)
							{
								if (Ouvrir_enregistrement(cheminfichierenreg, list_inst) < 0) // Impossible d'ouvrir le fichier
								{
									afficher_status(panelCommande, "Impossible d'ouvrir le fichier. Arrt !");
									// Dsactivation timer chantillonage
									SetCtrlAttribute (panelTimer, PANEL_Time_TIMER_echantillon,ATTR_ENABLED, 0);
									Liberer_buffer_circu();
									Liberer_buffer2D_circu();
									arret_instru(list_inst);
									Mode_boutons_stopped(panelCommande, panelInstru, panelGraphs);
									Discard3D();
									Discard2D();
									return -1;
								}
							} else {
								afficher_status(panelCommande, "Annulation de l'acquisition");
								SetCtrlAttribute (panelTimer, PANEL_Time_TIMER_echantillon,ATTR_ENABLED, 0);
								Liberer_buffer_circu();
								Liberer_buffer2D_circu();
								arret_instru(list_inst);
								Mode_boutons_stopped(panelCommande, panelInstru, panelGraphs);
								Discard3D();
								Discard2D();
								return -1;
							}
							break;
						case 1: // Acquisition synchronise
							/* Dsactivation du bouton acquisition */
							SetCtrlAttribute (panelCommande, P_Commande_COMMANDBUTTON_Acq, ATTR_DIMMED, 1);
							afficher_status(panelCommande, "Synchro en cours");
						
							DisplayPanel (panelSynchro);
							break;
						case 2:
							if (FileSelectPopup (cheminappli, "*.txt", "*.txt", "Choisir le fichier du squenceur", VAL_LOAD_BUTTON, 0, 0, 1, 0, cheminfichierseq) > 0)
							{
								if ((f_sequenceur = fopen(cheminfichierseq, "r")) == NULL) // Impossible d'ouvrir le fichier
								{
									afficher_status(panelCommande, "Impossible d'ouvrir le fichier. Arrt !");
									// Dsactivation timer chantillonage
									SetCtrlAttribute (panelTimer, PANEL_Time_TIMER_echantillon,ATTR_ENABLED, 0);
									Liberer_buffer_circu();
									Liberer_buffer2D_circu();
									arret_instru(list_inst);
									Mode_boutons_stopped(panelCommande, panelInstru, panelGraphs);
									Discard3D();
									Discard2D();
									return -1;
								}
							} else {
								afficher_status(panelCommande, "Annulation de l'acquisition");
								SetCtrlAttribute (panelTimer, PANEL_Time_TIMER_echantillon,ATTR_ENABLED, 0);
								Liberer_buffer_circu();
								Liberer_buffer2D_circu();
								arret_instru(list_inst);
								Mode_boutons_stopped(panelCommande, panelInstru, panelGraphs);
								Discard3D();
								Discard2D();
								return -1;
							}
							//SetCtrlAttribute (panelTimer, PANEL_Time_TIMER_SEQ,ATTR_ENABLED, 1);
							break;
					}
					etat = 1; // acquisition en cours
					
					SetCtrlAttribute (panel, control, ATTR_LABEL_TEXT, "Arrter A__cquisition" );
					
					break;
				
				
				case 1:
					// Dsactivation des timers
					SetCtrlAttribute (panelTimer, PANEL_Time_TIMER_echantillon, ATTR_ENABLED, 0);
					//SetCtrlAttribute (panelTimer, PANEL_Time_TIMER_SEQ,ATTR_ENABLED, 0);
					SetCtrlAttribute (panelTimer, PANEL_Time_T_synchrobanc, ATTR_ENABLED,0);
					
					Discard2D();
					Discard3D();
					
					Liberer_buffer_circu();
					Liberer_buffer2D_circu();
					
					afficher_status(panelCommande, "Arrt des instruments");
					
					// Arrt des instruments
					arret_instru(list_inst);
					
					Fermer_enregistrement(list_inst);
					
					if (f_sequenceur != NULL)
						fclose(f_sequenceur);
					f_sequenceur=NULL;
					
					Mode_boutons_stopped(panelCommande, panelInstru, panelGraphs);
					
					afficher_status(panelCommande, "Acquisition termine");
					
					etat=0;
					
					SetCtrlAttribute (panel, control, ATTR_LABEL_TEXT, "Dmarrer A__cquisition" );
					
					
					break;
			}
			break;
	}
	return 0;
}

int CVICALLBACK CB_synchrobanc (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	// Activation - Dsactivation de la synchro
	int err,etat_btn;
	
	switch (event)
	{
		case EVENT_COMMIT:
			//Etat du bouton ?
			GetCtrlVal (panelSynchro, P_Synchro_TBN_Synchobanc, &etat_btn);
			
			switch (etat_btn)
			{
				case 1:
					// Rcupration du rpertoire 
					err = DirSelectPopup (cheminappli, "Choisissez le rpertoire dans lequel surveiller",1, 1, surveillance);
					
					if (err <=0) // pas (ou invalide) de rpertoire choisi
					{
						MessagePopup("Attention","Aucun rpertoire n'a t slectionn.\n Surveillance INACTIVE");
						SetCtrlVal (panelSynchro, P_Synchro_TBN_Synchobanc, 1);
						return -1;
					}
					strcat (surveillance,"\\"); 
					
					/* Mise  jour de l'indicateur de statut */ 
					SetCtrlVal (panelSynchro, P_Synchro_TEXTMSG_synchromes, "Initialisation des instruments");
					
					Mode_boutons_acq(panelCommande, panelInstru, panelGraphs);
					
					/* Activation du timer de surveillance */
					SetCtrlAttribute (panelTimer, PANEL_Time_T_synchrobanc, ATTR_ENABLED,1);
					/* Mise  jour de l'indicateur de statut */
					SetCtrlVal (panelSynchro, P_Synchro_TEXTMSG_synchromes, "Surveillance");
					break;
				
				case 0:
					// Masque la fentre "Syncronisation"
					HidePanel (panelSynchro);
					
					afficher_status(panelCommande, "Synchro suspendue");
					
					/* Ractivation du bouton acquisition */
					SetCtrlAttribute (panelCommande, P_Commande_COMMANDBUTTON_Acq, ATTR_DIMMED, 0);
					
					/* Dsctivation du timer de surveillance */
					SetCtrlAttribute (panelTimer, PANEL_Time_T_synchrobanc, ATTR_ENABLED,0);
					/* Dsctivation du timer d'attente */
					SetCtrlAttribute (panelTimer, PANEL_Time_T_Attente,ATTR_ENABLED, 0);
					/* Mise  jour de l'indicateur de statut */
					SetCtrlVal (panelSynchro, P_Synchro_TEXTMSG_synchromes, "");
				
					Fermer_enregistrement(list_inst);
					break;
			}
			
			break;
	}
	return 0;
}

int CVICALLBACK CB_T_Seq (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	static cpt_boucle = -1; // indice de la boucle courante (-1 = pas a l'interieur d'une boucle)
	static attente = 0;
	static struct { fpos_t position; int occurences; } Pile[30];
	static float variable[26];
	static fpos_t label[26];
	static PInstrument *instru_status = NULL;
	static time_t tictoc = 0;
	float membre_gauche, membre_droit;
	char carac, carac2;
	char ligne[255];
	char chaine[255];
	char chainebis[255];
	char *p_char;
	char nom_fichier[255];
	int nb_tour_a_faire;
	tmaillon *list_pocale;
	int num_voie, max_voie;
	time_t tictoc_now;
	
	fpos_t f_position;
	
	switch (event)
		{
		case EVENT_TIMER_TICK:



			// Pas spcifique au squenceur, mais comme il tourne tout le temps c'est plus pratique
			if (duree_restante >=0)
				duree_restante--;
			if (duree_restante == 0) {
				Fermer_enregistrement(list_inst);
				afficher_status(panelCommande, "Fermeture du fichier d'enregistrement");
			}
			
			
			if( !etat )
			{
				attente = 0;
				return 0;
			}
		
			//InsertTextBoxLine (panelCommande, P_Commande_SEQ_STATUS, -1, "Tick!");
			if (f_sequenceur == NULL)
				return 0;
			
			if (attente > 0)
			{
				attente--;
				return 0;
			}
			
			while (1)
			{
				if (instru_status && instru_status->status) // doit on attendre un instru ?
					if (instru_status->status(instru_status) == STATUS_PRET)
					{
						afficher_status(panelCommande, "Instru prt");
						instru_status = NULL;
					}
					else
						return 0; // on doit attendre encore ? -> on vera au prochain TICK
				else // pas de status disponible ou pas d'attente
					instru_status = NULL;

				do
				{
					if (fgets(ligne, 254, f_sequenceur) ==  NULL)
						return 0; // fin du fichier / lecture impossible
					
					p_char = strchr(ligne, '#'); // A la recherche de commentaires
					if (p_char != NULL)
						*p_char = NULL; // on les "supprime"
					p_char = ligne;
					while ( (*p_char == ' ') || (*p_char == '\t') ) // On ignore les espaces/tabulations en dbut de ligne
						p_char++;
					if ((strlen(p_char)>0) && (p_char[strlen(p_char)-1] == '\n'))
						p_char[strlen(p_char)-1] = NULL; // on supprime le retour chariot de fin
				} while (*p_char == NULL);
				
				interpreter_variables(p_char, variable);

				if (sscanf(p_char, "label %c", &carac) == 1)
				{
					// placement d'un label vers lequel revenir plus tard
					if (isalpha(carac))
						fgetpos(f_sequenceur, &label[tolower(carac)-97]);
				}
				else if (!strncmp(p_char, "tic", strlen("tic")))
				{
					time(&tictoc);
					sprintf(chaine, "[tic]");
					afficher_status(panelCommande, chaine);
				}
				else if (!strncmp(p_char+1, "=toc", strlen("=toc")))
				{
					time(&tictoc_now);
					if ( (sscanf(p_char, "%c", &carac)==1) && (isalpha(carac)) )
					{
						carac=tolower(carac);
						variable[carac-97] = (double)(tictoc_now-tictoc);
						sprintf(chaine, "[toc] Variable modifie (%c = %f)", carac, variable[carac-97]);
						afficher_status(panelCommande, chaine);
					} else break;
				}
				else if (sscanf(p_char, "retour %c", &carac) == 1)
				{
					// ne peut que remonter a un label deja defini
					// le comportement d'un retour vers un label indefini est indefini
					if (isalpha(carac))
						fsetpos(f_sequenceur, &label[tolower(carac)-97]);
				}
				else if (sscanf(p_char, "faire_si %f%c%f", &membre_gauche, &carac, &membre_droit) == 3)
				{
					// si le test ne se verifie pas, on lit une ligne pour faire avancer le pointeur (ce qui empeche le sequenceur de la lire)
					switch (carac)
					{
						case '>':
							if (!(membre_gauche > membre_droit))
								fgets(chaine, 254, f_sequenceur);
							break;
						case '<':
							if (!(membre_gauche < membre_droit))
								fgets(chaine, 254, f_sequenceur);
							break;
						case '=':
							if (!(membre_gauche == membre_droit))
								fgets(chaine, 254, f_sequenceur);
							break;
					}
				}
				else if (sscanf(p_char, "boucle %d", &nb_tour_a_faire) == 1)
				{
					// nouvelle boucle -> on declare (on empile la position de retour et le nombre d'iterations)
					fgetpos(f_sequenceur, &f_position);
					cpt_boucle++;
					Pile[cpt_boucle].position = f_position;
					Pile[cpt_boucle].occurences = nb_tour_a_faire;
				}
				else if (!strncmp(p_char, "fin_boucle", strlen("fin_boucle")))
				{
					if (Pile[cpt_boucle].occurences == -1) // boucle infinie
					{
						fsetpos(f_sequenceur, &Pile[cpt_boucle].position);
						return 0;
					}
					else
					{
						Pile[cpt_boucle].occurences--;
						if (Pile[cpt_boucle].occurences > 0) // il faut encore boucler, on recupere la position de retour et on 'fsetpos'
							fsetpos(f_sequenceur, &Pile[cpt_boucle].position);
						else // on a fini de boucler, on depile la boucle
							cpt_boucle--;
					}
				}
				else if (sscanf(p_char, "attente %d", &attente) == 1)
				{
					if (attente > 0) // protection anti-boulet
					{
						sprintf(chaine, "Attente de %d secondes", attente);
						afficher_status(panelCommande, chaine);
						attente--;
						return 0;
					}
					else
						afficher_status(panelCommande, "Attente impossible");
				}
				else if (sscanf(p_char, "set %c%s", &carac, chaine) == 2) // une variable intervient
				{
					if (isalpha(carac))
					{
						carac=tolower(carac);
						strcpy(p_char, chaine+1);
						
						membre_droit = atof(p_char);
						if( errno == ERANGE ) membre_droit = 0; // probleme, caractre  la con
						
						switch(chaine[0])
						{
							case '=':
								variable[carac-97] = membre_droit;
								break;
							case '+':
								variable[carac-97] += membre_droit;
								break;
							case '-':
								variable[carac-97] -= membre_droit;
								break;
							case '*':
								variable[carac-97] *= membre_droit;
								break;
						}
						sprintf(chaine, "Variable modifie (%c = %f)", carac, variable[carac-97]);
						afficher_status(panelCommande, chaine);
					}
				}
				else if (!strncmp(p_char, "fermer", strlen("fermer"))) // Fermeture du fichier d'acquisition
				{
					Fermer_enregistrement(list_inst);
					afficher_status(panelCommande, "Fermeture du fichier d'enregistrement");
				}
				else if (!strncmp(p_char, "ouvrir ", strlen("ouvrir "))) // Ouverture d'un fichier d'acquisition
				{
					sprintf(nom_fichier, "%s", p_char+strlen("ouvrir ")); // init de la variable de travail (nom_fichier)
					sprintf(chaine, "Ouverture de \"%s\"", nom_fichier);
					Ouvrir_enregistrement(nom_fichier, list_inst);
					afficher_status(panelCommande, chaine);
				}
				else if (!strncmp(p_char, "demarquer", strlen("demarquer"))) // enlevement du marquage (marqueur_fichier)
				{
					Marquer_donnees("", panelCommande, P_Commande_DeMarquage);
					afficher_status(panelCommande, "Dmarquage");
				}
				else if (!strncmp(p_char, "marquer ", strlen("marquer "))) // marquage (marqueur_fichier)
				{
					sprintf(chainebis, "%s", p_char+strlen("marquer "));
					Marquer_donnees(chainebis, panelCommande, P_Commande_DeMarquage);
					sprintf(chaine, "Marquage: %s", chainebis);
					afficher_status(panelCommande, chaine);
				}
				else if ( (sscanf(p_char, "pour %c utiliser_mesure voie %d de : ", &carac, &num_voie) == 2) || (sscanf(p_char, "pour %c utiliser_calcul voie %d de : ", &carac, &num_voie) == 2) )
				{
					carac2 = '?';
					// Message par dfaut si quelque chose se passe mal
					sprintf(chainebis, "Variable %c NON assigne  cause d'une erreur", carac);

					// Ruse ultime pour savoir si c'est utiliser_mesure ou utiliser_calcul
					while (*p_char != '_') p_char++;
					p_char++;
					carac2 = *p_char; // 'm' pour les mesures, 'c' pour les calculs

					while (*p_char != ':') p_char++; // on pointera sur ':'
					p_char+=2; //on pointera aprs l'espace aprs ':', donc sur le nom s'il y en a un
					if (isalpha(carac))
						carac=tolower(carac);
					else
						break;
					
					list_pocale = list_inst;
					while (list_pocale)
					{
						if (list_pocale->plugin->get_nom_instru)
						{
							list_pocale->plugin->get_nom_instru(list_pocale->plugin, chaine);
							if (!stricmp(p_char, chaine)) // Comparaison sans respecter la casse
							{
								membre_droit = 0;
								max_voie = 0;
								
								if ( (carac2 == 'm') && (list_pocale->plugin->nb_voie_1D) )
									max_voie = list_pocale->plugin->nb_voie_1D(list_pocale->plugin);
								if ( (carac2 == 'c') && (list_pocale->plugin->nb_voie_calcul) )
									max_voie = list_pocale->plugin->nb_voie_calcul(list_pocale->plugin);
								
								if ( (num_voie < 1) || (num_voie>max_voie) )
								{
									sprintf(chainebis, "Numro de voie illgal !");
									break;
								}
								
								//recupration de la mesure sans passer par les buffers (TODO: bonne ide ou pas ?)
								if ( (carac2 == 'm') && (list_pocale->plugin->mesure_1D) )
									membre_droit = list_pocale->plugin->mesure_1D(list_pocale->plugin, num_voie);
								if ( (carac2 == 'c') && (list_pocale->plugin->mesure_calcul) )
									membre_droit = list_pocale->plugin->mesure_calcul(list_pocale->plugin, num_voie);

								//assignation de la variable
								variable[carac-97] = membre_droit;

								//affichage d'un message
								if(fabs(membre_droit)>1)
									sprintf (chainebis,"[%c]Variable %c assigne  : %f", carac2, carac, membre_droit);
								else
									sprintf (chainebis,"[%c]Variable %c assigne  : %e", carac2, carac, membre_droit);
							}
						}
						list_pocale = list_pocale->suivant;
					}
					afficher_status(panelCommande, chainebis);
				}
				else if (!strncmp(p_char, "attendre ", strlen("attendre "))) // attente d'un pilote
				{
					// on cherche l'instrument dont le nom correspond
					p_char+=strlen("attendre ");
					sprintf(chainebis, "Attente impossible (%s)", p_char);
					list_pocale = list_inst;
					while (list_pocale)
					{
						if (list_pocale->plugin->get_nom_instru)
						{
							list_pocale->plugin->get_nom_instru(list_pocale->plugin, chaine);
							if (!stricmp(p_char, chaine)) // Comparaison sans respecter la casse
							{
								instru_status = list_pocale->plugin; // on init le pointeur vers la structure
								sprintf(chainebis, "Attente du pilote: \"%s\"", chaine);
								break;
							}
						}
						list_pocale = list_pocale->suivant;
					}
					
					// on return pas, car dans le cas ou on ne provoque pas d'attente, on gagne du temps
					afficher_status(panelCommande, chainebis);
				}
				else if (!strnicmp(p_char, "commande ", strlen("commande "))) // commande pilotage
				{
					p_char+=strlen("commande ");
					commander_appareil(p_char, chainebis, list_inst); // "nom d'appareil : commande a faire" dans p_char
					afficher_status(panelCommande, chainebis);

				}
				else if (!strncmp(p_char, "echantillon", strlen("echantillon"))) // Echantillons  la demande
				{
					if (echantillon_a_la_demande == 1)
					{
						Ecriture_donnees(list_inst);
						afficher_status(panelCommande, "Echantillon demand");
					}
					else
						afficher_status(panelCommande, "Pas d'chantillons  la demande dans ce mode");
				}
				else
				{
					sprintf(chaine, "Commande non reconnue: %s", p_char);
					afficher_status(panelCommande, chaine);
				}
			}
		}
	return 0;
}

int CVICALLBACK Prog_Echantillon (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:

			if (echantillon_a_la_demande == 1)
				Ecriture_donnees(list_inst);
			else
				afficher_status(panelCommande, "Pas d'chantillons  la demande dans ce mode");
			
			break;
		}
	return 0;
}

int CVICALLBACK CB_T_echantillon (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_TIMER_TICK:

			SetWaitCursor (1);
			
			Echantilloner(list_inst); // Instruments, Calculs et Courbes
			Visu(); // Instruments, Calculs (1D) et Courbes (2D)
			if (echantillon_a_la_demande == 0) Ecriture_donnees(list_inst);
			
			SetWaitCursor (0);
			
			break;
	}
	return 0;
}	 

int CVICALLBACK CB_T_Synchroban (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	// Timer de surveillance (suspendu pendant l'acquisition)

	int fichier=-1,dureeacq, intervallemesure, err=0,popup=0;
	char *positionptvirg,nomrenommer[255],tmp[256],avant[MAX_PATHNAME_LEN],apres[MAX_PATHNAME_LEN],nomfichier[256];

	switch (event)
		{
		case EVENT_TIMER_TICK:
			memcpy (avant, surveillance, MAX_PATHNAME_LEN);

			/*Rcupration du nom du fichier  surveiller*/ GetCtrlVal (panelSynchro, P_Synchro_S_nomfichier, nomfichier);
			strcat(avant,nomfichier);

			fichier = OpenFile (avant, 1, VAL_OPEN_AS_IS, VAL_ASCII);
			if (fichier !=-1) // Le banc a crit le fichier de synchronisation
			{
				ReadLine (fichier, tmp, 255);
				positionptvirg = (char*)memchr (tmp, ';', strlen(tmp));
				err = sscanf(positionptvirg+1,"%9s",nomrenommer); // Nom du futur fichier
					if (err<1) popup=1;
						
				ReadLine (fichier, tmp, 255);
				positionptvirg = (char*)memchr (tmp, ';', strlen(tmp));
				err = sscanf(positionptvirg+1,"%d",&dureeacq); // Dure de l'acquisition
					if (err<1 || dureeacq<1) popup=1;
					
				ReadLine (fichier, tmp, 255);
				positionptvirg = (char*)memchr (tmp, ';', strlen(tmp));
				err = sscanf(positionptvirg+1,"%d",&intervallemesure); // intervalle entre deux mesures
					if (err<1 | intervallemesure<1| dureeacq<intervallemesure) popup=1;
				
				CloseFile(fichier);
				
				if (popup==1) 
				{
					SetCtrlVal (panelSynchro, P_Synchro_TEXTMSG_synchromes, "Fichier invalide !");
					return 0;
				}
				// Construction du nouveau nom de fichier d'entte
				memcpy (apres, surveillance, MAX_PATHNAME_LEN);
				sprintf(apres,"%s%s%s",apres,nomrenommer,".ent");
				
				/* on renomme le fichier*/
				err=RenameFile (avant, apres);
				if (err==-9)// Le fichier existe dj !
					{
					DeleteFile(apres); //l'effacer
					RenameFile (avant, apres); // et persvrer
					}
				// Construction du nom de fichier contennant les donnes
				memcpy (apres, surveillance, MAX_PATHNAME_LEN);
				sprintf(apres,"%s%s%s",apres,nomrenommer,".xls");
				Ouvrir_enregistrement(apres, list_inst);
				
				sprintf(tmp,"Mesures dans le fichier %s",nomrenommer);
				/* Mise  jour de l'indicateur de statut*/
				SetCtrlVal (panelSynchro, P_Synchro_TEXTMSG_synchromes, tmp);
				/* Configuration de la frquence d'chantillonage*/
				SetCtrlAttribute (panelTimer, PANEL_Time_TIMER_echantillon,ATTR_INTERVAL,(double)intervallemesure);
				/* Dsactivation du timer de surveillance*/
				SetCtrlAttribute (panelTimer, PANEL_Time_T_synchrobanc, ATTR_ENABLED,0);
				/* Configuration du timer d'attente*/
				SetCtrlAttribute (panelTimer, PANEL_Time_T_Attente,ATTR_INTERVAL, (double)dureeacq);
				/* Activation du timer d'attente*/
				SetCtrlAttribute (panelTimer, PANEL_Time_T_Attente, ATTR_ENABLED, 1);
				
				// Enregistrement de la premire mesure  la main
				CB_T_echantillon (panelTimer, PANEL_Time_TIMER_echantillon, EVENT_TIMER_TICK,NULL, eventData1, eventData2);
			}
			break;
		}
	return 0;
}

int CVICALLBACK CB_T_Attente (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	// Timer de dure d'acquisition
	switch (event)
		{
		case EVENT_TIMER_TICK:
			/* Dsctivation du timer d'attente*/			SetCtrlAttribute (panelTimer, PANEL_Time_T_Attente,ATTR_ENABLED, 0);
			/* Activation du timer de surveillance*/		SetCtrlAttribute (panelTimer, PANEL_Time_T_synchrobanc, ATTR_ENABLED,1); 
			/* Mise  jour de l'indicateur de statut*/		SetCtrlVal (panelSynchro, P_Synchro_TEXTMSG_synchromes, "Surveillance");
			
			/* fermeture du fichier de donnes de mesure*/
			Fermer_enregistrement(list_inst);
			break;
		}
	return 0;
}

int CVICALLBACK Prog_Scan_GPIB (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	int panelSCAN;
	
	switch (event)
		{
		case EVENT_COMMIT:
			if ((panelSCAN = LoadPanel (0, "Interface.uir", P_SCAN)) < 0)
				return -1;
			SetCtrlAttribute (panelCommande, P_Commande_COMMANDBUTTON_Acq, ATTR_DIMMED, 1);
			DisplayPanel (panelSCAN);
			break;
		}
	return 0;
}

int CVICALLBACK DO_Scan (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	short liste_adresse[31];
	short liste_listeners[255];
	int boucle;
	char reponse[255];
	
	for (boucle=1;boucle<31;boucle++)
		liste_adresse[boucle-1]=boucle;
	liste_adresse[boucle-1]=-1;
	memset(liste_listeners, 0, 255*sizeof(short));
	
	switch (event)
		{
		case EVENT_COMMIT:
			FindLstn (0, liste_adresse, liste_listeners, 254);
			boucle=0;
			DeleteTableRows (panel, P_SCAN_TABLE, 1, -1);
			while (liste_listeners[boucle] > 0)
			{
				Send (0, liste_listeners[boucle], "*IDN?", strlen("*IDN?"), 2);
				Receive (0, liste_listeners[boucle], reponse, 255, 256);
				reponse[ThreadIbcnt()]=0;
				InsertTableRows (panel, P_SCAN_TABLE, -1, 1, VAL_CELL_STRING);
				SetTableCellVal (panel, P_SCAN_TABLE, MakePoint(2, boucle+1), reponse);
				sprintf(reponse, "%i", liste_listeners[boucle]);
				SetTableCellVal (panel, P_SCAN_TABLE, MakePoint(1, boucle+1), reponse);
				boucle++;
			}
			
			break;
		}
	return 0;
}

int CVICALLBACK Fermer_Scan (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			DiscardPanel(panel);
			SetCtrlAttribute (panelCommande, P_Commande_COMMANDBUTTON_Acq, ATTR_DIMMED, 0);
			break;
		}
	return 0;
}

int CVICALLBACK CB_TABS (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_TAB_CHANGED:
			//Reserver_buffer_circu(list_inst, list_calc);
			break;
		}
	return 0;
}

int CVICALLBACK CB_Marquer (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	char chaine[255];
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (panel, P_Commande_Marquage, chaine);
			Marquer_donnees(chaine, panelCommande, P_Commande_DeMarquage);
			break;
		}
	return 0;
}

int CVICALLBACK CB_Marquer_2 (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	char chaine[255];
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (panel, P_Commande_Marquage_2, chaine);
			Marquer_donnees(chaine, panelCommande, P_Commande_DeMarquage);
			break;
		}
	return 0;
}

int CVICALLBACK CB_Marquer_3 (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	char chaine[255];
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (panel, P_Commande_Marquage_3, chaine);
			Marquer_donnees(chaine, panelCommande, P_Commande_DeMarquage);
			break;
		}
	return 0;
}

int CVICALLBACK CB_DeMarquer (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	char chaine[255];
	switch (event)
		{
		case EVENT_COMMIT:
			sprintf(chaine, "");
			Marquer_donnees(chaine, panelCommande, P_Commande_DeMarquage);
			break;
		}
	return 0;
}

int CVICALLBACK CB_enable_graph_3 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{

	int i_tmp = 0;

	switch (event)
		{
		case EVENT_COMMIT:

			GetCtrlVal(panel, control, &i_tmp);

			SetCtrlAttribute (panel, P_Graph_GRAPH_3, ATTR_VISIBLE, i_tmp);
			SetCtrlAttribute (panel, P_Graph_DIFF_VOIE_1_2, ATTR_VISIBLE, i_tmp);
			SetCtrlAttribute (panel, P_Graph_DIFF_VOIE_2_2, ATTR_VISIBLE, i_tmp);

			break;
		}
	return 0;
}

int CVICALLBACK CB_enable_graph_2 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int i_tmp = 0;

	switch (event)
		{
		case EVENT_COMMIT:
		
			GetCtrlVal(panel, control, &i_tmp);
			
			SetCtrlAttribute (panel, P_Graph_GRAPH_2, ATTR_VISIBLE, i_tmp);
			SetCtrlAttribute (panel, P_Graph_DIFF_VOIE_1_1, ATTR_VISIBLE, i_tmp);
			SetCtrlAttribute (panel, P_Graph_DIFF_VOIE_2_1, ATTR_VISIBLE, i_tmp);
			

		break;
		}
	return 0;
}

int CVICALLBACK CB_nb_graphes (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int i_tmp;

	switch (event)
		{
		case EVENT_COMMIT:
		
			if(!etat) return 0;
		
			GetCtrlVal(panel, control, &i_tmp);
		
			MAJ2D(i_tmp);
			
			break;
		}
	return 0;
}
