/*
Fichier gnr automatiquement pour l'instrument Pousse Seringue
*/

#include "plugin.h"

typedef struct
{

	char nom_instrument[128];
	int com_port;
	int panel_pilotage;

// Variables Utilisateur :  chaque position du tableau correspond un pousse seringue
	char	nb_PS;				// Nombre de pousses seringues
	int		instr_panel_height[4];
	int		pilot_panel_height[4];
	char	label_PS[4][64];	// Label associ au pousse seringue
	char	adresse[4];
	char	on_off[4];			// 0=OFF, 1=ON
	char	direction[4];		// 0=infuse, 1=withdraw
	float	diametre[4];		// Unit en mm
	int		rate[4];			// Dbit en L/hr
	
/*-------------------------------------
  Ne placez en dessous de cette ligne
  que des variables qui NE doivent PAS
  etre sauvegardes.				
---------------------------------------*/
	char dont_remove_me;

}infos_Pousse_Seringue;


// Fonctions obligatoires
static void Pousse_Seringue_nouveau( PInstrument** );
static void Pousse_Seringue_liberer( PInstrument* );
static void Pousse_Seringue_get_nom( PInstrument*, char* );
static void Pousse_Seringue_set_nom( PInstrument*, char* );
static void Pousse_Seringue_configure( PInstrument* );
static void Pousse_Seringue_get_config( PInstrument*, void**, void**, size_t*, char* );

static void Pousse_Seringue_stop( PInstrument* );
static int Pousse_Seringue_start( PInstrument* );
static int Pousse_Seringue_init( PInstrument* );
static int Pousse_Seringue_status( PInstrument* );
static void Pousse_Seringue_execute( PInstrument*, char* );
static void Pousse_Seringue_piloter( PInstrument* );


// Fonctions du pousse seringue
void write_read_monitor_rs232(infos_Pousse_Seringue * data, char * cmdToSend);
int controlID_to_index(int);
int index_to_controlID(int);


