#include "plugin.h"

typedef struct	
{
	int adresse_gpib;
	int identificateur;
	int nombrepoint;
	int stop_interruption;
	int numero_mesure;
	int panel; 
	
	char cheminfichierload[MAX_PATHNAME_LEN];
	
	char nom_instru[128];
	
	int Configuration;
	float Range_Start;  
	float Range_Stop;   
	float Gate_Start;   
	float Gate_Stop;    
	int ConfigS;      
	int Freq_Temp;    
	int Gate;
	int autoscale;

	// Zone  ne pas sauvegarder

	double mesures[2][1601];
	double indices[1601];
	double zone_memoire[2]; 
	
	
} infos_analyseur;

static void analyseur_nouveau(PInstrument **analyseur);
static int analyseur_init(PInstrument *analyseur) ;
static int miseenplace_int_analyseur(PInstrument *analyseur);
int __stdcall CB_interruption_analyseur(int boardOrDevice, int localsta, int localerr, long localcntl, void *callbackData);
static void arreter_interruption_analyseur(PInstrument *analyseur);
static void analyseur_liberer(PInstrument *analyseur);
static void analyseur_get_nom(PInstrument *analyseur, char *nom_instru);
static void analyseur_set_nom(PInstrument *analyseur, char *nom_instru);
static void analyseur_configure(PInstrument *analyseur);
static void analyseur_getconfig(PInstrument *analyseur, void** p_strct, void** p_member, size_t* p_size, char* p_bool);
static int analyseur_nb_voie(PInstrument *analyseur);
static void analyseur_get_nom_voie(PInstrument *analyseur, int voie, char *nom_voie);
static int analyseur_get_taille_voie(PInstrument *analyseur, int voie);
static void analyseur_mesure(PInstrument *analyseur, int voie, double *mesure);
static void analyseur_indices(PInstrument *analyseur, int voie, double *indices);
static unsigned int analyseur_numero(PInstrument *analyseur, int voie);
static void analyseur_execute (PInstrument *analyseur, char *chaine);

static void debut(int id_analyseur);
static void fin(int id_analyseur);
static int charger(int id_analyseur,char*);
static void Envoisuranalyseur(infos_analyseur *data_analyseur);
static void fonction (char *chaine, infos_analyseur *data_analyseur);
static void FreqTemp(infos_analyseur *data_analyseur);
static void AffGate(infos_analyseur *data_analyseur);
static void AffRange(infos_analyseur *data_analyseur);
static void Autoscale(infos_analyseur *data_analyseur);

static void Cacher_Start_Stop(int panelHandle);
static void Gate_aff(int panelHandle);

static void recuphorizontal(infos_analyseur *data_analyseur, double *horiz);
static void recupvertical(infos_analyseur *data_analyseur, double *vertical1, double *vertical2);
static void RecupAXE1(char *ordre,int id_analyseur,int nbpoint, double *axe);
static void RecupAXE2(char *ordre,int id_analyseur,int nbpoint, double *mag, double *phase);

static void demGate(int id_analyseur,int panelHandle);
static void RecupStartstop(int id_analyseur,int panelHandle); 
static void RecupGate(int id_analyseur,int panelHandle); 
static void demFT(int id_analyseur,int panelHandle);
static void demS(int id_analyseur,int panelHandle);
static void demgraf(int id_analyseur,int panelHandle);

static void sauvegarde(int id_analyseur,char*chaine3);
