#include <userint.h>
#include <ansi_c.h>
#include "plugin.h"
#include "bidon_pilote.h"
#include <utility.h> // pour NULL (au moins) :)
#include "UIR_bidon_pilote.h"

PInstrument pilote_bidon =
{
	NULL, // Rempli par 'nouveau'
	
	NULL, // rempli aprs nouveau (par liste.c)
	NULL,
	NULL,
	NULL,
	NULL,
	
	bidon_nouveau,
	bidon_liberer,
	bidon_configure,
	bidon_getconfig,
	bidon_get_nom,
	bidon_set_nom,
	NULL,
	NULL,
	bidon_init,

	bidon_status,
	bidon_execute,
	bidon_piloter,

	bidon_nb_voie,
	bidon_get_nom_voie,
	bidon_get_taille_voie,
	bidon_mesure,
	bidon_indices,
	bidon_numero,

	NULL,
	NULL,
	NULL,
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

static void bidon_nouveau(PInstrument **bidon)
{
	*bidon = (PInstrument *)malloc(sizeof(PInstrument));
	memcpy (*bidon, &pilote_bidon, sizeof(PInstrument));
	(*bidon)->structure = malloc(sizeof(infos_pilote));
	((infos_pilote *)(*bidon)->structure)->adresse = 45;
	((infos_pilote *)(*bidon)->structure)->panel_pilotage = 0;
	sprintf(((infos_pilote *)(*bidon)->structure)->nom_pilot, "Pilote bidon");
}

static void bidon_liberer(PInstrument *bidon)
{
	DiscardPanel(((infos_pilote *)bidon->structure)->panel_pilotage);
	free(bidon->structure);
	free(bidon);
}

static void bidon_configure(PInstrument *bidon)
{
	infos_pilote *data = bidon->structure;
	 
	int panel;
	if ((panel = LoadPanel (0, "UIR_bidon_pilote.uir", P_config)) < 0)
		return ;
	SetCtrlVal (panel, P_config_NUMERIC, data->adresse);
	SetCtrlAttribute (panel, P_config_BUTTON_OK, ATTR_CALLBACK_DATA, data);
	DisplayPanel (panel); // Affiche la fentre
}
int CVICALLBACK OK_config (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	int adresse;
	
	infos_pilote *structu_bidon;
	structu_bidon = (infos_pilote *)callbackData;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (panel, P_config_NUMERIC, &adresse);
			
			structu_bidon->adresse = adresse;
			
			DiscardPanel(panel);
			break;
		}
	return 0;
}

static void bidon_getconfig (PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool)
{
	infos_pilote* data = instrument->structure;
	
	*p_strct = (void*)data;
	*p_size = sizeof(infos_pilote);
	
	*p_bool = 1;
	
	return;
}

static void bidon_get_nom (PInstrument *bidon, char *nom_pilot)
{
	memcpy(nom_pilot, ((infos_pilote *)bidon->structure)->nom_pilot, TAILLE_NOM_INSTRU-1);
}

static void bidon_set_nom (PInstrument *bidon, char *nom_pilot)
{
	memcpy(((infos_pilote *)bidon->structure)->nom_pilot, nom_pilot, TAILLE_NOM_INSTRU-1);
	((infos_pilote *)bidon->structure)->nom_pilot[TAILLE_NOM_INSTRU-1] = NULL;
}

static int bidon_status (PInstrument *bidon) // La fonction devrait, dans l'idal, ne pas tre blocante (pour le bon fonctionnement du squenceur)
{
	return STATUS_PRET;
	// return STATUS_OQP;
}

static void bidon_execute (PInstrument *bidon, char *chaine) // La fonction devrait, dans l'idal, ne pas tre blocante (pour le bon fonctionnement du squenceur)
{
	// Interprtation de 'chaine'
	// Envoi vers l'appareil
	// Mise  jour du panel pour le pilotage manuel

	if (!strcmp(chaine, "jour"))
	{
		SetCtrlVal( ((infos_pilote *)bidon->structure)->panel_pilotage, P_PILOT_SW_Soleil, 1);
		SetCtrlVal( ((infos_pilote *)bidon->structure)->panel_pilotage, P_PILOT_LED, 1);
	}
	if (!strcmp(chaine, "nuit"))
	{
		SetCtrlVal( ((infos_pilote *)bidon->structure)->panel_pilotage, P_PILOT_SW_Soleil, 0);
		SetCtrlVal( ((infos_pilote *)bidon->structure)->panel_pilotage, P_PILOT_LED, 0);
	}
	
	return;
}

static int bidon_init (PInstrument *bidon)
{
	// Dtection de l'appareil
	// Configuration
	// ...
	
	// Chargement du panel pour le pilotage manuel (et mmorisation du panel_handle dans la structure)
	if ( ((infos_pilote *)bidon->structure)->panel_pilotage == 0)
		if ( ( ((infos_pilote *)bidon->structure)->panel_pilotage = LoadPanel (0, "UIR_bidon_pilote.uir", P_PILOT)) < 0)
			return -1;
	SetCtrlAttribute ( ((infos_pilote *)bidon->structure)->panel_pilotage,
		P_PILOT_SW_Soleil, ATTR_CALLBACK_DATA, bidon);
	SetCtrlVal( ((infos_pilote *)bidon->structure)->panel_pilotage, P_PILOT_SW_Soleil, 0);
	SetCtrlVal( ((infos_pilote *)bidon->structure)->panel_pilotage, P_PILOT_LED, 0);
	
	return 0; // ngatif = erreur
}

static void bidon_piloter(PInstrument *bidon)
{
	infos_pilote *structu_bidon = bidon->structure;
	DisplayPanel(structu_bidon->panel_pilotage);
}

int CVICALLBACK Cacher_Pilotage (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			HidePanel(panel);
			break;
		}
	return 0;
}

int CVICALLBACK Allumer_Eteindre (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int etat;
	PInstrument *bidon = callbackData;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal( ((infos_pilote *)bidon->structure)->panel_pilotage, P_PILOT_SW_Soleil, &etat);
			SetCtrlVal( ((infos_pilote *)bidon->structure)->panel_pilotage, P_PILOT_LED, etat);
			break;
		}
	return 0;
}


static int bidon_nb_voie(PInstrument *bidon)
{
	return 1;
}

static void bidon_get_nom_voie(PInstrument *bidon, int voie, char *nom_voie)
{
	sprintf(nom_voie, "Voie  la con");
	
	return;
}

static int bidon_get_taille_voie(PInstrument *bidon, int voie)
{
	return 50;
}

static void bidon_mesure(PInstrument *bidon, int voie, double *mesure)
{
	memset(mesure,0,50*sizeof(double));
}

static void bidon_indices(PInstrument *bidon, int voie, double *indices)
{
	int i;
	for(i=0;i<50;i++)
		indices[i] = i+1;
}

static unsigned int bidon_numero(PInstrument *bidon, int voie)
{
	static i = 1;
	// Doit retourner le numero de mesure
	return (i++);
}


