#include <utility.h>
#include <ansi_c.h>
#include <userint.h>
#include <gpib.h>
#include "globales.h"
#include <formatio.h>
#include "bode_hp4194.h"
#include "UIR_hp4194.h"
#include "plugin.h"

PInstrument bode_hp =
{
	NULL, // Rempli par 'nouveau'

	NULL, // rempli aprs nouveau (par liste.c)
	NULL,
	NULL,
	NULL,
	NULL,

	bode_nouveau,
	bode_liberer,
	bode_configure,
	bode_getconfig,
	bode_get_nom,
	bode_set_nom,
	arreter_interruption_bode,
	miseenplace_int_bode,
	bode_init,
	bode_status,
	bode_execute,
	NULL,
	
	bode_nb_voie,
	bode_get_nom_voie,
	bode_get_taille_voie,
	bode_mesure,
	bode_indices,
	bode_numero,

	NULL,
	NULL,
	NULL,
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

int CVICALLBACK BODE_OK (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	infos_bode *structu;
	structu = (infos_bode *)callbackData;

	switch (event)
		{
		case EVENT_COMMIT:

			GetCtrlVal (panel, PANEL_bode_GPIB, &structu->adresse_gpib);
			
			// Integ Time
			GetCtrlVal (panel, PANEL_bode_SWEEP, &structu->sweep);
			GetCtrlVal (panel, PANEL_bode_TRIG, &structu->trig);
			
			// Averaging
			GetCtrlVal (panel, PANEL_bode_MOY, &structu->moy);
			
			// Parameter
			GetCtrlVal (panel, PANEL_bode_REGLAGE, &structu->reglage);
			GetCtrlVal (panel, PANEL_bode_START, &structu->start);
			GetCtrlVal (panel, PANEL_bode_STOP, &structu->stop);
			GetCtrlVal (panel, PANEL_bode_CENTER, &structu->center);
			GetCtrlVal (panel, PANEL_bode_SPAN, &structu->span);
			GetCtrlVal (panel, PANEL_bode_OSCLEV, &structu->osclev);
			
			// Measurement unit
			GetCtrlVal (panel, PANEL_bode_MODE, &structu->mode);
			GetCtrlVal (panel, PANEL_bode_REF_ATT, &structu->ref_att);
			GetCtrlVal (panel, PANEL_bode_REF_IMP, &structu->ref_imp);
			GetCtrlVal (panel, PANEL_bode_TEST_ATT, &structu->test_att);
			GetCtrlVal (panel, PANEL_bode_TEST_IMP, &structu->test_imp);
			
			DiscardPanel (panel); // Dtruit la fentre
			
			break;
		}
	return 0;
}

static int bode_init(PInstrument *bode)
{
	infos_bode *data_osc = bode->structure;
	char chaine[255];
	int err=0, id_cont=0;
	short err_short=0;
	
	err = ibfind("GPIB0");
	if (err & ERR)
	{
		MessagePopup ("Problme de carte", "Carte GPIB non dtecte");
		return -1;
	}
	
	// Dtection d'un instrument  l'adresse indique
	id_cont = ibdev (0, data_osc->adresse_gpib, NO_SAD, T10s, 1, 0);
	ibclr (id_cont);
	ibln (id_cont, data_osc->adresse_gpib, NO_SAD, &err_short); 
	
	ibconfig (id_cont, IbcEOT, 1);
	ibconfig (id_cont, IbcEOSrd, 0);
	ibconfig (id_cont, IbcEOSwrt, 0);
	ibconfig (id_cont, IbcEOScmp, 0);
	ibconfig (id_cont, IbcEOSchar, 0);
	
	if (err_short == 0) 
		{
		sprintf(chaine,"Il faudrait penser  brancher le HP  l'adresse %d !!!",data_osc->adresse_gpib);
		MessagePopup ("PAS BON", chaine);
		return -1;
		}
	
	//ibecr2(id_cont, "*IDN?");
	//chaine[0]=NULL;
	//ibrd(id_cont, chaine, 250);
	//if (strstr (chaine, "TEKTRONIX,TDS 3052") == NULL)
	//{
	//	sprintf(tmp, "Modle (*IDN): %s", chaine);
	//	MessagePopup ("Info", chaine);
	//	MessagePopup ("Erreur", "Modle non support par ce module !");
	//	return -1;
	//}

	// initialisation
	ibecr2(id_cont, "FNC2"); // Gain phase
	ibecr2(id_cont, "GPP1"); // Db - degres
	
	ibecr2(id_cont, "SWP1"); // Sweep sur la frequence
	ibecr2(id_cont, "SWT1"); // Linaire
	ibecr2(id_cont, "SWD1"); // Up
	
	ibecr2(id_cont, "SWM2"); // Single
	
	sprintf(chaine, "ITM%d", data_osc->sweep); ibecr2(id_cont, chaine); // Vitesse balayage
	
	sprintf(chaine, "NOA=%d", data_osc->moy); ibecr2(id_cont, chaine); // Moyennage
	
	if (data_osc->reglage == 1)
	{
		sprintf(chaine, "START=%f;STOP=%f;NOP=401", data_osc->start, data_osc->stop); ibecr2(id_cont, chaine); // Plage de balayage
	}
	else
	{
		sprintf(chaine, "CENTER=%f;SPAN=%f;NOP=401", data_osc->center, data_osc->span); ibecr2(id_cont, chaine); // Plage de balayage
	}
	
	sprintf(chaine, "OSC=%f", data_osc->osclev); ibecr2(id_cont, chaine); // Niveau d'excitation
	
	sprintf(chaine, "PWS%d", data_osc->mode); ibecr2(id_cont, chaine); // Single / Dual
	sprintf(chaine, "ATR%d", data_osc->ref_att); ibecr2(id_cont, chaine); // Attenuation Ref
	sprintf(chaine, "ZIR%d", data_osc->ref_imp); ibecr2(id_cont, chaine); // Impedance Ref
	sprintf(chaine, "ATT%d", data_osc->test_att); ibecr2(id_cont, chaine); // Attenuation Test
	sprintf(chaine, "ZIT%d", data_osc->test_imp); ibecr2(id_cont, chaine); // Impedance Ref
	
	ibecr2(id_cont, "FMT2"); // Transfert en binaire (double)
	
	// Mise  jour des donnes de la structure.
	data_osc->identificateur = id_cont;
	data_osc->stop_interruption = RQS; 
	data_osc->numero_mesure = 0;
	
	return err;
}

/* Fonction de mise en place de l'interruption Renvoit CMPL (0x0100) en cas de succs.*/
static int miseenplace_int_bode(PInstrument *bode)
{
	infos_bode *data_osc = bode->structure;
	int err=0;
	char chaine[255];
	
	// Activation de l'interruption  la fin du sweep sur le HP
	if ((err = ibecr2 (data_osc->identificateur, "RQS2")) & ERR) // Activation
	{
		sprintf(chaine,"Impossible d'initialiser l'interruption (bode)");
		MessagePopup("Attention !!!",chaine);
		return err;
	}

	// Mise en place de l'interruption
	err = ibnotify (data_osc->identificateur, data_osc->stop_interruption, CB_interruption_bode, bode);
	if (err & ERR)
	{
		sprintf(chaine,"Impossible d'initialiser le HP");
		MessagePopup("Attention !!!",chaine);
		return -1;
	}
	
	// lancement d'une mesure
	if ((err = ibecr2 (data_osc->identificateur, "SWTRG"))& ERR) // dclenchement immdiat
	{
		sprintf(chaine,"Impossible de lancer une mesure");
		MessagePopup("Attention !!!",chaine);
		ibnotify (data_osc->identificateur, 0, CB_interruption_bode, NULL); //Dsactivation de l'interruption
		return err;
	}
	return err;
}
	

int __stdcall CB_interruption_bode(int boardOrDevice, int localsta, int localerr, long localcntl, void *callbackData)
{
	infos_bode *data_osc;
	PInstrument *bode;
	
	char chaine[256], srq_resp = 0;
	int err, iter, lock;
	
	switch (localsta)
	{
		case ERR:
			return 0;
		default:
			
			bode = (PInstrument *)callbackData;
			data_osc = bode->structure;
			
			sprintf(chaine, "GPIB0:%i", data_osc->adresse_gpib);
			lock = bode->gestion_lock(chaine);
			CmtGetLock(lock);
			
			iter=0;
			do
			{
				iter++;
				err = ibrsp (boardOrDevice, &srq_resp);
			} while ( (iter < 100) && (err & RQS) );
			
			if (iter == 100)
			{
				ibecr2 (boardOrDevice, "STB?");
				ibrd(boardOrDevice, chaine, 200);
			}
			
			data_osc->numero_mesure++;
			
			// void SwapEndian(void *Dest, void* Addr, const int Nb);
			
			// Gain
			recup_curve(boardOrDevice, "A", data_osc->mesures[0]);
			
			// Phase
			recup_curve(boardOrDevice, "B", data_osc->mesures[1]);
			
			// Frquence
			recup_curve(boardOrDevice, "X", data_osc->indices);
			
			// relancement d'une mesure si mode repeat
			if (data_osc->trig == 1) ibecr2 (boardOrDevice, "SWTRG"); // dclenchement immdiat
	
			CmtReleaseLock(lock);
			
			return data_osc->stop_interruption; // Pour ractiver l'interruption
	}
}

static void recup_curve(int device, char *channel, double *tabdou)
{
	unsigned short nbbyte;
	char chaine[50];
	double tabreg[401];
	int cpt_point;
	unsigned short short1;
	
	sprintf(chaine, "%s?", channel);
	ibecr2(device, chaine);
	
	ibrd(device, chaine, strlen("#A"));
	
	ibrd(device, &short1, 2); // Nombre d'octets a lire (data)
	SwapEndian(&nbbyte, &short1, 2);
	
	ibrd(device, tabreg, nbbyte); // Data
	
	ibrd(device, chaine, 2); // CR/LF
	
	for (cpt_point = 0; cpt_point<(nbbyte)/8; cpt_point++)
		SwapEndian(&tabdou[cpt_point], &tabreg[cpt_point], sizeof(double));
}

static void arreter_interruption_bode(PInstrument *bode)
{
	infos_bode *data = bode->structure;
	
	if (data->stop_interruption == 0) // dj arrt
		return;
		
	//dsactivation de l'interruption
	data->stop_interruption = 0;
	
	//libration de l'identificateur
	//ibonl (data->identificateur, 0);
}

static void bode_nouveau(PInstrument **plugin)
{
	*plugin = (PInstrument *)malloc(sizeof(PInstrument));
	memcpy (*plugin, &bode_hp, sizeof(PInstrument));
	(*plugin)->structure = malloc(sizeof(infos_bode));
	((infos_bode *)(*plugin)->structure)->adresse_gpib = 23;
	((infos_bode *)(*plugin)->structure)->start = 1E3;
	((infos_bode *)(*plugin)->structure)->stop = 100E3;
	((infos_bode *)(*plugin)->structure)->center = 10E3;
	((infos_bode *)(*plugin)->structure)->span = 1E3;
	((infos_bode *)(*plugin)->structure)->osclev = 1;
	sprintf(((infos_bode *)(*plugin)->structure)->nom_instru, "Analyseur Gain-Phase");
}

static void bode_liberer(PInstrument *plugin)
{
	free(plugin->structure);
	free(plugin);
}

static void bode_get_nom(PInstrument *bode, char *nom_instru)
{
	memcpy(nom_instru, ((infos_bode *)bode->structure)->nom_instru, TAILLE_NOM_INSTRU-1);
}

static void bode_set_nom(PInstrument *bode, char *nom_instru)
{
	memcpy(((infos_bode *)bode->structure)->nom_instru, nom_instru, TAILLE_NOM_INSTRU-1);
	((infos_bode *)bode->structure)->nom_instru[TAILLE_NOM_INSTRU-1] = NULL;
}

static void bode_configure(PInstrument *bode)
{
	infos_bode *structu = bode->structure;
	int panel;
	if ((panel = LoadPanel (0, "UIR_hp4194.uir", PANEL_bode)) < 0)
		return ;
	
	
	SetCtrlVal (panel, PANEL_bode_GPIB, structu->adresse_gpib);
	
	// Integ Time
	SetCtrlVal (panel, PANEL_bode_SWEEP, structu->sweep);
	SetCtrlVal (panel, PANEL_bode_TRIG, structu->trig);
	
	// Averaging
	SetCtrlVal (panel, PANEL_bode_MOY, structu->moy);
	
	// Parameter
	SetCtrlVal (panel, PANEL_bode_REGLAGE, structu->reglage);
	SetCtrlVal (panel, PANEL_bode_START, structu->start);
	SetCtrlVal (panel, PANEL_bode_STOP, structu->stop);
	SetCtrlVal (panel, PANEL_bode_CENTER, structu->center);
	SetCtrlVal (panel, PANEL_bode_SPAN, structu->span);
	SetCtrlVal (panel, PANEL_bode_OSCLEV, structu->osclev);
	
	// Measurement unit
	SetCtrlVal (panel, PANEL_bode_MODE, structu->mode);
	SetCtrlVal (panel, PANEL_bode_REF_ATT, structu->ref_att);
	SetCtrlVal (panel, PANEL_bode_REF_IMP, structu->ref_imp);
	SetCtrlVal (panel, PANEL_bode_TEST_ATT, structu->test_att);
	SetCtrlVal (panel, PANEL_bode_TEST_IMP, structu->test_imp);
	
	SetCtrlAttribute (panel, PANEL_bode_COMMANDBUTTON_OK, ATTR_CALLBACK_DATA, structu);
	
	DisplayPanel (panel);
}

static void bode_getconfig(PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool)
{
	infos_bode *data = instrument->structure;

	*p_strct = (void*)data;
	*p_member = (void*)&(data->mesures);
	
	*p_bool = 0;
}

static int bode_nb_voie(PInstrument *bode)
{
	return 2;
}

static void bode_get_nom_voie(PInstrument *plugin, int voie, char *nom_voie)
{
	nom_voie[0] = NULL;
	switch(voie)
	{
		case 1:
			sprintf(nom_voie, "Gain");
			break;
		case 2:
			sprintf(nom_voie, "Phase");
			break;
	}
}

static int bode_get_taille_voie(PInstrument *plugin, int voie)
{
	//infos_bode *data_osc = plugin->structure;
	return 401;
}

static void bode_mesure(PInstrument *plugin, int voie, double *mesure)
{
	infos_bode *data_osc = plugin->structure;
	memcpy(mesure, data_osc->mesures[voie-1], 401 * sizeof(double));
}

static void bode_indices(PInstrument *plugin, int voie, double *indices)
{
	infos_bode *data_osc = plugin->structure;
	memcpy(indices, data_osc->indices, 401 * sizeof(double));
}

static unsigned int bode_numero(PInstrument *plugin, int voie)
{
	infos_bode *data = plugin->structure;
	return data->numero_mesure;
}

static int bode_status (PInstrument *plugin) // La fonction devrait, dans l'idal, ne pas tre blocante (pour le bon fonctionnement du squenceur)
{
	infos_bode *data = plugin->structure;
	return data->status;
	// return STATUS_PRET;
	// return STATUS_OQP;
}

static void bode_execute (PInstrument *plugin, char *chaine) // La fonction devrait, dans l'idal, ne pas tre blocante (pour le bon fonctionnement du squenceur)
{
	// Interprtation de 'chaine'
	// Envoi vers l'appareil

	char tmp[255];
	int lock;
	double valeur = 0;
	
	infos_bode *data = plugin->structure;
	data->status = STATUS_OQP;
	
	sprintf(tmp, "GPIB0:%i", data->adresse_gpib);
	lock = plugin->gestion_lock(tmp);
	CmtGetLock(lock); // Pour ne pas parler  l'appareil en mme temps que l'interruption.

	strcpy(tmp, chaine);
	StringUpperCase (tmp);
	
	// center
	if (sscanf(tmp, "CENTER=%lf", &valeur) == 1)
	{
		ibecr2(data->identificateur, tmp);
	}
	else
	// span
	if (sscanf(tmp, "SPAN=%lf", &valeur) == 1)
	{
		ibecr2(data->identificateur, tmp);
	}
	else
	// start
	if (sscanf(tmp, "START=%lf", &valeur) == 1)
	{
		ibecr2(data->identificateur, tmp);
	}
	else
	// stop
	if (sscanf(tmp, "STOP=%lf", &valeur) == 1)
	{
		ibecr2(data->identificateur, tmp);
	}
	else
	// nop
	if (sscanf(tmp, "NOP=%lf", &valeur) == 1)
	{
		ibecr2(data->identificateur, tmp);
	}
	else
	// osc
	if (sscanf(tmp, "OSC=%lf", &valeur) == 1)
	{
		ibecr2(data->identificateur, tmp);
	}
	else
	// trig
	if (!strcmp(tmp, "TRIG"))
	{
		ibecr2(data->identificateur, "SWTRG");
	}
	else
	// sweep up
	if (!strcmp(tmp, "SWEEP_UP"))
	{
		ibecr2(data->identificateur, "SWD1");
	}
	else
	// sweep down
	if (!strcmp(tmp, "SWEEP_DOWN"))
	{
		ibecr2(data->identificateur, "SWD2");
	}

	CmtReleaseLock(lock);
	
	data->status = STATUS_PRET;
	return;
}
