#include "plugin.h"

typedef struct	
{
	int adresse_gpib;
	int identificateur;
	int stop_interruption;
	int numero_mesure;
	
	char nom_instru[128];
	
	int mode;
	int sweep;
	int trig;
	int moy;
	int reglage;
	double start;
	double stop;
	double center;
	double span;
	double osclev;
	int ref_att;
	int ref_imp;
	int test_att;
	int test_imp;
	
	int status;
	
	// Zone  ne pas sauvegarder

	double mesures[2][401];
	double indices[401];
	
	
} infos_bode;

int __stdcall CB_interruption_bode(int boardOrDevice, int localsta, int localerr, long localcntl, void *callbackData);

static void recup_curve(int device, char *channel, double *tabdou);

static int bode_init(PInstrument *bode);
static int miseenplace_int_bode(PInstrument *bode);
static void arreter_interruption_bode(PInstrument *bode);
static void bode_nouveau(PInstrument **bode);
static void bode_liberer(PInstrument *bode);
static void bode_get_nom(PInstrument *bode, char *nom_instru);
static void bode_set_nom(PInstrument *bode, char *nom_instru);
static void bode_configure(PInstrument *bode);
static void bode_getconfig(PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool);
static int bode_nb_voie(PInstrument *bode);
static void bode_get_nom_voie(PInstrument *plugin, int voie, char *nom_voie);
static int bode_get_taille_voie(PInstrument *plugin, int voie);
static void bode_mesure(PInstrument *plugin, int voie, double *mesure);
static void bode_indices(PInstrument *plugin, int voie, double *indices);
static unsigned int bode_numero(PInstrument *plugin, int voie);
static int bode_status (PInstrument *plugin);
static void bode_execute (PInstrument *plugin, char *chaine);
