#include <analysis.h>
#include <userint.h>
#include <ansi_c.h>
#include "plugin.h"
#include "calcul_moy_stddev.h"
#include <utility.h>
#include "UIR_calcul_moy_stddev.h"

PInstrument calcul_moy_stddev =
{
	NULL, // rempli par nouveau
	
	NULL, // rempli aprs nouveau (par liste.c)
	NULL,
	NULL,
	NULL,
	NULL,

	stddev_nouveau,
	stddev_liberer,
	stddev_configure,
	stddev_get_config,
	stddev_get_nom,
	stddev_set_nom,
	NULL,
	NULL,
	stddev_init,
	NULL, // status
	NULL, // execute
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,

	stddev_nb_voie,
	stddev_get_nom_voie,
	stddev_mesure,
	stddev_calculer,

	NULL,
	NULL,
	NULL,
	NULL,
	
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

static void stddev_nouveau (PInstrument **stddev)
{
	*stddev = (PInstrument *)malloc(sizeof(PInstrument));
	memcpy (*stddev, &calcul_moy_stddev, sizeof(PInstrument));
	(*stddev)->structure = malloc(sizeof(infos_stddev));
	sprintf(((infos_stddev *)(*stddev)->structure)->nom_pilot, "Calcul moyenne et ecart-type");
	// total: 3 malloc
	
	((infos_stddev *)(*stddev)->structure)->taille_median = 3;
}

static void stddev_liberer (PInstrument *stddev)
{
	free(stddev->structure);
	free(stddev);
	// total: 3 free
}

static void stddev_configure (PInstrument *stddev)
{
	infos_stddev *data = stddev->structure;

	int panel;
	if ((panel = LoadPanel (0, "UIR_calcul_moy_stddev.uir", P_config)) < 0)
		return ;
	SetCtrlAttribute (panel, P_config_COMMANDBUTTON, ATTR_CALLBACK_DATA, data);
	stddev->init_liste_voie(panel, P_config_RING);
	SetCtrlVal(panel, P_config_RING, data->tatoo_voie);
	SetCtrlVal(panel, P_config_MEDIAN, data->taille_median);
	DisplayPanel (panel); // Affiche la fentre
}

static void stddev_get_config (PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool)
{
	infos_stddev* data = instrument->structure;
	
	*p_strct = (void*)data;
	*p_size = sizeof(infos_stddev);
	
	*p_bool = 1;
}

static int stddev_nb_voie (PInstrument *instrument)
{
	return 3;
}

static void stddev_get_nom_voie (PInstrument *instrument, int voie, char *nom_voie)
{
	switch (voie)
	{
		case 1:
			sprintf(nom_voie, "Moyenne");
			break;
		case 2:
			sprintf(nom_voie, "Ecart-type");
			break;
		case 3:
			sprintf(nom_voie, "Median");
			break;
	}
}

static void stddev_get_nom (PInstrument *stddev, char *nom_instru)
{
	infos_stddev *structu_stddev;
	structu_stddev = stddev->structure;
	memcpy(nom_instru, ((infos_stddev *)stddev->structure)->nom_pilot, TAILLE_NOM_INSTRU-1);
}

static void stddev_set_nom (PInstrument *stddev, char *nom_instru)
{
	memcpy(((infos_stddev *)stddev->structure)->nom_pilot, nom_instru, TAILLE_NOM_INSTRU-1);
	((infos_stddev *)stddev->structure)->nom_pilot[TAILLE_NOM_INSTRU-1] = NULL;
}

static double stddev_mesure (PInstrument *instrument, int voie)
{
	infos_stddev *structu_stddev;
	structu_stddev = instrument->structure;

	switch (voie)
	{
		case 1:
			return structu_stddev->moyenne;
		case 2:
			return structu_stddev->stddev;
		case 3:
			return structu_stddev->median;
	}
	return 0;
}

static void stddev_calculer (PInstrument *instrument)//, ptr_buff_circu *buffer_circu, ptr_buff2D_circu *buffer2D_circu)
{
	int boucle_indice, indice_ok, position;
	double moyenne = 0, stddev = 0, median=0;
	infos_stddev *structu_stddev;
	ptr_buff_circu *buffer;
	double mini_buf[30];

	structu_stddev = instrument->structure;
	
	buffer = instrument->get_buffer_from_tatoo(structu_stddev->tatoo_voie);
	if (buffer == NULL) return;
	
	position = 0;
	for (boucle_indice=buffer->dernier_indice-30+1; boucle_indice<=buffer->dernier_indice; boucle_indice++)
	{
		indice_ok = boucle_indice;
		if (indice_ok<0)
			indice_ok += buffer->profondeur;
		mini_buf[29-position] = buffer->mesure[indice_ok];
		position++;
	}

	Median(mini_buf, structu_stddev->taille_median, &median);
	StdDev (mini_buf, 30, &moyenne, &stddev);
	
	
	
/*	for (boucle_indice=buffer->dernier_indice-30+1; boucle_indice<=buffer->dernier_indice; boucle_indice++)
	{
		indice_ok = boucle_indice;
		if (indice_ok<0)
			indice_ok += buffer->profondeur;
		moyenne += buffer->mesure[indice_ok];
	}
	moyenne /= 30;
	
	for (boucle_indice=buffer->dernier_indice-30+1; boucle_indice<=buffer->dernier_indice; boucle_indice++)
	{
		indice_ok = boucle_indice;
		if (indice_ok<0)
			indice_ok += buffer->profondeur;
		stddev += pow(buffer->mesure[indice_ok]-moyenne, 2);
	}
	stddev /= 30;
	stddev = sqrt(stddev);	  */
	
	structu_stddev->moyenne = moyenne;
	structu_stddev->stddev = stddev;
	structu_stddev->median = median;
	return;
}

static int stddev_init (PInstrument *instrument)
{
	return 0; // negatif = erreur
}

int CVICALLBACK OK_config_calcul_stddev (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	infos_stddev *structu_stddev;
	structu_stddev = (infos_stddev *)callbackData;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal(panel, P_config_RING, structu_stddev->tatoo_voie);
			GetCtrlVal(panel, P_config_MEDIAN, &structu_stddev->taille_median);
			
			DiscardPanel(panel);
			break;
		}
	return 0;
}
