/* CRED.h
Contient les dclarations spcifiques au fonctionnement de la carte du CRED
*/

#include "plugin.h"

#ifndef CRED_H
#define CRED_H

typedef struct	
{

	int port_com; 
	int temps_echantillonnage;
	int nombre_voie;
	char nom_instru[128];

	// Zone  ne pas sauvegarder

	unsigned int numero_mesure[4];
	double zone_memoire[4];
	
}infos_cred;



#ifdef CRED_TYPES
	//  les types ont t dfinis plus tt ne pas les redfinir
#else
#define CRED_TYPES

#define ETX 3
#define ACK 4
#define CR 13
#define VALID_PC '7'		//valeur envoye par HC11 quand le pc est valid
#define VALID_TE '8'		//valeur envoye par HC11 quand Il est pret a recevoir Te   

extern char buffer[140];

struct voie
{	signed char	num_voie;
	signed char	temp_consigne;
	short 		Te;
	short 		coef2;
	short 		coef3;
}; 


struct data
{	//signed char	epsilon_1;
	//signed char	epsilon_2;
	short	epsilon_1;   //Modif Padding le 03/09/03
	short	epsilon_2;
	int		freq_1;
	int		freq_2;
	int		freq_3;
	int		freq_4;
};

#define NBR_BYTE_VOIE sizeof(struct voie)
#define NBR_BYTE_DONNEES sizeof(struct data)

union voie_n
{
	struct voie	data;
	char		bytes[NBR_BYTE_VOIE];
};
union data_mesure
{
	struct data valeur ;
	unsigned char		bytes[NBR_BYTE_DONNEES];
};

void CRED_inversion_short_mesures(char*);
void CRED_inversion_short_pwm(char*);
void CRED_inversion_entier(char*);   
void CRED_requete(infos_cred *data_cred) ;
void CRED_RS232_en_attente(infos_cred *data_cred);
void Transformation_donnees_carte_cred(char Transformation[255],infos_cred *data_cred);

//int CRED_initialisation(infos_cred *data_cred);
void CVICALLBACK CRED_comint(int COMPort, int eventMask, void *callbackData);
//int CRED_arreter_comint(infos_cred *data_cred);

static void cred_nouveau(PInstrument **cred);
static void cred_liberer(PInstrument *instru);
static void cred_get_nom(PInstrument *instrument, char *nom_instru);
static void cred_set_nom(PInstrument *instrument, char *nom_instru);
static void cred_configure(PInstrument *cred);
static void cred_getconfig(PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool);
static int cred_nb_voie(PInstrument *cred);
static void cred_get_nom_voie(PInstrument *cred, int voie, char *nom_voie);
static double cred_mesure(PInstrument *cred, int voie);
static unsigned int cred_numero(PInstrument *cred, int voie);
static int cred_digits(PInstrument *cred);

static void CRED_arreter_comint(PInstrument *cred);
int CRED_initialisation(PInstrument *cred);
#endif

#endif
