#include <userint.h>
#include <ansi_c.h>
#include "plugin.h"
#include "extremum.h"
#include <utility.h>
#include "UIR_extremum.h"

PInstrument calcul_extremum =
{
	NULL, // rempli par nouveau
	
	NULL, // rempli aprs nouveau (par liste.c)
	NULL,
	NULL,
	NULL,
	NULL,

	extremum_nouveau,
	extremum_liberer,
	extremum_configure,
	extremum_get_config,
	extremum_get_nom,
	extremum_set_nom,
	NULL,
	NULL,
	extremum_init,
	NULL, // status
	NULL, // execute
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,

	extremum_nb_voie,
	extremum_get_nom_voie,
	extremum_mesure,
	extremum_calculer,

	NULL,
	NULL,
	NULL,
	NULL,
	
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

static void extremum_nouveau (PInstrument **extremum)
{
	*extremum = (PInstrument *)malloc(sizeof(PInstrument));
	memcpy (*extremum, &calcul_extremum, sizeof(PInstrument));
	(*extremum)->structure = malloc(sizeof(infos_extremum));
	sprintf(((infos_extremum *)(*extremum)->structure)->nom_pilot, "Calcul extremum");
	// total: 3 malloc
}

static void extremum_liberer (PInstrument *extremum)
{
	free(extremum->structure);
	free(extremum);
	// total: 3 free
}

static void extremum_configure (PInstrument *extremum)
{
	infos_extremum *data = extremum->structure;

	int panel;
	if ((panel = LoadPanel (0, "UIR_extremum.uir", P_config)) < 0)
		return ;
	SetCtrlAttribute (panel, P_config_COMMANDBUTTON, ATTR_CALLBACK_DATA, data);
	extremum->init_liste_voie2D(panel, P_config_RING);
	SetCtrlVal(panel, P_config_RING, data->tatoo_voie);
	SetCtrlVal(panel, P_config_TYPE, data->type);
	SetCtrlVal(panel, P_config_T_EXTREM, data->type_extrem);
	DisplayPanel (panel); // Affiche la fentre
}

static void extremum_get_config (PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool)
{
	infos_extremum* data = instrument->structure;
	
	*p_strct = (void*)data;
	*p_size = sizeof(infos_extremum);
	
	*p_bool = 1;
}

static int extremum_nb_voie (PInstrument *instrument)
{
	return 1;
}

static void extremum_get_nom_voie (PInstrument *instrument, int voie, char *nom_voie)
{
	sprintf(nom_voie, "Voie 1");
}

static void extremum_get_nom (PInstrument *extremum, char *nom_instru)
{
	memcpy(nom_instru, ((infos_extremum *)extremum->structure)->nom_pilot, TAILLE_NOM_INSTRU-1);
}

static void extremum_set_nom (PInstrument *extremum, char *nom_instru)
{
	memcpy(((infos_extremum *)extremum->structure)->nom_pilot, nom_instru, TAILLE_NOM_INSTRU-1);
	((infos_extremum *)extremum->structure)->nom_pilot[TAILLE_NOM_INSTRU-1] = NULL;
}

static double extremum_mesure (PInstrument *instrument, int voie)
{
	return ((infos_extremum *)instrument->structure)->mesure;
}

static void extremum_calculer (PInstrument *instrument)//, ptr_buff_circu *buffer_circu, ptr_buff2D_circu *buffer2D_circu)
{
	int cpt;
	infos_extremum *data;
	double valeur, indice_pour_max, val_tab, indice_pour_max_tab;
	ptr_buff2D_circu *buffer;
	
	data = instrument->structure;
	
	buffer = instrument->get_buffer2D_from_tatoo(data->tatoo_voie);
	if (buffer == NULL) return;
	
	valeur = buffer->mesure[buffer->dernier_indice][0];
	indice_pour_max = buffer->indices[buffer->dernier_indice][0];
	
	for (cpt=0; cpt<buffer->taille_voie; cpt++)
	{
		val_tab = buffer->mesure[buffer->dernier_indice][cpt];
		indice_pour_max_tab = buffer->indices[buffer->dernier_indice][cpt];
	
		if (data->type == 0) // Minimum
		{
			if (val_tab < valeur)
			{
				valeur = val_tab;
				indice_pour_max = indice_pour_max_tab;
			}
		}
		else // Maximum
		{
			if (val_tab > valeur)
			{
				valeur = val_tab;
				indice_pour_max = indice_pour_max_tab;
			}
		}
	}
	
	if (data->type_extrem == 0)
	{
		data->mesure = valeur;
	}
	else
	{
		data->mesure = indice_pour_max;
	}
	return;
}

static int extremum_init (PInstrument *instrument)
{
	return 0; // negatif = erreur
}

int CVICALLBACK OK_config_calcul_extremum (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	infos_extremum *structu_extremum;
	structu_extremum = (infos_extremum *)callbackData;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal(panel, P_config_RING, structu_extremum->tatoo_voie);
			GetCtrlVal(panel, P_config_TYPE, &structu_extremum->type);
			GetCtrlVal(panel, P_config_T_EXTREM, &structu_extremum->type_extrem);
			
			DiscardPanel(panel);
			break;
		}
	return 0;
}
