#include <analysis.h>
#include <ansi_c.h>
#include <userint.h>
#include <utility.h>
#include "UIR_fitter.h"
#include "plugin.h"
#include "fitter.h"
#include <matheval.h>

infos_fitter *g_fitter; // c'est merdique, mais ya pas moyen sans ca

PInstrument fitter =
{
	NULL, // Rempli par 'nouveau'
	
	NULL, // rempli aprs nouveau (par liste.c)
	NULL,
	NULL,
	NULL,
	NULL,
	
	fitter_nouveau,
	fitter_liberer,
	fitter_configure,
	fitter_getconfig,
	fitter_get_nom,
	fitter_set_nom,
	fitter_stop, // stop
	fitter_start, // start
	NULL, // init
	NULL,
	NULL,
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,

	fitter_nb_voie_calcul,
	fitter_get_nom_voie_calcul,
	fitter_mesure_calcul,
	fitter_calculer_1D,

	NULL,
	NULL,
	NULL,
	NULL,
	
	fitter_nbvoie,
	fitter_get_nom_voie,
	fitter_taille_voie,
	fitter_resultat,
	fitter_indices,
	fitter_calculer
};

int CVICALLBACK OK_fit (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	infos_fitter *structu;
	structu = (infos_fitter *)callbackData;
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (panel,P_config_STRING_1  , structu->nom_param1);
			GetCtrlVal (panel,P_config_RING_1    , structu->tatoo_param1); 
			GetCtrlVal (panel,P_config_NUMERIC_1 , &structu->param1); 
			GetCtrlVal (panel,P_config_STRING_2  , structu->nom_param2);
			GetCtrlVal (panel,P_config_RING_2    , structu->tatoo_param2); 
			GetCtrlVal (panel,P_config_NUMERIC_2 , &structu->param2);
			GetCtrlVal (panel,P_config_STRING_3  , structu->nom_param3);
			GetCtrlVal (panel,P_config_RING_3    , structu->tatoo_param3); 
			GetCtrlVal (panel,P_config_NUMERIC_3 , &structu->param3); 
			GetCtrlVal (panel,P_config_STRING_4  , structu->nom_param4);
			GetCtrlVal (panel,P_config_RING_4    , structu->tatoo_param4); 
			GetCtrlVal (panel,P_config_NUMERIC_4 , &structu->param4);

			GetCtrlVal (panel,P_config_RING  , structu->tatoo_voie_fit);
			GetCtrlVal (panel,P_config_STRING    , structu->fonction); 
			GetCtrlVal (panel,P_config_STRING_0 , structu->nom_inconnue);

			DiscardPanel (panel); 

			break;
		}
	return 0;
}

static void fitter_nouveau(struct PInstrument **instrument)
{
	infos_fitter *i_fitter;
	*instrument = (PInstrument *)malloc(sizeof(PInstrument));
	
	memcpy (*instrument, &fitter, sizeof(PInstrument));
	(*instrument)->structure = malloc(sizeof(infos_fitter));

	i_fitter = (*instrument)->structure;

	sprintf(i_fitter->tatoo_voie_fit, "");
	sprintf(i_fitter->fonction, "a*x^2+b*x+c");
	sprintf(i_fitter->nom_inconnue, "x");
	
	sprintf(i_fitter->nom_param1, "a");
	sprintf(i_fitter->tatoo_param1, "");
	i_fitter->param1 = 1.337;

	sprintf(i_fitter->nom_param2, "b");
	sprintf(i_fitter->tatoo_param2, "");
	i_fitter->param2 = 5.6;

	sprintf(i_fitter->nom_param3, "c");
	sprintf(i_fitter->tatoo_param3, "");
	i_fitter->param3=0;

	sprintf(i_fitter->nom_param4, "d");
	sprintf(i_fitter->tatoo_param4, "");
	i_fitter->param4=0;

	i_fitter->calculs = NULL;
	i_fitter->indices = NULL;
	i_fitter->taille_voie = 0; // non initialis
	i_fitter->num_var = 0;
	
	i_fitter->f = NULL;

	sprintf(i_fitter->nom_instru, "Fitter de courbes");
}

static void fitter_liberer(struct PInstrument *instrument)
{
	free(instrument->structure);
	free(instrument);
}

static void fitter_configure(struct PInstrument *instrument)
{
	infos_fitter *structu = instrument->structure;
	int panel;
	if ((panel = LoadPanel (0, "UIR_fitter.uir", P_config)) < 0)
		return ;
	
	instrument->init_liste_voie2D(panel, P_config_RING);
	
	instrument->init_liste_voie(panel, P_config_RING_1);
	instrument->init_liste_voie(panel, P_config_RING_2);
	instrument->init_liste_voie(panel, P_config_RING_3);
	instrument->init_liste_voie(panel, P_config_RING_4);
	
	SetCtrlVal (panel,P_config_STRING_1  , structu->nom_param1);
	SetCtrlVal (panel,P_config_RING_1    , structu->tatoo_param1); 
	SetCtrlVal (panel,P_config_NUMERIC_1 , structu->param1); 
	SetCtrlVal (panel,P_config_STRING_2  , structu->nom_param2);
	SetCtrlVal (panel,P_config_RING_2    , structu->tatoo_param2); 
	SetCtrlVal (panel,P_config_NUMERIC_2 , structu->param2);
	SetCtrlVal (panel,P_config_STRING_3  , structu->nom_param3);
	SetCtrlVal (panel,P_config_RING_3    , structu->tatoo_param3); 
	SetCtrlVal (panel,P_config_NUMERIC_3 , structu->param3); 
	SetCtrlVal (panel,P_config_STRING_4  , structu->nom_param4);
	SetCtrlVal (panel,P_config_RING_4    , structu->tatoo_param4); 
	SetCtrlVal (panel,P_config_NUMERIC_4 , structu->param4);

	SetCtrlVal (panel,P_config_STRING_0  , structu->nom_inconnue); 
	SetCtrlVal (panel,P_config_RING      , structu->tatoo_voie_fit);
	SetCtrlVal (panel,P_config_STRING    , structu->fonction); 
	
	SetCtrlAttribute (panel, P_config_OK_BUTTON, ATTR_CALLBACK_DATA, structu);
	
	DisplayPanel (panel);
}

static void fitter_getconfig(PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool)
{
	infos_fitter *data = instrument->structure;
	
	*p_strct = (void*)data;
	*p_member = (void*)&(data->calculs);
	
	*p_bool = 0;
	
	return;
}

static void fitter_get_nom(PInstrument *instrument, char *nom_instru)
{
	memcpy(nom_instru, ((infos_fitter *)instrument->structure)->nom_instru, TAILLE_NOM_INSTRU-1);
}

static void fitter_set_nom(PInstrument *instrument, char *nom_instru)
{
	memcpy(((infos_fitter *)instrument->structure)->nom_instru, nom_instru, TAILLE_NOM_INSTRU-1);
	((infos_fitter *)instrument->structure)->nom_instru[TAILLE_NOM_INSTRU-1] = NULL;
}

static void fitter_stop(struct PInstrument *instrument)
{
	infos_fitter *i_fitter = instrument->structure;
	if( i_fitter->f ) evaluator_destroy (i_fitter->f);
	if (i_fitter->indices)
		free(i_fitter->indices);
	i_fitter->indices = NULL;
	if (i_fitter->calculs)
		free(i_fitter->calculs);
	i_fitter->calculs = NULL;
	//free(i_fitter->vars);
}

static int fitter_start(struct PInstrument *instrument)
{
	infos_fitter *i_fitter = instrument->structure;
	
	// On va mettre a jour les champs qui dependent de l'instrument qui sert de base au fit
	if( !(i_fitter->buffer = instrument->get_buffer2D_from_tatoo(i_fitter->tatoo_voie_fit)) )
		return 0x8000;
		
	// le buffer n'est pas initialis  cet instant l !
	
	// TODO: ca va chier si on fit un calcul !!!
	i_fitter->taille_voie = ((PInstrument*)(i_fitter->buffer->instrument))->get_taille_voie2D(i_fitter->buffer->instrument, i_fitter->buffer->voie);
	
	i_fitter->indices = malloc(i_fitter->taille_voie * sizeof(double));
	i_fitter->calculs = malloc(i_fitter->taille_voie * sizeof(double));

	/* Create evaluator for function.  */
	i_fitter->f = evaluator_create (i_fitter->fonction);
	if (i_fitter->f == NULL) return 0x8000;
	
	/* Get variable names appearing in function. */
	evaluator_get_variables (i_fitter->f, &i_fitter->vars, &i_fitter->num_var);
	i_fitter->num_var--; // faut pas compter l'inconnue
	
	/*for (i = 0; i < count; i++)
	{
		sprintf (chaine, "%s ", names[i]);
		InsertTextBoxLine (panelCommande, P_Commande_STATUS, -1, chaine);
	} */
	
	// TODO: on pourrait vrifier que ya pas de soucis au niveau variables (paramtres existants)
	/*for (i=0;i<i_fitter->num_var;i++)
	{
		for (j=0; j<i_fitter->num_var;j++)
		{
			if (strcmp(i_fitter->variables[j],i_fitter->vars[i])==0) // on cherche parmi les variables de l'equation a quel parametre ca correspond (de 1 a 3)
			{
				i_fitter->valeurs[i] = parm[j];
				next; // c'est bon, trouv, on passe  la prochaine variable
			}
		}
	}*/

	strcpy(i_fitter->variables[0], i_fitter->nom_param1);
	strcpy(i_fitter->variables[1], i_fitter->nom_param2);
	strcpy(i_fitter->variables[2], i_fitter->nom_param3);
	strcpy(i_fitter->variables[3], i_fitter->nom_param4);
	strcpy(i_fitter->variables[i_fitter->num_var], i_fitter->nom_inconnue);
	
	return 0; // pas de soucis
}

static int fitter_nb_voie_calcul (struct PInstrument *instrument)
{
	infos_fitter *i_fitter = instrument->structure;
	//return i_fitter->num_var; // c'est pas grave si avant le start on dit 0 voies
	return 4; // c'est quand meme mieux de dire 3 (mais faudrait analyser l'expression idealement: TODO)
}

static void fitter_get_nom_voie_calcul (struct PInstrument *instrument, int voie, char *nom_voie)
{
	sprintf(nom_voie, "Voie %i", voie); // TODO peut mieux faire
}

static double fitter_mesure_calcul (struct PInstrument *instrument, int voie)
{
	infos_fitter *i_fitter = instrument->structure;
	if ( (voie>=0) && (voie<5)) // Prcaution
		return i_fitter->valeurs[voie-1];
	else
		return 0;
}

static void fitter_calculer_1D (struct PInstrument *instrument)
{
	return; // le calcul se fait avec fitter_calculer_2D, donc pas besoin de faire kkch ici
}

static int fitter_nbvoie(struct PInstrument *instrument)
{
	return 1;
}

static void fitter_get_nom_voie(struct PInstrument *instrument, int voie, char *nom_voie)
{
	sprintf(nom_voie, "Fitte");
}

static int fitter_taille_voie(struct PInstrument *instrument, int voie)
{
// pb ici... on doit attendre l'init de l'instrument concern :/
// en fait, c'est pas si problmatique, le malloc du buffer (la partie critique)
//		se fait apres "init" et "start"
// c'est dur a detailler en fait
// TODO: expliquer en detail
	infos_fitter *i_fitter = instrument->structure;
	return i_fitter->taille_voie;
}

static void fitter_resultat(struct PInstrument *instrument, int voie, double *mesure)
{
	infos_fitter *i_fitter = instrument->structure;
	if (i_fitter->calculs)
		memcpy(mesure, i_fitter->calculs, i_fitter->taille_voie*sizeof(double));
	return;
}

static void fitter_indices(struct PInstrument *instrument, int voie, double *mesure)
{
	infos_fitter *i_fitter = instrument->structure;
	if (i_fitter->indices)
		memcpy(mesure, i_fitter->indices, i_fitter->taille_voie*sizeof(double));
	return;
}

static void fitter_calculer(struct PInstrument *instrument)//, ptr_buff_circu *buffer_circu, ptr_buff2D_circu *buffer2D_circu)
{
	infos_fitter *i_fitter = instrument->structure;
	ptr_buff_circu *buffer1, *buffer2, *buffer3, *buffer4;
	int err;
	double err_rms;
	double *a_fitter;
	
	// il faut chercher le buffer, il a ptet change juste apres "start" (une histoire malfique de Reserver_buffer_circu apres le start)
	// TODO: chercher comment mieux faire (c'est pas gagn)
	i_fitter->buffer = instrument->get_buffer2D_from_tatoo(i_fitter->tatoo_voie_fit);
	
	buffer1 = instrument->get_buffer_from_tatoo(i_fitter->tatoo_param1);
	buffer2 = instrument->get_buffer_from_tatoo(i_fitter->tatoo_param2);
	buffer3 = instrument->get_buffer_from_tatoo(i_fitter->tatoo_param3);
	buffer4 = instrument->get_buffer_from_tatoo(i_fitter->tatoo_param4);

	if (buffer1 == NULL)
		i_fitter->valeurs[0] = i_fitter->param1;
	else
		i_fitter->valeurs[0] = buffer1->mesure[buffer1->dernier_indice];

	if (buffer2 == NULL)
		i_fitter->valeurs[1] = i_fitter->param2;
	else
		i_fitter->valeurs[1] = buffer2->mesure[buffer2->dernier_indice];

	if (buffer3 == NULL)
		i_fitter->valeurs[2] = i_fitter->param3;
	else
		i_fitter->valeurs[2] = buffer3->mesure[buffer3->dernier_indice];
	
	if (buffer4 == NULL)
		i_fitter->valeurs[3] = i_fitter->param4;
	else
		i_fitter->valeurs[3] = buffer4->mesure[buffer4->dernier_indice];

	if (i_fitter->buffer == NULL)
		return;

	a_fitter = malloc(i_fitter->taille_voie * sizeof(double));
	memcpy(i_fitter->indices, i_fitter->buffer->indices[i_fitter->buffer->dernier_indice], i_fitter->buffer->taille_voie * sizeof(double));
	memcpy(a_fitter, i_fitter->buffer->mesure[i_fitter->buffer->dernier_indice], i_fitter->buffer->taille_voie * sizeof(double));
	
	// TODO: prendre semaphore !
	g_fitter = i_fitter;
	// c'est lent de fitter...
	err = NonLinearFit (i_fitter->indices, a_fitter, i_fitter->calculs, i_fitter->taille_voie,
		ModelFunct, i_fitter->valeurs, i_fitter->num_var, &err_rms);
	// TODO: relacher semaphore !
	
	free(a_fitter);					  
	return;
}

double ModelFunct (double x, double a[], int ncoef)
{
	// variable globale g_fitter, c'est lourd, mais ya pas moyen sinon
	double b[5], res;
	char **grrr;
	int i;
	
	b[0]=a[0];
	b[1]=a[1];
	b[2]=a[2];
	b[3]=a[3];
	b[ncoef]=x;
	
	grrr = malloc(5*sizeof(char*));
	for (i=0; i<=ncoef; i++)
		grrr[i] = (char*)&(g_fitter->variables[i]);
	
	res = evaluator_evaluate(g_fitter->f, g_fitter->num_var+1, grrr, b);
	free(grrr);
	return res;
}


