/* frquence2voies.h
 contient les initialisations, mise en place, et fonction d'interruption
 pour un frquencemtre fonctionnant sur 2 voies. 
 Contient aussi des fonctions propres pour afficher les messages d'erreur*/

#include "plugin.h"

typedef struct	
	{
	int identificateur;
	int adresse_gpib;
	int digits;
	int impedance;
	int filtre;
	int couplage;
	int attenuation;
	int stop_interruption;
	int lock_interruption;
	unsigned int numero_mesure[2];
	int nombre_voie;
	double zone_memoire[2];
	int etat_voie;
	char nom_instru[128];
	
	int watchdog;
	int panel_wdog;
	
	double delay_wdog;
		
	}infos_freq_2voies; 


int __stdcall CB_interruption_freq_2voies(int boardOrDevice, int sta, int err, long cntl,void *callbackData);

static void frequencemetre_2voies_nouveau(PInstrument **freq2v);
static void frequencemetre_2voies_liberer(PInstrument *instru);
static void frequencemetre_2voies_get_nom(PInstrument *instrument, char *nom_instru);
static void frequencemetre_2voies_set_nom(PInstrument *instrument, char *nom_instru);
static void frequencemetre_2voies_configure(PInstrument *frequencemetre);
static void frequencemetre_2voies_getconfig(PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool);
static int frequencemetre_2voies_nb_voie(PInstrument *frequencemetre);
static void frequencemetre_2voies_get_nom_voie(PInstrument *frequencemetre, int voie, char *nom_voie);
static double frequencemetre_2voies_mesure(PInstrument *frequencemetre, int voie);
static unsigned int frequencemetre_2voies_numero(PInstrument *frequencemetre, int voie);
static int frequencemetre_2voies_digits(PInstrument *frequencemetre);
static void arreter_interruption_freq_2voies(PInstrument *frequencemetre);

int miseenplace_int_freq_2voies(PInstrument *frequencemetre);
int initialisation_freq_2voies_int(PInstrument *frequencemetre);
