#include "toolbox.h"
#include <ansi_c.h>
#include "hp5313xa.h"
#include <userint.h>
#include <visa.h>
#include <gpib.h>
#include "globales.h"
#include <formatio.h>
#include "frequencemetre.h"
#include "UIR_frequencemetre.h"
#include "plugin.h"

PInstrument freq =
{
	NULL, // Rempli par 'nouveau'

	NULL, // rempli aprs nouveau (par liste.c)
	NULL,
	NULL,
	NULL,
	NULL,

	frequencemetre_nouveau,
	frequencemetre_liberer,
	frequencemetre_configure,
	frequencemetre_getconfig,
	frequencemetre_get_nom,
	frequencemetre_set_nom,
	arreter_interruption_freq_1voie,
	miseenplace_int_freq_1voie,
	initialisation_freq_1voie_int,
	NULL,
	NULL,
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	
	frequencemetre_nb_voie,
	frequencemetre_get_nom_voie,
	frequencemetre_mesure,
	frequencemetre_numero,
	
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

int CVICALLBACK FR_OK (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{

int Valeurs_Configuration_Adresse_GPIB = 0;
int Valeurs_Configuration_Digit = 0;
int Valeurs_Configuration_Impedance = 0;
int Valeurs_Configuration_Filtre = 0;
int Valeurs_Configuration_Couplage = 0;
int Valeurs_Configuration_Attenuation = 0;

infos_freq_1voie *structu_inst;

structu_inst = (infos_freq_1voie *)callbackData;

	switch (event)
		{
		case EVENT_COMMIT:
		
			GetCtrlVal (panel, Conf_Fr_NUM_Conf_Adr_Freq, &Valeurs_Configuration_Adresse_GPIB); // Rcupration de l'adresse GPIB
			GetCtrlVal (panel, Conf_Fr_RING_Conf_Digit_Freq, &Valeurs_Configuration_Digit); // Rcupration du nombre de digits
			GetCtrlVal (panel, Conf_Fr_BINARYSW_Conf_Impedan, &Valeurs_Configuration_Impedance); // Rcupration de la valeur de l'impdance
			GetCtrlVal (panel, Conf_Fr_BINARYSW_Conf_Filtre, &Valeurs_Configuration_Filtre); // Rcupration de l'tat du filtre
			GetCtrlVal (panel, Conf_Fr_BINARYSW_Conf_Couplag, &Valeurs_Configuration_Couplage); // Rcupration de la nature du couplage
			GetCtrlVal (panel, Conf_Fr_BINARYSW_Conf_Attenua, &Valeurs_Configuration_Attenuation); // Rcupration de la valeur de l'attnuation
			
			structu_inst->adresse_gpib = Valeurs_Configuration_Adresse_GPIB;
			structu_inst->digits = Valeurs_Configuration_Digit;
			structu_inst->impedance = Valeurs_Configuration_Impedance;
			structu_inst->filtre = Valeurs_Configuration_Filtre;
			structu_inst->couplage = Valeurs_Configuration_Couplage;
			structu_inst->attenuation = Valeurs_Configuration_Attenuation;
			structu_inst->nombre_voie = 1;
				
			DiscardPanel (panel); // Dtruit la fentre "CONFIGURATION D'UN APPAREIL" pour un frquencemtre
			
			break;
		}
	return 0;
}

int initialisation_freq_1voie_int(PInstrument *frequencemetre)
{
	infos_freq_1voie *data_freq = frequencemetre->structure;
	char gpib_canal[20], chaine[255], tmp[255], chaine_digits[255];
	int err=0,handle=0,id_cont=0;
	short err_short=0;


	// Initialisation Zone Mmoire.
	data_freq->zone_memoire[0]=NotANumber();

	//Initialisation Numro Mesure.
	data_freq->numero_mesure[0] = 0;

	err = ibfind("GPIB0");
	if (err & ERR)
	{
		MessagePopup ("Problme de carte", "Carte GPIB non dtecte");
		return -1;
	}
	
	// Dtection frquencemtre
	id_cont = ibdev (0, data_freq->adresse_gpib, NO_SAD, T10s, 1, 1);
	ibclr (id_cont);		// Erreur CVI si branche mais pas allume !?
	ibln (id_cont, data_freq->adresse_gpib, NO_SAD, &err_short); 

	if (err_short == 0) 
		{
		sprintf(chaine,"Il faudrait penser  brancher le compteur  l'adresse %d !!!",data_freq->adresse_gpib);
		MessagePopup ("PAS BON", chaine);
		return -1;
		}
	
	ibecr(id_cont, "*IDN?");
	ibrd(id_cont, chaine, 250);
	if (strstr (chaine, "HEWLETT-PACKARD,5313") == NULL)
	{
		MessagePopup ("Erreur", "Modle non support par ce module !");
		return -1;
	}

	sprintf(tmp,"%d",data_freq->digits);
	strcpy(chaine_digits,":FREQ:ARM:STOP:DIG ");
	strcat (chaine_digits, tmp);
	sprintf(gpib_canal, "GPIB::%d", data_freq->adresse_gpib);
	if ((err = hp5313xa_init (gpib_canal, VI_OFF, VI_ON, 1, &handle))!=0) 
		analyse_msg_VI("init",err);
	else if ((err = hp5313xa_reset (handle))!=0) // reset
		analyse_msg_freq("reset",err);
	else if ((err = hp5313xa_writeInstrData (handle, "*CLS"))!=0)   // clear event register and error queue
		analyse_msg_freq("writeInstrData",err);
	else if ((err = hp5313xa_writeInstrData (handle, "*SRE 0"))!=0) // clear service request enable register
		analyse_msg_freq("writeInstrData",err);
	else if ((err = hp5313xa_writeInstrData (handle, "*ESE 0"))!=0) // clear event status enable register
		analyse_msg_freq("writeInstrData",err);
	else if ((err = hp5313xa_writeInstrData (handle, ":FUNC 'FREQ 1'"))!=0) // utilis pour mesurer la frquence, voie 1
		analyse_msg_freq("writeInstrData",err);
	else if ((err = hp5313xa_writeInstrData (handle, ":FREQ:ARM:STAR:SOUR IMM"))!=0) // dclenchement immdiat
		analyse_msg_freq("writeInstrData",err);
	else if ((err = hp5313xa_writeInstrData (handle, ":FREQ:ARM:STOP:SOUR DIG"))!=0) // Arrt sur un nombre de Digits
		analyse_msg_freq("writeInstrData",err);	
	else if ((err = hp5313xa_writeInstrData (handle, chaine_digits))!=0) // Spcification du nombre de Digits
		analyse_msg_freq("writeInstrData",err);
	else if ((err = hp5313xa_writeInstrData (handle, ":TRIG:COUN:AUTO OFF"))!=0) // pour que :init:imm dmarre une mesure directement
		analyse_msg_freq("writeInstrData",err);
	else if ((err = hp5313xa_writeInstrData (handle, "FORM:DATA ASCII"))!=0) // on renvoit des nombres rels.
		analyse_msg_freq("writeInstrData",err);
	else if ((err = hp5313xa_inputCond (handle, 1, data_freq->couplage, data_freq->impedance, data_freq->attenuation, data_freq->filtre))!=0)
		analyse_msg_freq("inputCond",err);
	else if ((err = hp5313xa_trigSens (handle,  1, VI_OFF, 50, data_freq->attenuation, VI_ON, 0))!=0)
		analyse_msg_freq("trigSens",err);
	else if ((err = hp5313xa_inputCond (handle, 2, data_freq->couplage, data_freq->impedance, data_freq->attenuation, data_freq->filtre))!=0)
		analyse_msg_freq("inputCond",err);
	else if ((err = hp5313xa_trigSens (handle,  2, VI_OFF, 50, data_freq->attenuation, VI_ON, 0))!=0)
		analyse_msg_freq("trigSens",err);
	else if (( err = viSetAttribute (handle, VI_ATTR_TMO_VALUE, 2500)) !=0)
		analyse_msg_VI("Timeout",err);
	hp5313xa_close (handle);

	// Mise  jour des donnes de la structure.
	data_freq->identificateur = id_cont;
	data_freq->stop_interruption = RQS; 
	
	return err;
}

/* Fonction de mise en place de l'interruption sur le freq 1 voie
Renvoit CMPL (0x0100) en cas de succs.*/
int miseenplace_int_freq_1voie(PInstrument *frequencemetre)
{
	infos_freq_1voie *data_freq = frequencemetre->structure;
	int err=0;
	char chaine[255];
	unsigned short addr_GPIB=0;
	
	err=ibwrt(data_freq->identificateur,"*ESE 1",strlen("*ESE 1"));
	// Activation de l'interruption  la fin des mesures sur le frquencemtre
	if ((err = ibwrt (data_freq->identificateur, "*SRE 32",strlen("*SRE 32"))) & ERR) // Activation
		{
		sprintf(chaine,"Impossible d'initialiser l'interruption\nsur le frquencemtre d'identificateur %d\n iberr=%x \n ibsta=%x\nibcntl=%x",data_freq->identificateur,iberr,ibsta,ibcntl);
		MessagePopup("Attention !!!",chaine);
		return err;
		}

	// Enlever le bit RQS
	err = ibrsp(data_freq->identificateur,chaine); 
	// Nettoyage du registre d'interruptions
	ibecr(data_freq->identificateur,"*ESR?");
	ibrd(data_freq->identificateur,chaine,10);
	
	// Mise en place de l'interruption
	err = ibnotify (data_freq->identificateur, data_freq->stop_interruption, CB_interruption_freq_1voie,data_freq);
	if (err & ERR)
	{
		sprintf(chaine,"Impossible d'initialiser le frquencemtre\nd'adresse %d",addr_GPIB);
		MessagePopup("Attention !!!",chaine);
		return -1;
	}
	// lancement d'une mesure
	if ((err = ibwrt (data_freq->identificateur, ":INIT:IMM;*OPC",strlen(":INIT:IMM;*OPC")))& ERR) // dclenchement immdiat
	{
		sprintf(chaine,"Impossible de lancer une mesure\nsur le frquencemtre d'identificateur %d\n iberr=%x \n ibsta=%x\nibcntl=%x",data_freq->identificateur,ibsta,ibcntl);
		MessagePopup("Attention !!!",chaine);
		ibnotify (data_freq->identificateur, 0, CB_interruption_freq_1voie,data_freq->zone_memoire); //Dsactivation de l'interruption
		return err;
	}
	return err;
}
	

int __stdcall CB_interruption_freq_1voie(int boardOrDevice, int localsta, int localerr, long localcntl, void *callbackData)
{
	infos_freq_1voie *data_freq;

	char chaine[256];
	int err;
	int count=0;
	
	switch (localsta)
	{
		case ERR:
			return 0;
		default:
	
			data_freq = (infos_freq_1voie *)callbackData;

			// Enlever le bit RQS
			err = ibrsp(boardOrDevice,chaine); 
			// Demander la frquence au frquencemtre
			do
			{
				err = ibecr(boardOrDevice,"FETCH:FREQ?");
				//Lecture de  la chaine
				err = ibrd (boardOrDevice, chaine, 255);
				count++;
			} while (err & ERR); // Parfois le HP ne comprend pas le FETCH (!!)
			
			chaine[ThreadIbcntl()]='\0'; //Ajout du caractere de fin de chaine
			
			if (count > 1) // S'il a fallu plus d'une tentative pour lire avec FETCH
			{
				err = ibecr(boardOrDevice, "*ESE 0"); // Methode de reprise mise au point a la main, en cours de test dans de vraies conditions
				err = ibecr(boardOrDevice, "*ESE 1");
			}
			
			err = sscanf (chaine, "%lf", &(data_freq->zone_memoire[0])); //transformation en flottant

		    // Incrmentation du nombre de mesures.
		    data_freq->numero_mesure[0]++; 

			if (err==EOF)
				data_freq->zone_memoire[0]=18.0; // Debug du sscanf -> Si erreur, envoie 18  la place de la mesure (ne devrait plus servir, l'erreur a surement ete identifie au niveau du FETCH)
		
			// Nettoyage du registre d'interruptions
			ibecr(boardOrDevice,"*ESR?");
			ibrd(boardOrDevice,chaine,10);
	
			// relancement d'une mesure
			ibecr(boardOrDevice, ":INIT:IMM;*OPC"); // dclenchement immdiat
	
			return data_freq->stop_interruption; // Pour ractiver l'interruption
	}
}

static void arreter_interruption_freq_1voie(PInstrument *frequencemetre)
{
	infos_freq_1voie *data_freq = frequencemetre->structure;
	
	if (data_freq->stop_interruption == 0) // dj arrt
		return;
		
	//dsactivation de l'interruption
	data_freq->stop_interruption = 0;
	
	//libration de l'identificateur
	//ibonl (data_freq->identificateur, 0);
}

static void frequencemetre_nouveau(PInstrument **frequencemetre)
{
	*frequencemetre = (PInstrument *)malloc(sizeof(PInstrument));
	memcpy (*frequencemetre, &freq, sizeof(PInstrument));
	(*frequencemetre)->structure = malloc(sizeof(infos_freq_1voie));
	((infos_freq_1voie *)(*frequencemetre)->structure)->adresse_gpib = 4;
	sprintf(((infos_freq_1voie *)(*frequencemetre)->structure)->nom_instru, "Frquencemtre");
}

static void frequencemetre_liberer(PInstrument *instru)
{
	free(instru->structure);
	free(instru);
}

static void frequencemetre_get_nom(PInstrument *instrument, char *nom_instru)
{
	memcpy(nom_instru, ((infos_freq_1voie *)instrument->structure)->nom_instru, TAILLE_NOM_INSTRU-1);
}

static void frequencemetre_set_nom(PInstrument *instrument, char *nom_instru)
{
	memcpy(((infos_freq_1voie *)instrument->structure)->nom_instru, nom_instru, TAILLE_NOM_INSTRU-1);
	((infos_freq_1voie *)instrument->structure)->nom_instru[TAILLE_NOM_INSTRU-1] = NULL;
}

static void frequencemetre_configure(PInstrument *frequencemetre)
{
	infos_freq_1voie *data_freq = frequencemetre->structure;
	int panel;
	if ((panel = LoadPanel (0, "UIR_frequencemetre.uir", Conf_Fr)) < 0)
		return ;
					   
	SetCtrlVal (panel, Conf_Fr_NUM_Conf_Adr_Freq, data_freq->adresse_gpib);
	SetCtrlVal (panel, Conf_Fr_RING_Conf_Digit_Freq, data_freq->digits);
	SetCtrlVal (panel, Conf_Fr_BINARYSW_Conf_Impedan, data_freq->impedance);
	SetCtrlVal (panel, Conf_Fr_BINARYSW_Conf_Filtre, data_freq->filtre);
	SetCtrlVal (panel, Conf_Fr_BINARYSW_Conf_Couplag, data_freq->couplage);
	SetCtrlVal (panel, Conf_Fr_BINARYSW_Conf_Attenua, data_freq->attenuation);
						

	SetCtrlAttribute (panel, Conf_Fr_B_Conf_OK, ATTR_CALLBACK_DATA, data_freq);
	DisplayPanel (panel); // Affiche la fentre "CONFIGURATION DE L'APPAREIL" pour un frquencemtre
}

static void frequencemetre_getconfig(PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool)
{
	infos_freq_1voie* data = instrument->structure;
	
	*p_strct = (void*)data;
	*p_size = sizeof(infos_freq_1voie);
	
	*p_bool = 1;
}

static int frequencemetre_nb_voie(PInstrument *frequencemetre)
{
	infos_freq_1voie *data_freq = frequencemetre->structure;
	return data_freq->nombre_voie;
}

static void frequencemetre_get_nom_voie(PInstrument *frequencemetre, int voie, char *nom_voie)
{
	//infos_freq_1voie *data_freq = frequencemetre->structure;
	strcpy(nom_voie, "Voie 1");
}

static double frequencemetre_mesure(PInstrument *frequencemetre, int voie)
{
	infos_freq_1voie *data_freq = frequencemetre->structure;
	return data_freq->zone_memoire[voie-1];
}

static unsigned int frequencemetre_numero(PInstrument *frequencemetre, int voie)
{
	infos_freq_1voie *data_freq = frequencemetre->structure;
	return data_freq->numero_mesure[voie-1];
}

static int frequencemetre_digits(PInstrument *frequencemetre)
{
	infos_freq_1voie *data_freq = frequencemetre->structure;
	return data_freq->digits;
}

