/* frequencemetre.h
 contient les initialisations, mise en place, et fonction d'interruption
 pour un frquencemtre sur une voie 
 Contient aussi des fonctions propres pour afficher les messages d'erreur*/

#include "plugin.h"

typedef struct	
	{
	int identificateur;
	int adresse_gpib;
	int digits;
	int impedance;
	int filtre;
	int couplage;
	int attenuation;
	int stop_interruption;
	unsigned int numero_mesure[1];
	int nombre_voie;
	double zone_memoire[1];
	char nom_instru[128];
	}infos_freq_1voie;


//int initialisation_freq_1voie_int(infos_freq_1voie *data_freq);
//int miseenplace_int_freq_1voie(infos_freq_1voie *data_freq);
int __stdcall CB_interruption_freq_1voie(int boardOrDevice, int sta, int err, long cntl,void *callbackData);
//int arreter_interruption_freq_1voie(infos_freq_1voie *data_freq);

static void frequencemetre_nouveau(PInstrument **frequencemetre);
static void frequencemetre_liberer(PInstrument *instru);
static void frequencemetre_get_nom(PInstrument *instrument, char *nom_instru);
static void frequencemetre_set_nom(PInstrument *instrument, char *nom_instru);
static void frequencemetre_configure(PInstrument *frequencemetre);
static void frequencemetre_getconfig(PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool);
static int frequencemetre_nb_voie(PInstrument *frequencemetre);
static void frequencemetre_get_nom_voie(PInstrument *frequencemetre, int voie, char *nom_voie);
static double frequencemetre_mesure(PInstrument *frequencemetre, int voie);
static unsigned int frequencemetre_numero(PInstrument *frequencemetre, int voie);
static int frequencemetre_digits(PInstrument *frequencemetre);

static void arreter_interruption_freq_1voie(PInstrument *frequencemetre);
int miseenplace_int_freq_1voie(PInstrument *frequencemetre);
int initialisation_freq_1voie_int(PInstrument *frequencemetre);
