/* switch.h
 contient les initialisations, mise en place, et fonction d'interruption
 pour un frquencemtre sur une voie switche 
 Contient aussi des fonctions propres pour afficher les messages d'erreur*/

#include "plugin.h"

typedef struct	
	{
	int identificateur;
	int adresse_gpib;
	int bit_choisi;
	int digits;
	int impedance;
	int filtre;
	int couplage;
	int attenuation;
	int nombre_voie;
	int stop_interruption;
	unsigned int numero_mesure[2];
	double zone_memoire[2];
	int etat_switch;
	char nom_instru[128];
	}infos_frsw; 


int __stdcall CB_interruption_freq_switch(int boardOrDevice, int sta, int err, long cntl,void *callbackData);

static void frequencemetre_SW_nouveau(PInstrument **frequencemetre);
static void frequencemetre_SW_liberer(PInstrument *instru);
static void frequencemetre_SW_get_nom(PInstrument *instrument, char *nom_instru);
static void frequencemetre_SW_set_nom(PInstrument *instrument, char *nom_instru);
static void frequencemetre_SW_configure(PInstrument *frequencemetre);
static void frequencemetre_SW_getconfig(PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool);
static int frequencemetre_SW_nb_voie(PInstrument *frequencemetre);
static void frequencemetre_SW_get_nom_voie(PInstrument *frequencemetre, int voie, char *nom_voie);
static double frequencemetre_SW_mesure(PInstrument *frequencemetre, int voie);
static unsigned int frequencemetre_SW_numero(PInstrument *frequencemetre, int voie);
static int frequencemetre_SW_digits(PInstrument *frequencemetre);

static void arreter_interruption_freq_switch(PInstrument *frequencemetre);
int miseenplace_int_freq_switch(PInstrument *frequencemetre);
int initialisation_freq_switch_int(PInstrument *frequencemetre);

