#include <ansi_c.h>
#include <userint.h>
#include "cviogl.h"
#include "graph3D.h"
#include "UIR_graph3D.h"
#include "plugin.h"

extern void init_liste_voie2D(int panel, int control_id); // ce serait bien de faire disparaitre ca...
extern ptr_buff2D_circu *get_buffer2D_from_tatoo(char *tatoo_voie);

static double dataArray[ptsY][HISTORIQUE_2D];

static int OGLPlotHandle = 0;
static int OGLControlID;
static int OGLPanel = 0;

static ColorMapEntry gColorMap[3];

int InitGraph3D(int nb_voie2D)
{
	// Load the main program panel
    if ((OGLPanel = LoadPanel (0, "UIR_graph3D.uir", P_OGL)) < 0)
    {
    	MessagePopup("Graph 3D", "Impossible de charger le panel 3D");
        return -1;
    }
    
	// Initialize the OGL control
    if (InitOGLControl () != 0)
        return -1;
        
    // Initialize the main UIR
    if (InitPlot () != 0)
        return -1;
        
    Update_Liste_Voie2D();
    
    // Display the OGL panel
    DisplayPanel (OGLPanel);

    return 0;
}

void Update_Liste_Voie2D(void)
{
	init_liste_voie2D(OGLPanel, P_OGL_RING);
}

int DiscardGraph3D(void)
{
	OGLDiscardCtrl (OGLPanel, OGLControlID);
	DiscardPanel(OGLPanel);
	OGLPanel = 0;
	return 0;
}

static int InitPlot(void)
{
    // Plot the color scale next to 3D plot to reflect this color map
    /*if (PlotColorScale() != 0)
    {
        MessagePopup ("Initialization Error", "Could not initialize color scale.");
        return -1;
    }*/

    // Create the plotdata for the first time, we will use 
	memset (dataArray, 0, HISTORIQUE_2D*ptsY*sizeof(double));
    
    OGLPlotHandle = OGLPlot3DUniform (OGLPanel, OGLControlID,
                   dataArray, HISTORIQUE_2D, ptsY, OGLVAL_DOUBLE, 1.0, 0.0, 1.0, 0.0);
                   
    // Set the plot attributes
    OGLSetPlotAttribute(OGLPanel, OGLControlID,OGLPlotHandle, OGLATTR_SURFACE_STYLE,OGLVAL_FLAT);
    OGLSetPlotAttribute(OGLPanel, OGLControlID,OGLPlotHandle, OGLATTR_SURFACE_SPECULAR_FACTOR,0.0);
    OGLSetPlotAttribute(OGLPanel, OGLControlID,OGLPlotHandle, OGLATTR_SURFACE_SHININESS,50);
    OGLSetPlotAttribute(OGLPanel, OGLControlID,OGLPlotHandle, OGLATTR_WIRE_STYLE,OGLVAL_NONE);
    return 0;
}       

static int InitOGLControl(void)
{
    char chaine[255];
    
    // Creation du control OpenGL par le code (la conversion d'une image merdait sur le portable toshiba)
	if ((OGLControlID = OGLNewCtrl (OGLPanel, "", 70, 10)) <= 0)
	{
		OGLGetErrorString (OGLControlID, chaine, 255);
    	MessagePopup("InitOGLControl", chaine);
        return -1;
	}
	OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_HEIGHT, 420);
	OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_WIDTH, 490);
    
    // Set up the lighting attributes
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_LIGHTING_ENABLE, OGLVAL_FALSE);
    //OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_LIGHT_SELECT, 1);
    //OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_LIGHT_ENABLE, 1);
    //OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_LIGHT_DISTANCE, 3.0);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_PROJECTION_TYPE,OGLVAL_PERSPECTIVE);
    
    // Set up the Z axis    
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_ZNAME_VISIBLE, OGLVAL_TRUE);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_ZNAME, "Z");
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_ZNAME_COLOR, OGLVAL_YELLOW);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_ZNAME_POINT_SIZE, 17);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_ZLABEL_VISIBLE, 1);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_ZLABEL_POINT_SIZE, 16);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_ZDIVISIONS, 5);
	OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_ZAXIS_SCALING, OGLVAL_AUTO);
    //OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_ZMIN, -10.0);
    //OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_ZMAX, 10.0);
    
    // Set up the X axis
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_XNAME, "X");   
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_XNAME_VISIBLE, OGLVAL_TRUE);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_XNAME_POINT_SIZE, 17);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_XNAME_COLOR, OGLVAL_YELLOW);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_XLABEL_POINT_SIZE, 16);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_XLABEL_VISIBLE, OGLVAL_TRUE);
    
    // Set up the Y axis
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_YNAME, "Y");   
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_YNAME_VISIBLE, OGLVAL_TRUE);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_YNAME_POINT_SIZE, 17);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_YNAME_COLOR, OGLVAL_YELLOW);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_YLABEL_VISIBLE, OGLVAL_TRUE);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_YLABEL_POINT_SIZE, 16);
    
    // Set up the grid planes
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_YZ_GRID_VISIBLE, OGLVAL_TRUE);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_YZ_GRID_COLOR, OGLVAL_LT_GRAY);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_XY_GRID_VISIBLE, OGLVAL_TRUE);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_XY_GRID_COLOR, OGLVAL_LT_GRAY);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_XZ_GRID_VISIBLE, OGLVAL_TRUE);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_XZ_GRID_COLOR, OGLVAL_LT_GRAY);
    
    // Set up the plot area
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_PLOTAREA_ZSTART, -1.0);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_PLOTAREA_ZSIZE, 2.0);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_PLOTAREA_XSTART, -1.0);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_PLOTAREA_XSIZE, 2.0);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_PLOTAREA_YSTART, -1.0);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_PLOTAREA_YSIZE, 2.0);
    
    // Set up the default view position
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_VIEW_AUTO_DISTANCE, OGLVAL_FALSE);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_VIEW_DISTANCE, 4.0);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_VIEW_LATITUDE, 66.0);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_VIEW_LONGITUDE, 64.0);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_VIEW_CENTERZ, -0.35);
    
    // Set up the control for Refresh operation (keeping a pointer only)
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_COPY_ORIGINAL_DATA, OGLVAL_FALSE);
    
    // Define user interaction
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_ENABLE_PAN_ZOOM_ROTATE, OGLVAL_TRUE);
    OGLSetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_ENABLE_PROPERTY_POPUP,  OGLVAL_TRUE);
    return 0;
}

static void MakeColorMap(int lowColor, int medColor, int highColor, double low, double med, double high)
{
    gColorMap[0].dataValue.valDouble = low;
    gColorMap[0].color = lowColor;
    gColorMap[1].dataValue.valDouble = med;
    gColorMap[1].color = medColor;
    gColorMap[2].dataValue.valDouble = high;
    gColorMap[2].color = highColor;
}

void Visu3D(ptr_buff2D_circu *buffer2D_circulaire)
{
    double zmin, zmax;
    
    static int uncoupsurdeux = 0;
    if (uncoupsurdeux == 0)
    	uncoupsurdeux++;
    else
    {
    	uncoupsurdeux = 0;
    	//return;
    }

	if (OGLPanel == 0)
    	return;

	MakeDataArray (dataArray, buffer2D_circulaire);
    
    OGLGetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_ZMIN, &zmin);
    OGLGetCtrlAttribute (OGLPanel, OGLControlID, OGLATTR_ZMAX, &zmax);
    MakeColorMap (VAL_BLACK, VAL_BLUE, VAL_RED, zmin, (zmin+zmax)/2, zmax);
    OGLSetPlotColorScheme (OGLPanel, OGLControlID, OGLPlotHandle, OGLVAL_COLORMAP, gColorMap, 3, VAL_YELLOW, 1, NULL, 0, 0);
    
    OGLRefreshGraph (OGLPanel, OGLControlID);
}

static int MakeDataArray(double dataArray[ptsY][HISTORIQUE_2D], ptr_buff2D_circu *buffer2D_circulaire)
{
    int x, x_array;
    int y_loop, y, y_array;
    //int id_voie;
    ptr_buff2D_circu *buffer;
    char tatoo_voie[30];
    int y_center, z_out;
    
    GetCtrlVal(OGLPanel, P_OGL_RING, tatoo_voie);
    buffer = get_buffer2D_from_tatoo(tatoo_voie);
    
    if (buffer == NULL)
    	return -1;
	if (buffer->taille_voie == 0)
		return -1;
		
    GetCtrlVal(OGLPanel, P_OGL_CENTER, &y_center);
    GetCtrlVal(OGLPanel, P_OGL_Z_OUT, &z_out);
    
    if ((y_center <0) || (y_center>=buffer->taille_voie))
    {
    	y_center = buffer->taille_voie/2;
    	SetCtrlVal(OGLPanel, P_OGL_CENTER, y_center);
    }
    SetCtrlAttribute (OGLPanel, P_OGL_NUMERIC, ATTR_DIMMED, 0);
	SetCtrlVal(OGLPanel, P_OGL_NUMERIC, buffer->indices[buffer->dernier_indice][y_center]);

    y_array=0;
    for (y_loop=y_center-ptsY*z_out/2; y_loop<y_center+ptsY*z_out/2; y_loop+=z_out)
    {
    	y=y_loop;
    	if (y<0) y=0;
    	if (y>=buffer->taille_voie) y=buffer->taille_voie-1;
    	
    	x_array = 0;
    	for (x=buffer->dernier_indice+1; x<HISTORIQUE_2D; x++)
        {
            dataArray[y_array][x_array] = buffer->mesure[x][y];
            x_array++;
        }
        for (x=0; x<=buffer->dernier_indice; x++)
        {
            dataArray[y_array][x_array] = buffer->mesure[x][y];
            x_array++;
        }
        y_array++;
    }   
    return 0;
}

int CVICALLBACK P_Graph3D_Callback (int panel, int event, void *callbackData, int eventData1, int eventData2)
{
    int top, height, left, width;
    switch (event)
    {
     case EVENT_PANEL_SIZE:
        GetCtrlAttribute(panel, OGLControlID, ATTR_TOP, &top);
        GetCtrlAttribute(panel, OGLControlID, ATTR_LEFT, &left);
        GetCtrlAttribute(panel, OGLControlID, ATTR_WIDTH, &width);
        GetCtrlAttribute(panel, OGLControlID, ATTR_HEIGHT, &height);

        OGLSetCtrlAttribute (panel, OGLControlID, OGLATTR_TOP, top);
        OGLSetCtrlAttribute (panel, OGLControlID, OGLATTR_LEFT, left);
        OGLSetCtrlAttribute (panel, OGLControlID, OGLATTR_WIDTH, width);
        OGLSetCtrlAttribute (panel, OGLControlID, OGLATTR_HEIGHT, height);

        OGLRefreshGraph(panel, OGLControlID);
        
        break;
    }
    return 0;
}

int CVICALLBACK CB_Center (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			SetCtrlAttribute (OGLPanel, P_OGL_NUMERIC, ATTR_DIMMED, 1);
			break;
		}
	return 0;
}
