#include <utility.h>
#include <ansi_c.h>
#include <userint.h>
#include "UIR_graphtab.h"
#include "graphtab.h"
#include "plugin.h"

static int panelTab;

extern void init_liste_voie(int panel, int control_id);
extern ptr_buff_circu *get_buffer_from_tatoo(char *tatoo_voie);

int nbpointsgraph;

int nbgraphs = 1;

LC_GRAPH* graphs = NULL;

void Visu2D(int Total_Voie, ptr_buff_circu *buffer_circulaire)
{
	LC_GRAPH* g = graphs;
	
	while(g)
	{
		Trace_Courbes(g, buffer_circulaire);
		g = g->next;
	}
	
	Ecriture_Tableau(Total_Voie, buffer_circulaire);
}

void Init_graph(int nbpointsgraph, LC_GRAPH* graphs)
{
		if ((graphs->panelGraph = LoadPanel (0, "UIR_graphtab.uir", P_Graph)) < 0)
			return ;
		if ((graphs->panelChoixAxe = LoadPanel (0, "UIR_graphtab.uir", P_Choix)) < 0)
			return ;
		
		InsertListItem(graphs->panelGraph,P_Graph_RG_COLOR_G, -1, "Blanc",VAL_WHITE);			
		InsertListItem(graphs->panelGraph,P_Graph_RG_COLOR_G, -1, "Jaune",VAL_YELLOW);
		InsertListItem(graphs->panelGraph,P_Graph_RG_COLOR_G, -1, "Vert",VAL_GREEN);
		InsertListItem(graphs->panelGraph,P_Graph_RG_COLOR_G, -1, "Bleu",VAL_BLUE);
		InsertListItem(graphs->panelGraph,P_Graph_RG_COLOR_G, -1, "Rouge",VAL_RED);
		InsertListItem(graphs->panelGraph,P_Graph_RG_COLOR_G, -1, "Cyan",VAL_CYAN);
		InsertListItem(graphs->panelGraph,P_Graph_RG_COLOR_G, -1, "Magenta",VAL_MAGENTA);
	
		InsertListItem(graphs->panelGraph,P_Graph_RG_COLOR_D, -1, "Blanc",VAL_WHITE);			
		InsertListItem(graphs->panelGraph,P_Graph_RG_COLOR_D, -1, "Jaune",VAL_YELLOW);
		InsertListItem(graphs->panelGraph,P_Graph_RG_COLOR_D, -1, "Vert",VAL_GREEN);
		InsertListItem(graphs->panelGraph,P_Graph_RG_COLOR_D, -1, "Bleu",VAL_BLUE);
		InsertListItem(graphs->panelGraph,P_Graph_RG_COLOR_D, -1, "Rouge",VAL_RED);
		InsertListItem(graphs->panelGraph,P_Graph_RG_COLOR_D, -1, "Cyan",VAL_CYAN);
		InsertListItem(graphs->panelGraph,P_Graph_RG_COLOR_D, -1, "Magenta",VAL_MAGENTA);
	
		
		graphs->color_left = VAL_YELLOW;
		SetCtrlVal(graphs->panelGraph,P_Graph_RG_COLOR_G, VAL_YELLOW);
		
		graphs->color_right = VAL_GREEN;
		SetCtrlVal(graphs->panelGraph,P_Graph_RG_COLOR_D, VAL_GREEN);
		
		SetCtrlAttribute(graphs->panelGraph,P_Graph_TRACE_DROIT,ATTR_LABEL_COLOR,graphs->color_right);
		SetCtrlAttribute(graphs->panelGraph,P_Graph_TRACE_DROIT,ATTR_TEXT_COLOR,graphs->color_right);
		SetCtrlAttribute(graphs->panelGraph,P_Graph_DIFF_VOIE_2_2,ATTR_LABEL_COLOR,graphs->color_right);
		SetCtrlAttribute(graphs->panelGraph,P_Graph_DIFF_VOIE_2_2,ATTR_TEXT_COLOR,graphs->color_right);
		SetCtrlAttribute(graphs->panelGraph,P_Graph_DIFF_VOIE_2_1,ATTR_LABEL_COLOR,graphs->color_right);
		SetCtrlAttribute(graphs->panelGraph,P_Graph_DIFF_VOIE_2_1,ATTR_TEXT_COLOR,graphs->color_right);
		SetCtrlAttribute(graphs->panelGraph,P_Graph_DIFF_VOIE_2,ATTR_LABEL_COLOR,graphs->color_right);
		SetCtrlAttribute(graphs->panelGraph,P_Graph_DIFF_VOIE_2,ATTR_TEXT_COLOR,graphs->color_right);

		SetCtrlAttribute(graphs->panelGraph,P_Graph_TRACE_GAUCHE,ATTR_LABEL_COLOR,graphs->color_left);
		SetCtrlAttribute(graphs->panelGraph,P_Graph_TRACE_GAUCHE,ATTR_TEXT_COLOR,graphs->color_left);
		SetCtrlAttribute(graphs->panelGraph,P_Graph_DIFF_VOIE_1_2,ATTR_LABEL_COLOR,graphs->color_left);
		SetCtrlAttribute(graphs->panelGraph,P_Graph_DIFF_VOIE_1_2,ATTR_TEXT_COLOR,graphs->color_left);
		SetCtrlAttribute(graphs->panelGraph,P_Graph_DIFF_VOIE_1_1,ATTR_LABEL_COLOR,graphs->color_left);
		SetCtrlAttribute(graphs->panelGraph,P_Graph_DIFF_VOIE_1_1,ATTR_TEXT_COLOR,graphs->color_left);
		SetCtrlAttribute(graphs->panelGraph,P_Graph_DIFF_VOIE_1,ATTR_LABEL_COLOR,graphs->color_left);
		SetCtrlAttribute(graphs->panelGraph,P_Graph_DIFF_VOIE_1,ATTR_TEXT_COLOR,graphs->color_left);
		
	
		// Pour choix des axes  grapher
		init_liste_voie(graphs->panelGraph, P_Graph_TRACE_GAUCHE);
		init_liste_voie(graphs->panelGraph, P_Graph_TRACE_DROIT);
	
		SetAxisRange (graphs->panelGraph, P_Graph_GRAPH, VAL_MANUAL, 0, nbpointsgraph-1, VAL_NO_CHANGE, 0.0, 1.0);
		SetAxisRange (graphs->panelGraph, P_Graph_GRAPH_2, VAL_MANUAL, 0, nbpointsgraph-1, VAL_NO_CHANGE, 0.0, 1.0);
		SetAxisRange (graphs->panelGraph, P_Graph_GRAPH_3, VAL_MANUAL, 0, nbpointsgraph-1, VAL_NO_CHANGE, 0.0, 1.0);
		
		DisplayPanel(graphs->panelGraph);

}

void MAJ_graphs(int nouveau_nbgraphs, int nb_points)
{

	LC_GRAPH* g = graphs;
	
	if( nouveau_nbgraphs < 1 ) return;
	
	if( nouveau_nbgraphs == nbgraphs ) return;

	if( nouveau_nbgraphs > nbgraphs )
	{// On ajoute
	
		while( g && (g->next) )
			g = g->next;
		
		g->next = (LC_GRAPH*)malloc(sizeof(LC_GRAPH));
		memset(g->next, 0, sizeof(LC_GRAPH));
		
		Init_graph(nb_points,g->next);
		
		nbgraphs++;
		
		MAJ_graphs(nouveau_nbgraphs,nb_points);
				
	}
	else
	{// On vire
		
		while( g && (g->next) && (g->next->next) )
			g = g->next;
		
		DiscardPanel(g->next->panelGraph);
		DiscardPanel(g->next->panelChoixAxe);
		
		free(g->next);
		
		g->next = NULL;
		
		nbgraphs--;
		
		MAJ_graphs(nouveau_nbgraphs,nb_points);
	
	}

	return;
}

void Init_graphtab(int Total_Voie, int nb_graphes, ptr_buff_circu *buffer_circulaire)
{
	int cpt_voie;
	int i;
	//int err;
	
	LC_GRAPH* prec = NULL;
	
	nbgraphs = nb_graphes;
	
	
	if ((panelTab = LoadPanel (0, "UIR_graphtab.uir", P_AFF_TAB)) < 0)
		return ;

	nbpointsgraph = buffer_circulaire[0].profondeur;
	

	for(i=0;i<nbgraphs;i++)
	{
		
		graphs = (LC_GRAPH*)malloc(sizeof(LC_GRAPH));
		memset(graphs, 0, sizeof(LC_GRAPH));
		
		graphs->next = prec;
		
		prec = graphs;
	
															   
	//.................
		Init_graph(nbpointsgraph,graphs);
	//.................
	}
	
	
	// On vide la table et on la rempli
	DeleteTableRows (panelTab, P_AFF_TAB_TABLE, 1, -1);
	DeleteTableColumns (panelTab, P_AFF_TAB_TABLE, 1, -1);
	InsertTableColumns (panelTab, P_AFF_TAB_TABLE, 1, Total_Voie, VAL_CELL_NUMERIC);
	for (cpt_voie=0; cpt_voie<Total_Voie; cpt_voie++)
	{
		SetTableColumnAttribute (panelTab, P_AFF_TAB_TABLE, cpt_voie+1, ATTR_LABEL_TEXT, buffer_circulaire[cpt_voie].nom_voie);
		SetTableColumnAttribute (panelTab, P_AFF_TAB_TABLE, cpt_voie+1, ATTR_USE_LABEL_TEXT, 1);
		SetTableColumnAttribute (panelTab, P_AFF_TAB_TABLE, cpt_voie+1, ATTR_PRECISION, 8);
		SetTableColumnAttribute (panelTab, P_AFF_TAB_TABLE, cpt_voie+1, ATTR_FORMAT, VAL_ENGINEERING_FORMAT);
	}
	DisplayPanel(panelTab);
}

void DiscardGraphTab(void)
{
	LC_GRAPH* g = graphs;

	LC_GRAPH* tmp;
	
	while(g)
	{
		DiscardPanel(g->panelGraph);
		DiscardPanel(g->panelChoixAxe);
		
		tmp = g;
		
		g = g->next;
		
		free(tmp);
	}
	
	DiscardPanel(panelTab);
	
}

static void Trace_Courbes (LC_GRAPH* g, ptr_buff_circu *buffer_circulaire)
{
	int err;
	//int Trace_Gauche, Trace_Droit;
	ptr_buff_circu *buffer_g, *buffer_d;
	double *buffer_lineaire;
	double *Bcirc;
	int deplacement=0;
	int Recup_mode_scaling;
	double Recup_max_axe_gauche, Recup_min_axe_gauche, diff_axe_gauche;
	double Recup_max_axe_droite, Recup_min_axe_droite, diff_axe_droite;
	int Valeur_Choix_Echelle_Gauche,Valeur_Choix_Echelle_Droite;
	double Valeur_MAX_Gauche = 0;
	double Valeur_MIN_Gauche = 0;
	double Valeur_Centrage_Gauche = 0;

	double Valeur_MAX_Droite = 0;
	double Valeur_MIN_Droite = 0;
	double Valeur_Centrage_Droite = 0;

	char tatoo_gauche[30], tatoo_droit[30];
	
	int i;
	int delta_t;
	double M;
		
	
	GetCtrlVal (g->panelGraph, P_Graph_TRACE_GAUCHE, tatoo_gauche);
	GetCtrlVal (g->panelGraph, P_Graph_TRACE_DROIT, tatoo_droit);
	buffer_g = get_buffer_from_tatoo(tatoo_gauche);
	buffer_d = get_buffer_from_tatoo(tatoo_droit);
	
	// Allocation de mmoire pour le buffer linaire
	buffer_lineaire=(double*) malloc( nbpointsgraph*sizeof(double) );

	DeleteGraphPlot (g->panelGraph, P_Graph_GRAPH, g->handle_plot_gauche, VAL_IMMEDIATE_DRAW);
	DeleteGraphPlot (g->panelGraph, P_Graph_GRAPH_2, g->handle_plot_gauche_2, VAL_IMMEDIATE_DRAW);	
	DeleteGraphPlot (g->panelGraph, P_Graph_GRAPH_3, g->handle_plot_gauche_3, VAL_IMMEDIATE_DRAW);
	
	DeleteGraphPlot (g->panelGraph, P_Graph_GRAPH, g->handle_plot_droite, VAL_IMMEDIATE_DRAW);
	DeleteGraphPlot (g->panelGraph, P_Graph_GRAPH_2, g->handle_plot_droite_2, VAL_IMMEDIATE_DRAW);
	DeleteGraphPlot (g->panelGraph, P_Graph_GRAPH_3, g->handle_plot_droite_3, VAL_IMMEDIATE_DRAW);
																			   
																			   
	if (buffer_g != NULL) // Cet axe est initialis et on veut le tracer
	{
		// Activation de l'axe de gauche pour tracer
		SetCtrlAttribute (g->panelGraph, P_Graph_GRAPH, ATTR_ACTIVE_YAXIS, VAL_LEFT_YAXIS);
		SetCtrlAttribute (g->panelGraph, P_Graph_GRAPH_2, ATTR_ACTIVE_YAXIS, VAL_LEFT_YAXIS);		
		SetCtrlAttribute (g->panelGraph, P_Graph_GRAPH_3, ATTR_ACTIVE_YAXIS, VAL_LEFT_YAXIS);		
	
		// Circulaire ->linaire gauche
		memset(buffer_lineaire,0.0,nbpointsgraph*sizeof(double));
		Bcirc=buffer_g->mesure;
		deplacement=buffer_g->ptr_mobile;
		
		//copie de la partie ancienne
		memcpy (buffer_lineaire,
			Bcirc+deplacement,
			(nbpointsgraph-deplacement)*sizeof(double));
		//copie de la partie rcente
		memcpy (buffer_lineaire + (nbpointsgraph-deplacement),
			Bcirc,
			(deplacement)*sizeof(double));
	
		//........
		
			
		//........
	
		/* On trace la voie sur l'axe slectionn en haut */
		g->handle_plot_gauche   = PlotY (g->panelGraph, P_Graph_GRAPH, buffer_lineaire, nbpointsgraph, VAL_DOUBLE, VAL_THIN_LINE, VAL_EMPTY_SQUARE, VAL_SOLID, 1, g->color_left);
		g->handle_plot_gauche_2 = PlotY (g->panelGraph, P_Graph_GRAPH_2, buffer_g->points_mid, nbpointsgraph, VAL_DOUBLE, VAL_THIN_LINE, VAL_EMPTY_SQUARE, VAL_SOLID, 1, g->color_left);
		g->handle_plot_gauche_3 = PlotY (g->panelGraph, P_Graph_GRAPH_3, buffer_g->points_long, nbpointsgraph, VAL_DOUBLE, VAL_THIN_LINE, VAL_EMPTY_SQUARE, VAL_SOLID, 1, g->color_left);	
		
		/* Ecriture diff axe min et max voie gauche */
		GetAxisScalingMode (g->panelGraph, P_Graph_GRAPH, VAL_LEFT_YAXIS,&Recup_mode_scaling, &Recup_min_axe_gauche,&Recup_max_axe_gauche);
		diff_axe_gauche = Recup_max_axe_gauche -Recup_min_axe_gauche;
		SetCtrlVal (g->panelGraph, P_Graph_DIFF_VOIE_1, diff_axe_gauche);
		
		/* Ecriture diff axe min et max voie gauche */
		GetAxisScalingMode (g->panelGraph, P_Graph_GRAPH_2, VAL_LEFT_YAXIS,&Recup_mode_scaling, &Recup_min_axe_gauche,&Recup_max_axe_gauche);
		diff_axe_gauche = Recup_max_axe_gauche -Recup_min_axe_gauche;
		SetCtrlVal (g->panelGraph, P_Graph_DIFF_VOIE_1_1, diff_axe_gauche);
		
		/* Ecriture diff axe min et max voie gauche */
		GetAxisScalingMode (g->panelGraph, P_Graph_GRAPH_3, VAL_LEFT_YAXIS,&Recup_mode_scaling, &Recup_min_axe_gauche,&Recup_max_axe_gauche);
		diff_axe_gauche = Recup_max_axe_gauche -Recup_min_axe_gauche;
		SetCtrlVal (g->panelGraph, P_Graph_DIFF_VOIE_1_2, diff_axe_gauche);
		
		
		// Configuration de l'axe de gauche
		GetCtrlAttribute (g->panelChoixAxe, P_Choix_RING_Choix_Echelle_G, ATTR_CTRL_INDEX, &Valeur_Choix_Echelle_Gauche);
		switch (Valeur_Choix_Echelle_Gauche) // Analyse de la configuration de l'axe de gauche
		{
			case 0: // Autoscale Voie de gauche
			
				SetAxisScalingMode (g->panelGraph, P_Graph_GRAPH, VAL_LEFT_YAXIS,VAL_AUTOSCALE, 0 /* inutilis */,0 /* inutilis */);
				break;
			
			case 1: // Manuelle axe gauche
			
				// Chargement des donnes dans les contrles
				err = GetCtrlVal (g->panelChoixAxe, P_Choix_NUM_Val_MIN_Gauche, &Valeur_MIN_Gauche);
				GetCtrlVal (g->panelChoixAxe, P_Choix_NUM_Val_MAX_Gauche, &Valeur_MAX_Gauche);

				if  (Valeur_MAX_Gauche>Valeur_MIN_Gauche) // on ne met l'chelle que si elle est possible
					SetAxisScalingMode (g->panelGraph, P_Graph_GRAPH, VAL_LEFT_YAXIS, VAL_MANUAL, Valeur_MIN_Gauche, Valeur_MAX_Gauche);
				break;
			
			case 2: // Centre Axe gauche
			
				GetCtrlVal (g->panelChoixAxe, P_Choix_NUM_Val_Centrage_G, &Valeur_Centrage_Gauche);
				Valeur_MAX_Gauche = buffer_lineaire[nbpointsgraph-1] + Valeur_Centrage_Gauche;
				Valeur_MIN_Gauche = buffer_lineaire[nbpointsgraph-1] - Valeur_Centrage_Gauche;
				if (Valeur_MIN_Gauche<Valeur_MAX_Gauche)	
					// Mise en place des axes centrs
					SetAxisScalingMode (g->panelGraph, P_Graph_GRAPH, VAL_LEFT_YAXIS, VAL_MANUAL, Valeur_MIN_Gauche, Valeur_MAX_Gauche);
	
				break;
			
		}
	}

		
	if (buffer_d != NULL) // Cet axe est initialis et on veut le tracer
	{
		// Activation de l'axe de Droite pour tracer
		SetCtrlAttribute (g->panelGraph, P_Graph_GRAPH, ATTR_ACTIVE_YAXIS, VAL_RIGHT_YAXIS);
		SetCtrlAttribute (g->panelGraph, P_Graph_GRAPH_2, ATTR_ACTIVE_YAXIS, VAL_RIGHT_YAXIS);
		SetCtrlAttribute (g->panelGraph, P_Graph_GRAPH_3, ATTR_ACTIVE_YAXIS, VAL_RIGHT_YAXIS);
						
		
		// Circulaire ->linaire droit
		Bcirc=buffer_d->mesure;
		deplacement=buffer_d->ptr_mobile;
		
		//copie de la partie ancienne
		memcpy (buffer_lineaire,
			Bcirc+deplacement,
			(nbpointsgraph-deplacement)*sizeof(double));
		//copie de la partie rcente
		memcpy (buffer_lineaire + (nbpointsgraph-deplacement),
			Bcirc,
			(deplacement)*sizeof(double));

		/* On trace la voie sur l'axe slectionn en haut*/
		g->handle_plot_droite   = PlotY (g->panelGraph, P_Graph_GRAPH, buffer_lineaire, nbpointsgraph, VAL_DOUBLE, VAL_THIN_LINE, VAL_EMPTY_SQUARE, VAL_SOLID, 1, g->color_right);
		g->handle_plot_droite_2 = PlotY (g->panelGraph, P_Graph_GRAPH_2, buffer_d->points_mid, nbpointsgraph, VAL_DOUBLE, VAL_THIN_LINE, VAL_EMPTY_SQUARE, VAL_SOLID, 1, g->color_right);	
		g->handle_plot_droite_3 = PlotY (g->panelGraph, P_Graph_GRAPH_3, buffer_d->points_long, nbpointsgraph, VAL_DOUBLE, VAL_THIN_LINE, VAL_EMPTY_SQUARE, VAL_SOLID, 1, g->color_right);	
		
		/* Ecriture diff axe min et max voie droite */
		GetAxisScalingMode (g->panelGraph, P_Graph_GRAPH, VAL_RIGHT_YAXIS,&Recup_mode_scaling, &Recup_min_axe_droite,&Recup_max_axe_droite);
		diff_axe_droite = Recup_max_axe_droite -Recup_min_axe_droite;
		SetCtrlVal (g->panelGraph, P_Graph_DIFF_VOIE_2, diff_axe_droite);
		
		/* Ecriture diff axe min et max voie gauche */
		GetAxisScalingMode (g->panelGraph, P_Graph_GRAPH_2, VAL_RIGHT_YAXIS,&Recup_mode_scaling, &Recup_min_axe_gauche,&Recup_max_axe_gauche);
		diff_axe_gauche = Recup_max_axe_gauche -Recup_min_axe_gauche;
		SetCtrlVal (g->panelGraph, P_Graph_DIFF_VOIE_2_1, diff_axe_gauche);
		
		/* Ecriture diff axe min et max voie gauche */
		GetAxisScalingMode (g->panelGraph, P_Graph_GRAPH_3, VAL_RIGHT_YAXIS,&Recup_mode_scaling, &Recup_min_axe_gauche,&Recup_max_axe_gauche);
		diff_axe_gauche = Recup_max_axe_gauche -Recup_min_axe_gauche;
		SetCtrlVal (g->panelGraph, P_Graph_DIFF_VOIE_2_2, diff_axe_gauche);
		
		
		
		// Configuration de l'axe de droite
		GetCtrlAttribute (g->panelChoixAxe, P_Choix_RING_Choix_Echelle_D, ATTR_CTRL_INDEX, &Valeur_Choix_Echelle_Droite);
		switch (Valeur_Choix_Echelle_Droite) // Analyse de la configuration de l'axe de Droite
		{
			case 0: // Autoscale Voie de Droite
			{
				// Activation de l'autoscale axe de Droite
				SetAxisScalingMode (g->panelGraph, P_Graph_GRAPH, VAL_RIGHT_YAXIS,VAL_AUTOSCALE, 0 /* inutilis */,0 /* inutilis */);
				break;
			}
			case 1: // Manuelle axe Droite
			{
				// Chargement des donnes dans les contrles
				GetCtrlVal (g->panelChoixAxe, P_Choix_NUM_Val_MIN_Droite, &Valeur_MIN_Droite);
				GetCtrlVal (g->panelChoixAxe, P_Choix_NUM_Val_MAX_Droite, &Valeur_MAX_Droite);
	
				if  (Valeur_MAX_Droite>Valeur_MIN_Droite) // on ne met l'chelle que si elle est possible
				/* Mise en place des axes manuels */ SetAxisScalingMode (g->panelGraph, P_Graph_GRAPH, VAL_RIGHT_YAXIS, VAL_MANUAL, Valeur_MIN_Droite, Valeur_MAX_Droite);
				break;
			}
			case 2: // Centre Axe Droite
			{
				GetCtrlVal (g->panelChoixAxe, P_Choix_NUM_Val_Centrage_D, &Valeur_Centrage_Droite);

				Valeur_MAX_Droite = buffer_lineaire[nbpointsgraph-1] + Valeur_Centrage_Droite;
				Valeur_MIN_Droite = buffer_lineaire[nbpointsgraph-1] - Valeur_Centrage_Droite;
				if  (Valeur_MAX_Droite>Valeur_MIN_Droite) // on ne met l'chelle que si elle est possible
					// Mise en place des axes centrs
					SetAxisScalingMode (g->panelGraph, P_Graph_GRAPH, VAL_RIGHT_YAXIS, VAL_MANUAL, Valeur_MIN_Droite, Valeur_MAX_Droite);
				break;
			}
		}
	}

	// libration de la mmoire du buffer linaire
	free(buffer_lineaire);
}

static void Ecriture_Tableau(int Total_Voie, ptr_buff_circu *buffer_circulaire)
{
	int nb_row;
	int cpt_voie;
	
	GetNumTableRows (panelTab, P_AFF_TAB_TABLE, &nb_row);

	if (nb_row > 500)
		DeleteTableRows (panelTab, P_AFF_TAB_TABLE, 1, 1);
		
	InsertTableRows (panelTab, P_AFF_TAB_TABLE, -1, 1, VAL_CELL_NUMERIC);
	
	SetCtrlAttribute (panelTab, P_AFF_TAB_TABLE, ATTR_FIRST_VISIBLE_ROW, nb_row);
	
	for (cpt_voie=0; cpt_voie<Total_Voie; cpt_voie++)
	{
		GetNumTableRows (panelTab, P_AFF_TAB_TABLE, &nb_row);
		SetTableCellVal (panelTab, P_AFF_TAB_TABLE, MakePoint(cpt_voie+1, nb_row), buffer_circulaire[cpt_voie].mesure[buffer_circulaire[cpt_voie].dernier_indice]);
	}

}

int CVICALLBACK Choix_Echelle_Gauche (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	int Valeur_Echelle_Gauche = 0;

	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal (panel, P_Choix_RING_Choix_Echelle_G, &Valeur_Echelle_Gauche);
			switch (Valeur_Echelle_Gauche)
				{
				case 1: SetCtrlAttribute (panel, P_Choix_NUM_Val_MIN_Gauche, ATTR_DIMMED, 1);
						SetCtrlAttribute (panel, P_Choix_NUM_Val_MAX_Gauche, ATTR_DIMMED, 1);
						SetCtrlAttribute (panel, P_Choix_NUM_Val_Centrage_G, ATTR_DIMMED, 1);
						break;
						
				case 2:	SetCtrlAttribute (panel, P_Choix_NUM_Val_MIN_Gauche, ATTR_DIMMED, 0);
						SetCtrlAttribute (panel, P_Choix_NUM_Val_MAX_Gauche, ATTR_DIMMED, 0);
						SetCtrlAttribute (panel, P_Choix_NUM_Val_Centrage_G, ATTR_DIMMED, 1);
						break;
						
				case 3:	SetCtrlAttribute (panel, P_Choix_NUM_Val_MIN_Gauche, ATTR_DIMMED, 1);
						SetCtrlAttribute (panel, P_Choix_NUM_Val_MAX_Gauche, ATTR_DIMMED, 1);
						SetCtrlAttribute (panel, P_Choix_NUM_Val_Centrage_G, ATTR_DIMMED, 0);
						break;
				}
			break;
	}
	return 0;
}

int CVICALLBACK Choix_Echelle_Droite (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	int Valeur_Echelle_Droite = 0;

	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal (panel, P_Choix_RING_Choix_Echelle_D, &Valeur_Echelle_Droite);
			switch (Valeur_Echelle_Droite)
				{
				case 1: SetCtrlAttribute (panel, P_Choix_NUM_Val_MIN_Droite, ATTR_DIMMED, 1);
						SetCtrlAttribute (panel, P_Choix_NUM_Val_MAX_Droite, ATTR_DIMMED, 1);
						SetCtrlAttribute (panel, P_Choix_NUM_Val_Centrage_D, ATTR_DIMMED, 1);
						break;
						
				case 2:	SetCtrlAttribute (panel, P_Choix_NUM_Val_MIN_Droite, ATTR_DIMMED, 0);
						SetCtrlAttribute (panel, P_Choix_NUM_Val_MAX_Droite, ATTR_DIMMED, 0);
						SetCtrlAttribute (panel, P_Choix_NUM_Val_Centrage_D, ATTR_DIMMED, 1);
						break;
						
				case 3:	SetCtrlAttribute (panel, P_Choix_NUM_Val_MIN_Droite, ATTR_DIMMED, 1);
						SetCtrlAttribute (panel, P_Choix_NUM_Val_MAX_Droite, ATTR_DIMMED, 1);
						SetCtrlAttribute (panel, P_Choix_NUM_Val_Centrage_D, ATTR_DIMMED, 0);
						break;
				}
			break;
	}
	return 0;
}

int CVICALLBACK Prog_Graph_Choix_Axe (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	LC_GRAPH* g = graphs;

	switch (event)
		{
		case EVENT_RIGHT_CLICK:
		
			while(g)
			{
				if( g->panelGraph == panel )
					DisplayPanel (g->panelChoixAxe);
					
				g = g->next;
			}
				
			
			break;
		}
	return 0;
}

int CVICALLBACK Choix_echelles (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	LC_GRAPH* g = graphs;


	switch (event)
	{
		case EVENT_COMMIT:
		
			HidePanel (panel);
			
			break;
	}
	return 0;
}

int CVICALLBACK CB_ring_color_left (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int i_tmp;
	
	LC_GRAPH* g = graphs;

	switch (event)
		{
		case EVENT_COMMIT:
			
			GetCtrlVal(panel,control,&i_tmp);

			while(g)
			{
				if( g->panelGraph == panel )
				{
					g->color_left = i_tmp;
					
					SetCtrlAttribute(g->panelGraph,P_Graph_TRACE_GAUCHE,ATTR_LABEL_COLOR,i_tmp);
					SetCtrlAttribute(g->panelGraph,P_Graph_TRACE_GAUCHE,ATTR_TEXT_COLOR,i_tmp);
					SetCtrlAttribute(g->panelGraph,P_Graph_DIFF_VOIE_1_2,ATTR_LABEL_COLOR,i_tmp);
					SetCtrlAttribute(g->panelGraph,P_Graph_DIFF_VOIE_1_2,ATTR_TEXT_COLOR,i_tmp);
					SetCtrlAttribute(g->panelGraph,P_Graph_DIFF_VOIE_1_1,ATTR_LABEL_COLOR,i_tmp);
					SetCtrlAttribute(g->panelGraph,P_Graph_DIFF_VOIE_1_1,ATTR_TEXT_COLOR,i_tmp);
					SetCtrlAttribute(g->panelGraph,P_Graph_DIFF_VOIE_1,ATTR_LABEL_COLOR,i_tmp);
					SetCtrlAttribute(g->panelGraph,P_Graph_DIFF_VOIE_1,ATTR_TEXT_COLOR,i_tmp);
					
					
				}
				
				g = g->next;
			}

			break;
		}
	return 0;
}

int CVICALLBACK CB_ring_color_right (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int i_tmp;

	LC_GRAPH* g = graphs;

	switch (event)
		{
		case EVENT_COMMIT:
			
			GetCtrlVal(panel,control,&i_tmp);

			while(g)
			{
				if( g->panelGraph == panel )
				{
					g->color_right = i_tmp;
				
					SetCtrlAttribute(g->panelGraph,P_Graph_TRACE_DROIT,ATTR_LABEL_COLOR,i_tmp);
					SetCtrlAttribute(g->panelGraph,P_Graph_TRACE_DROIT,ATTR_TEXT_COLOR,i_tmp);
					SetCtrlAttribute(g->panelGraph,P_Graph_DIFF_VOIE_2_2,ATTR_LABEL_COLOR,i_tmp);
					SetCtrlAttribute(g->panelGraph,P_Graph_DIFF_VOIE_2_2,ATTR_TEXT_COLOR,i_tmp);
					SetCtrlAttribute(g->panelGraph,P_Graph_DIFF_VOIE_2_1,ATTR_LABEL_COLOR,i_tmp);
					SetCtrlAttribute(g->panelGraph,P_Graph_DIFF_VOIE_2_1,ATTR_TEXT_COLOR,i_tmp);
					SetCtrlAttribute(g->panelGraph,P_Graph_DIFF_VOIE_2,ATTR_LABEL_COLOR,i_tmp);
					SetCtrlAttribute(g->panelGraph,P_Graph_DIFF_VOIE_2,ATTR_TEXT_COLOR,i_tmp);
				}
				
				
				g = g->next;
			}

			break;
		}
	return 0;
}

int CVICALLBACK CB_panel_graph (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:

			break;
		}
	return 0;
}
