#include "toolbox.h"
#include <utility.h>
#include <userint.h>
#include <ansi_c.h>
#include "liste.h"
#include "plugin.h"
#include "Interface.h" // pour accder aux lments graphiques: remplir_liste_instru / mode_boutons_*
#include "graph3D.h"
#include "graphtab.h"

#define TAILLE_NOM_LOCK 20

// Variables globales: peut mieux faire
int nbpointsgraph;
int sous_ech_2D;

static time_t debut_ecriture;
static time_t heure_echantillon;

static ptr_buff_circu *buffer_circulaire = NULL;
static ptr_buff2D_circu *buffer2D_circulaire = NULL;

static int Total_Voie = 0, nb_voie2D = 0;

static int unique = 0;

static int Lock_gestion_lock = 0; // sisi, un lock pour gerer les locks :)

static char marqueur_fichier[255];

static FILE *fichierdonnees;

//
int diviseur_short_mid = 2; // diviseur court vers moyen terme
int diviseur_mid_long = 5; // diviseur moyen vers long terme.



// En attendant les DLL:
// On cre les listes d'instruments en dur.
// On declare les structures modles (freq, freq2v...) en extern dans le .h (elles sont dfinies dans le .c du plugin)
// On associe le "type" d'instrument "Frquencemtre"  un identifiant (5313x_1v.dll)

// lock port parallele  modifier aussi (gestion_lock)
PInstrument *Nouvel_instrument(char *chaine)
{					
	PInstrument *instrument = NULL;
	if (strcmp (chaine,"5313x_1v.dll") == 0) freq.nouveau(&instrument);
	if (strcmp (chaine,"5313x_2v.dll") == 0) freq2v.nouveau(&instrument);
	if (strcmp (chaine, "5313x_sw.dll") == 0) freq_sw.nouveau(&instrument);
	if (strcmp (chaine, "4419.dll") == 0) power_simple.nouveau(&instrument);
	if (strcmp (chaine, "4419_sw.dll") == 0) power_switch.nouveau(&instrument);
	if (strcmp (chaine, "cred.dll") == 0) cred_4v.nouveau(&instrument);
	if (strcmp (chaine, "multimetre.dll") == 0) multi.nouveau(&instrument);
	
	if (strcmp (chaine, "pilote_bidon.dll") == 0) pilote_bidon.nouveau(&instrument);
	if (strcmp (chaine, "therm.dll") == 0) enc_ther.nouveau(&instrument);
	if (strcmp (chaine, "efd.dll") == 0) pilote_valve.nouveau(&instrument);

	if (strcmp (chaine, "Calculatrice.dll") == 0) Calculatrice.nouveau(&instrument);
	if (strcmp (chaine, "reboucleur.dll") == 0) boucleur.nouveau(&instrument);
	if (strcmp (chaine, "extremum.dll") == 0) calcul_extremum.nouveau(&instrument);
	if (strcmp (chaine, "stddev.dll") == 0) calcul_moy_stddev.nouveau(&instrument);

	if (strcmp (chaine, "tektro3052.dll") == 0) tek.nouveau(&instrument);
	if (strcmp (chaine, "bode_hp4194.dll") == 0) bode_hp.nouveau(&instrument);
	if (strcmp (chaine, "Analyseur_reseau.dll") == 0) anritsu.nouveau(&instrument);	

	if (strcmp (chaine, "fitter.dll") == 0)	fitter.nouveau(&instrument);
		
	if (strcmp (chaine, "Regul_Acoustic.dll") == 0) Regul_Acoustic.nouveau(&instrument);	
	if (strcmp (chaine, "Pousse_Seringue.dll") == 0) Pousse_Seringue.nouveau(&instrument);	
	if (strcmp (chaine, "Pompe_Ismatec.dll") == 0) Pompe_Ismatec.nouveau(&instrument);	
	if (strcmp (chaine, "Electrovanne.dll") == 0) Electrovanne.nouveau(&instrument);	
	if (strcmp (chaine, "GBF_HP3312A.dll") == 0) GBF_HP3312A.nouveau(&instrument);	
	if (strcmp (chaine, "HP53131_phase.dll") == 0) HP53131_phase.nouveau(&instrument);	
	if (strcmp (chaine, "DGM110.dll") == 0) DGM110.nouveau(&instrument);	
//@@@	if (strcmp (chaine, "@@NOM_C@@.dll") == 0) @@NOM_C@@.nouveau(&instrument);	

	if (instrument==NULL) return NULL;
	instrument->gestion_lock = gestion_lock;
	instrument->init_liste_voie = init_liste_voie;
	instrument->get_buffer_from_tatoo = get_buffer_from_tatoo;
	instrument->init_liste_voie2D = init_liste_voie2D;
	instrument->get_buffer2D_from_tatoo = get_buffer2D_from_tatoo;
	return instrument;
}
void remplir_liste_instru(int panel)
{
	ClearListCtrl (panel, PANEL_Ajou_RING_Ajou_Type);
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Frquencemtre", "5313x_1v.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Frquencemtre 2 Voies", "5313x_2v.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Frquencemtre Switch", "5313x_sw.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Powermeter", "4419.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Powermeter Switch", "4419_sw.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Carte CRED", "cred.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Multimtre HP34401", "multimetre.dll");

	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "------------------", "");
	
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Valve EFD", "efd.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Enceinte thermique", "therm.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Pilote bidon", "pilote_bidon.dll");

	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "------------------", "");
	
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Calculatrice", "Calculatrice.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Reboucleur", "reboucleur.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Dtecteur d'extremum", "extremum.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Calcul de statistiques", "stddev.dll");

	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "------------------", "");
	
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Tektronix TDS 3052", "tektro3052.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "HP 4194 (bodemtre)", "bode_hp4194.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Anritsu MS4623B", "Analyseur_reseau.dll");
	
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "------------------", "");

	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Fitter de courbes", "fitter.dll");
	
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "------------------", "");
	
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Regul Acoustic", "Regul_Acoustic.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Pousse Seringue", "Pousse_Seringue.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Pompe Ismatec", "Pompe_Ismatec.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "Electrovanne", "Electrovanne.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "GBF HP3312A", "GBF_HP3312A.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "HP53131 - phase", "HP53131_phase.dll");
	//InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "rheometre temperature", "rheometre_temperature.dll");
	//InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "rheometre temperature", "rheometre_temperature.dll");
	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "DGM (retour infos)", "DGM110.dll");
//@@@	InsertListItem (panel, PANEL_Ajou_RING_Ajou_Type, -1, "@@NOM@@", "@@NOM_C@@.dll");
	
	
}
// Fin d'attente des DLL

void init_tatoo(int init_unique)
{
	unique = init_unique;
}

int get_tatoo(void)
{
	return unique++;
}

int status_tatoo(void)
{
	return unique;
}

ptr_buff_circu *get_buffer_from_tatoo(char *tatoo_voie)
{
	int tatoo, voie;
	int cpt_voie;
	if (sscanf(tatoo_voie, "%i;%i", &tatoo, &voie) != 2)
		return NULL;
	
	for (cpt_voie=0; cpt_voie<Total_Voie; cpt_voie++)
	{
		if ( (buffer_circulaire[cpt_voie].tatoo == tatoo) && (buffer_circulaire[cpt_voie].voie == voie) )
			return &buffer_circulaire[cpt_voie];
	}
	return NULL;
}

ptr_buff2D_circu *get_buffer2D_from_tatoo(char *tatoo_voie)
{
	int tatoo, voie;
	int cpt_voie;
	if (sscanf(tatoo_voie, "%i;%i", &tatoo, &voie) != 2)
		return NULL;
	
	for (cpt_voie=0; cpt_voie<nb_voie2D; cpt_voie++)
	{
		if ( (buffer2D_circulaire[cpt_voie].tatoo == tatoo) && (buffer2D_circulaire[cpt_voie].voie == voie) )
			return &buffer2D_circulaire[cpt_voie];
	}
	return NULL;
}

tmaillon *Inserer_instru(tmaillon *list_instru, char *Type_App, PInstrument *structu_inst, int tatoo)
{
	tmaillon *nouveaumaillon;
	tmaillon *list_locale;
	
	nouveaumaillon = (tmaillon *)malloc(sizeof(tmaillon));

	sprintf(nouveaumaillon->Type_Apareil, "%s", Type_App);
	nouveaumaillon->plugin = structu_inst;
	nouveaumaillon->suivant = NULL;
	nouveaumaillon->tatoo = tatoo; // sert  identifier de manire unique les instruments (et les voies par consquence)
	nouveaumaillon->fichier = NULL;
	
	if (list_instru == NULL)
	{
		return nouveaumaillon;
	}
	else
	{
		list_locale = list_instru;
		while (list_locale->suivant != NULL)
			list_locale = list_locale->suivant;
		
		list_locale->suivant = nouveaumaillon;
		return list_instru;
	}
}

tmaillon *Supprimer_instru (tmaillon *list_instru, tmaillon *repere_suppr)
{
	tmaillon *sauvegarde = NULL;
	tmaillon *list_debut = NULL;

	list_debut = list_instru;
	while (list_instru) // On parcourt la liste
	{
		if (list_instru == repere_suppr) // c'est le premier maillon qu'il faut supprimer
		{
			sauvegarde = repere_suppr->suivant;
			repere_suppr->plugin->liberer(repere_suppr->plugin); // liberation de l'instrument
			free (repere_suppr); // libration du maillon
			return sauvegarde;
		}
		
		if (list_instru->suivant == repere_suppr) // c'est un autre maillon qu'il faut supprimer
		{
			list_instru->suivant = repere_suppr->suivant; // On dechaine le maillon  supprimer
			repere_suppr->plugin->liberer(repere_suppr->plugin); // liberation de l'instrument
			free (repere_suppr); // libration du maillon
			return list_debut;
		}
		list_instru = list_instru->suivant;
	}
	return 0;
}

tmaillon *Effacer_liste_inst (tmaillon *list_instru)
{
	tmaillon *sauvegarde = NULL;

	if (list_instru == NULL)
		return 0;
	else
	{
		sauvegarde = list_instru->suivant;
		list_instru->plugin->liberer(list_instru->plugin);
		free (list_instru);
		return Effacer_liste_inst (sauvegarde);
	}
}

void arret_instru(tmaillon *list_acq)
{
	while (list_acq)
	{
		if (list_acq->plugin->stop)
			list_acq->plugin->stop(list_acq->plugin);
		list_acq = list_acq->suivant;
	}
}

int Ouvrir_enregistrement(char *nom_fichier, tmaillon *list_ac)
{
	char nom_voie[TAILLE_NOM_VOIE];
	char nom_instru[TAILLE_NOM_INSTRU];
	char nom_fichier2[MAX_PATHNAME_LEN];
	char *char_point;
	int voie, err, taille_voie;
	
	tmaillon *list_acq = list_ac; // indispensable, on parcourt plusieurs fois !

	err = 0;
	time(&debut_ecriture);
	
	if (fichierdonnees != NULL)
		fclose(fichierdonnees); // TODO: ouverture sans avoir ferm, erreur ou pas ?
		
	fichierdonnees = fopen(nom_fichier, "w");
	if (fichierdonnees == NULL)
		err--;
	else
	{
		fprintf (fichierdonnees,"Date\tHeure\tMarqueur\tDure coule");

		// Voies mesures
		while (list_acq)
		{
			list_acq->plugin->get_nom_instru(list_acq->plugin, nom_instru);
			if (list_acq->plugin->nb_voie_1D && list_acq->plugin->get_nom_voie_1D &&
				list_acq->plugin->mesure_1D && list_acq->plugin->numero_1D)
				for (voie=1; voie<=list_acq->plugin->nb_voie_1D(list_acq->plugin); voie++)
				{
					list_acq->plugin->get_nom_voie_1D(list_acq->plugin, voie, nom_voie);
					fprintf (fichierdonnees, "\t%s %s\tMesure n", nom_instru, nom_voie);
				}
			list_acq = list_acq->suivant;
		}

		// Voies calcules
		list_acq = list_ac;
		while (list_acq)
		{
			list_acq->plugin->get_nom_instru(list_acq->plugin, nom_instru);
			if (list_acq->plugin->nb_voie_calcul && list_acq->plugin->get_nom_voie_calcul &&
				list_acq->plugin->mesure_calcul && list_acq->plugin->calculer_1D)
				for (voie=1; voie<=list_acq->plugin->nb_voie_calcul(list_acq->plugin); voie++)
				{
					list_acq->plugin->get_nom_voie_calcul(list_acq->plugin, voie, nom_voie);
					fprintf (fichierdonnees, "\t%s %s", nom_instru, nom_voie);
				}
			list_acq = list_acq->suivant;
		}
	
		fprintf (fichierdonnees, "\n");
	}

////////////////
// Donnes 2D //
////////////////
	char_point = strrchr(nom_fichier, '.');
	if (char_point != NULL) // prcaution a priori inutile
		*char_point = NULL;
	
	list_acq = list_ac;
	while (list_acq) // Instruments
	{
		if ( (list_acq->plugin->nb_voie2D && list_acq->plugin->get_taille_voie2D &&
			list_acq->plugin->indices2D && list_acq->plugin->mesure2D) ||
			(list_acq->plugin->nb_voie_calcul2D && list_acq->plugin->get_nom_voie_calcul_2D &&
			list_acq->plugin->get_taille_voie_calcul2D && list_acq->plugin->calcul2D &&
			list_acq->plugin->i_calcul2D && list_acq->plugin->calculer_2D) )
		{
			list_acq->plugin->get_nom_instru(list_acq->plugin, nom_instru);
			sprintf(nom_fichier2, "%s-%s.%s", nom_fichier, nom_instru, char_point+1);
		
			list_acq->fichier = fopen(nom_fichier2, "wb");
			if (list_acq->fichier == NULL)
				err--;
			else
			{
				fprintf (list_acq->fichier, "Date\tHeure\tDure coule\tMarqueur");
				// Mesures
				if (list_acq->plugin->nb_voie2D && list_acq->plugin->get_taille_voie2D &&
						list_acq->plugin->indices2D && list_acq->plugin->mesure2D)
					for (voie=1; voie<=list_acq->plugin->nb_voie2D(list_acq->plugin); voie++)
					{
						list_acq->plugin->get_nom_voie2D(list_acq->plugin, voie, nom_voie);
						taille_voie = list_acq->plugin->get_taille_voie2D(list_acq->plugin, voie);
						fprintf(list_acq->fichier, "\tIndices %s [%i]", nom_voie, taille_voie);
						fprintf(list_acq->fichier, "\tMesure %s [%i]", nom_voie, taille_voie);
					}
				// Calculs
				if (list_acq->plugin->nb_voie_calcul2D && list_acq->plugin->get_nom_voie_calcul_2D &&
						list_acq->plugin->get_taille_voie_calcul2D && list_acq->plugin->calcul2D &&
						list_acq->plugin->i_calcul2D && list_acq->plugin->calculer_2D)
					for (voie=1; voie<=list_acq->plugin->nb_voie_calcul2D(list_acq->plugin); voie++)
					{
						list_acq->plugin->get_nom_voie_calcul_2D(list_acq->plugin, voie, nom_voie);
						taille_voie = list_acq->plugin->get_taille_voie_calcul2D(list_acq->plugin, voie);
						fprintf(list_acq->fichier, "\tIndices %s [%i]", nom_voie, taille_voie);
						fprintf(list_acq->fichier, "\tMesure %s [%i]", nom_voie, taille_voie);
					}
				fprintf (list_acq->fichier, "\n");
			}
		} else
			list_acq->fichier = NULL;
		list_acq = list_acq->suivant;
	}
	return err;
}

void Fermer_enregistrement(tmaillon *list_wave)
{
	if (fichierdonnees != NULL)
		fclose(fichierdonnees);
	fichierdonnees=NULL;

	while (list_wave)
	{
		if (list_wave->fichier != NULL)
			fclose(list_wave->fichier);
		list_wave->fichier = NULL;
		list_wave = list_wave->suivant;
	}
}

int mettre_donnees_dans_Bcirc(tmaillon *list_result)
{
	int voie=0, Cpt_Voie=0;
	
	if (buffer_circulaire == NULL)
		return 0;
	if (buffer_circulaire[0].mesure == NULL)
		return 0;

	/////////////
	// Mesures //
	/////////////
	while (list_result)
	{
		if (list_result->plugin->nb_voie_1D && list_result->plugin->get_nom_voie_1D &&
			list_result->plugin->mesure_1D && list_result->plugin->numero_1D)
			for (voie=0;voie<list_result->plugin->nb_voie_1D(list_result->plugin);voie++)
			{
				buffer_circulaire[Cpt_Voie].dernier_indice = buffer_circulaire[Cpt_Voie].ptr_mobile;
				buffer_circulaire[Cpt_Voie].mesure[buffer_circulaire[Cpt_Voie].ptr_mobile] = list_result->plugin->mesure_1D(list_result->plugin,voie+1);
				buffer_circulaire[Cpt_Voie].numero[buffer_circulaire[Cpt_Voie].ptr_mobile] = list_result->plugin->numero_1D(list_result->plugin,voie+1);
				buffer_circulaire[Cpt_Voie].ptr_mobile++;
				if (buffer_circulaire[Cpt_Voie].ptr_mobile >= buffer_circulaire[Cpt_Voie].profondeur)
					buffer_circulaire[Cpt_Voie].ptr_mobile = 0;
				Cpt_Voie++;
			}
	
		list_result = list_result->suivant;
	}
	return Cpt_Voie;
}

void mettre_calculs_dans_Bcirc(int Cpt_Voie, tmaillon *list_cal)
{
	int voie=0;

	if (buffer_circulaire == NULL)
		return;
	if (buffer_circulaire[0].mesure == NULL)
		return;
		
	while (list_cal) // On rcupre les calculs
	{
		if (list_cal->plugin->nb_voie_calcul && list_cal->plugin->get_nom_voie_calcul &&
			list_cal->plugin->mesure_calcul && list_cal->plugin->calculer_1D)
			for (voie=0;voie<list_cal->plugin->nb_voie_calcul(list_cal->plugin);voie++)
			{
				buffer_circulaire[Cpt_Voie].dernier_indice = buffer_circulaire[Cpt_Voie].ptr_mobile;
				buffer_circulaire[Cpt_Voie].mesure[buffer_circulaire[Cpt_Voie].ptr_mobile] = list_cal->plugin->mesure_calcul(list_cal->plugin,voie+1);
				buffer_circulaire[Cpt_Voie].numero[0]++; // les plugins de calcul n'ont pas de numero vu que (au moins pour l'instant) ca n'a pas de sens
				buffer_circulaire[Cpt_Voie].numero[buffer_circulaire[Cpt_Voie].ptr_mobile] = buffer_circulaire[Cpt_Voie].numero[0];
				buffer_circulaire[Cpt_Voie].ptr_mobile++;
				if (buffer_circulaire[Cpt_Voie].ptr_mobile >= buffer_circulaire[Cpt_Voie].profondeur)
					buffer_circulaire[Cpt_Voie].ptr_mobile = 0;
				Cpt_Voie++;
			}
		list_cal = list_cal->suivant;
	}
	
}

int mettre_donnees2D_dans_Bcirc2D(tmaillon *list_inst)
{
	int voie, Cpt_Voie2D=0;
	
	if (buffer2D_circulaire == NULL)
		return 0;
	
	while (list_inst) // Instruments
	{
		if (list_inst->plugin->nb_voie2D && list_inst->plugin->mesure2D &&
			list_inst->plugin->indices2D && list_inst->plugin->numero2D)
			for (voie=0; voie<list_inst->plugin->nb_voie2D(list_inst->plugin); voie++)
			{
				buffer2D_circulaire[Cpt_Voie2D].dernier_indice = buffer2D_circulaire[Cpt_Voie2D].ptr_mobile;
				list_inst->plugin->mesure2D(list_inst->plugin, voie+1, buffer2D_circulaire[Cpt_Voie2D].mesure[buffer2D_circulaire[Cpt_Voie2D].ptr_mobile]);
				list_inst->plugin->indices2D(list_inst->plugin, voie+1, buffer2D_circulaire[Cpt_Voie2D].indices[buffer2D_circulaire[Cpt_Voie2D].ptr_mobile]);
				buffer2D_circulaire[Cpt_Voie2D].numero[buffer2D_circulaire[Cpt_Voie2D].ptr_mobile] = list_inst->plugin->numero2D(list_inst->plugin, voie+1);
				buffer2D_circulaire[Cpt_Voie2D].ptr_mobile++;
				if (buffer2D_circulaire[Cpt_Voie2D].ptr_mobile >= HISTORIQUE_2D)
					buffer2D_circulaire[Cpt_Voie2D].ptr_mobile = 0;
				Cpt_Voie2D++;
			}
			list_inst = list_inst->suivant;
	}
	return Cpt_Voie2D;
}

void mettre_calculs2D_dans_Bcirc2D(int Cpt_Voie2D, tmaillon *list_inst)
{
	int voie; //, Cpt_Voie2D=0;
	
	if (buffer2D_circulaire == NULL)
		return;
	
	while (list_inst) // Instruments
	{
		if (list_inst->plugin->get_nom_instru && list_inst->plugin->nb_voie_calcul2D &&
			list_inst->plugin->get_nom_voie_calcul_2D && list_inst->plugin->get_taille_voie_calcul2D &&
			list_inst->plugin->calcul2D && list_inst->plugin->i_calcul2D)
			for (voie=0; voie<list_inst->plugin->nb_voie_calcul2D(list_inst->plugin); voie++)
			{
				buffer2D_circulaire[Cpt_Voie2D].dernier_indice = buffer2D_circulaire[Cpt_Voie2D].ptr_mobile;
				list_inst->plugin->calcul2D(list_inst->plugin, voie+1, buffer2D_circulaire[Cpt_Voie2D].mesure[buffer2D_circulaire[Cpt_Voie2D].ptr_mobile]);
				list_inst->plugin->i_calcul2D(list_inst->plugin, voie+1, buffer2D_circulaire[Cpt_Voie2D].indices[buffer2D_circulaire[Cpt_Voie2D].ptr_mobile]);
				//buffer2D_circulaire[Cpt_Voie2D].numero[buffer2D_circulaire[Cpt_Voie2D].ptr_mobile] = list_inst->plugin->numero2D(list_inst->plugin, voie+1);
				buffer2D_circulaire[Cpt_Voie2D].ptr_mobile++;
				if (buffer2D_circulaire[Cpt_Voie2D].ptr_mobile >= HISTORIQUE_2D)
					buffer2D_circulaire[Cpt_Voie2D].ptr_mobile = 0;
				Cpt_Voie2D++;
			}
			list_inst = list_inst->suivant;
	}
}

void lancer_calculs_1D(tmaillon *list_cal2)
{
	if (buffer_circulaire == NULL)
		return;
	if (buffer_circulaire[0].mesure == NULL)
		return;

	while (list_cal2) // On lance les calculs
	{
		if (list_cal2->plugin->calculer_1D)
			list_cal2->plugin->calculer_1D(list_cal2->plugin);//, buffer_circulaire, buffer2D_circulaire);
		list_cal2 = list_cal2->suivant;
	}
}

void lancer_calculs_2D(tmaillon *list_cal2)
{
	if (buffer2D_circulaire == NULL)
		return;
	if (buffer2D_circulaire[0].mesure == NULL)
		return;

	while (list_cal2) // On lance les calculs
	{
		if (list_cal2->plugin->calculer_2D)
			list_cal2->plugin->calculer_2D(list_cal2->plugin); //, buffer_circulaire, buffer2D_circulaire);
		list_cal2 = list_cal2->suivant;
	}
}

void Marquer_donnees(char *chaine2, int panel, int control)
{
	char chaine[255];
	strncpy(chaine, chaine2, 254);
	sprintf(marqueur_fichier, chaine);
	SetCtrlVal(panel, control, chaine);
}

void Ecriture_donnees(tmaillon *list_resul)
{
	static int ech_2D =0;
	char *heure;
	char *date;	
	int voie, taille_voie;
	double *tabdouble;
	tmaillon *list_result = list_resul; // indispensable, on parcourt plusieurs fois !

	date = DateStr ();
	heure = TimeStr ();

	////////////////
	// Donnes 1D //
	////////////////
	if (fichierdonnees != NULL)
	{
		fprintf (fichierdonnees, "%s\t%s", date, heure);
	
		// Le marqueur
		fprintf(fichierdonnees, "\t%s", marqueur_fichier);
		
		// Temps coul depuis l'ouverture du fichier en criture
		fprintf (fichierdonnees,"\t%i",heure_echantillon-debut_ecriture);
	
		// Voies mesures
		while (list_result)
		{
			if (list_result->plugin->nb_voie_1D && list_result->plugin->get_nom_voie_1D &&
				list_result->plugin->mesure_1D && list_result->plugin->numero_1D)
				for (voie=1;voie<=list_result->plugin->nb_voie_1D(list_result->plugin);voie++)
					if(fabs(list_result->plugin->mesure_1D(list_result->plugin,voie))>1)
						fprintf (fichierdonnees,"\t%f\t%u",
							list_result->plugin->mesure_1D(list_result->plugin,voie),
							list_result->plugin->numero_1D(list_result->plugin,voie));
					else
						fprintf (fichierdonnees,"\t%e\t%u",
							list_result->plugin->mesure_1D(list_result->plugin,voie),
							list_result->plugin->numero_1D(list_result->plugin,voie));
				
			list_result = list_result->suivant;
		}
		// Voies calcules
		list_result = list_resul;
		while (list_result)
		{
			if (list_result->plugin->nb_voie_calcul && list_result->plugin->get_nom_voie_calcul &&
				list_result->plugin->mesure_calcul && list_result->plugin->calculer_1D)
				for (voie=1;voie<=list_result->plugin->nb_voie_calcul(list_result->plugin);voie++)
					if(fabs(list_result->plugin->mesure_calcul(list_result->plugin,voie))>1)
						fprintf (fichierdonnees,"\t%f", list_result->plugin->mesure_calcul(list_result->plugin,voie));
					else
						fprintf (fichierdonnees,"\t%e", list_result->plugin->mesure_calcul(list_result->plugin,voie));
			list_result = list_result->suivant;
		}
		
		fprintf (fichierdonnees,"\n");
	}


////////////////
// Donnes 2D //
////////////////

	ech_2D++;
	if ( (ech_2D % sous_ech_2D) != 0) return;
	
	list_result = list_resul; // on reparcourt
	while (list_result) // Instruments
	{
		if (list_result->fichier != NULL)
		{
			fprintf (list_result->fichier, "%s\t%s", date, heure);
			fprintf (list_result->fichier,"\t%i",heure_echantillon-debut_ecriture);
			fprintf (list_result->fichier, "\t%s", marqueur_fichier);
			fprintf (list_result->fichier, "\n");
			// 1 ligne tout
			
			// mesures
			if (list_result->plugin->nb_voie2D && list_result->plugin->get_taille_voie2D &&
					list_result->plugin->indices2D && list_result->plugin->mesure2D)
				for (voie=1; voie<=list_result->plugin->nb_voie2D(list_result->plugin); voie++)
				{
					taille_voie = list_result->plugin->get_taille_voie2D(list_result->plugin, voie);
					tabdouble = malloc(taille_voie*sizeof(double));
				
					list_result->plugin->indices2D(list_result->plugin, voie, tabdouble);
					fwrite (tabdouble, sizeof(double), taille_voie, list_result->fichier);
				
					list_result->plugin->mesure2D(list_result->plugin, voie, tabdouble);
					fwrite (tabdouble, sizeof(double), taille_voie, list_result->fichier);
				
					free(tabdouble);
				}

			// calculs
			if (list_result->plugin->nb_voie_calcul2D && list_result->plugin->get_nom_voie_calcul_2D &&
					list_result->plugin->get_taille_voie_calcul2D && list_result->plugin->calcul2D &&
					list_result->plugin->i_calcul2D && list_result->plugin->calculer_2D)
				for (voie=1; voie<=list_result->plugin->nb_voie_calcul2D(list_result->plugin); voie++)
				{
					taille_voie = list_result->plugin->get_taille_voie_calcul2D(list_result->plugin, voie);
					tabdouble = malloc(taille_voie*sizeof(double));
				
					list_result->plugin->i_calcul2D(list_result->plugin, voie, tabdouble);
					fwrite (tabdouble, sizeof(double), taille_voie, list_result->fichier);
				
					list_result->plugin->calcul2D(list_result->plugin, voie, tabdouble);
					fwrite (tabdouble, sizeof(double), taille_voie, list_result->fichier);
				
					free(tabdouble);
				}

		}
		list_result = list_result->suivant;
	}
}

void Echantilloner(tmaillon *list_result)
{
	int cpt_voie, cpt2D;
	
	time(&heure_echantillon); // Heure de l'chantillonage ( quelques ms prs)
	
	cpt2D = mettre_donnees2D_dans_Bcirc2D(list_result);
	
	// cpt_voie est une ruse pour reperer facilement  quel indice
	// dans buffer_circu se trouvent les (premiers) calculs
	// On suppose donc que les (voies de) calculs sont en dernier (amen)
	cpt_voie = mettre_donnees_dans_Bcirc(list_result);
	
	lancer_calculs_1D(list_result);
	lancer_calculs_2D(list_result);

	mettre_calculs_dans_Bcirc(cpt_voie, list_result);
	mettre_calculs2D_dans_Bcirc2D(cpt2D, list_result);
	
	generer_graphes_moyens();
}

void generer_graphes_moyens()
{

	int i,cpt;
	
	double* Bcirc = NULL;
	double* buffer_lineaire = NULL;
	
	double* data_mid = NULL;
	double* data_long = NULL;
	
	int deplacement;

	int delta_t;
	
	double M;
	
	
	buffer_lineaire = (double*)malloc(nbpointsgraph*sizeof(double));
	memset(buffer_lineaire, 0, nbpointsgraph*sizeof(double));
	
	for(cpt=0;cpt<Total_Voie;cpt++)
	{

		data_mid = buffer_circulaire[cpt].points_mid;
		data_long = buffer_circulaire[cpt].points_long;

		// Circulaire ->linaire droit
		Bcirc=buffer_circulaire[cpt].mesure;
		deplacement=buffer_circulaire[cpt].ptr_mobile;

		//copie de la partie ancienne
		memcpy (buffer_lineaire,
			Bcirc+deplacement,
			(nbpointsgraph-deplacement)*sizeof(double));
		//copie de la partie rcente
		memcpy (buffer_lineaire + (nbpointsgraph-deplacement),
			Bcirc,
			(deplacement)*sizeof(double));
			
		// Graphe GAUCHE / MOYEN
		if( ++(buffer_circulaire[cpt].cpt_mid) >= diviseur_short_mid )
		{
			buffer_circulaire[cpt].cpt_mid=0;
			
			M=0;
			delta_t = diviseur_short_mid;
		
			// On calcule la moyenne des delta_t derniers points.
			for(i=0;i<delta_t;i++)
				M += *(buffer_lineaire + nbpointsgraph - i - 1);
			
			M /= (double)delta_t;
			
			// On dcale le buffer vers la gauche. ( i <- i+1 )
			for(i=0;i<nbpointsgraph-1; i++)
				data_mid[i] = data_mid[i+1];
			
			// On place le nouveau point au bout.
			*(data_mid + nbpointsgraph - 1) = M;
		
			// Graphe GAUCHE / LONG
			if( ++(buffer_circulaire[cpt].cpt_long) >= diviseur_mid_long )
			{
				buffer_circulaire[cpt].cpt_long=0;
			
				M=0;
				delta_t = diviseur_mid_long;
		
				// On calcule la moyenne des delta_t derniers points.
				for(i=0;i<delta_t;i++)
					M += *(data_mid + nbpointsgraph - i - 1);
			
				M /= (double)delta_t;
			
				// On dcale le buffer vers la gauche. ( i <- i+1 )
				for(i=0;i<nbpointsgraph-1; i++)
					data_long[i] = data_long[i+1];
			
				// On place le nouveau point au bout.
				*(data_long + nbpointsgraph - 1) = M;
			}
		}
			
	}

	free(buffer_lineaire);

	return;
}

void Visu(void)
{
	if ( (buffer_circulaire != NULL) && (buffer_circulaire[0].mesure != NULL) )
	{
		Visu2D(Total_Voie, buffer_circulaire);
	}
	
	if (buffer2D_circulaire != NULL)
		Visu3D(buffer2D_circulaire);
}

void Init3D(void)
{
	if (nb_voie2D)
		InitGraph3D(nb_voie2D);
}
void Discard3D(void)
{
	if (nb_voie2D)
	DiscardGraph3D();
}

void Init2D(int nb_graphes)
{
	if (Total_Voie > 0)
		Init_graphtab(Total_Voie, nb_graphes, buffer_circulaire);
}

void MAJ2D(int n)
{
	if (Total_Voie > 0)
		MAJ_graphs(n,nbpointsgraph);
}

void Discard2D(void)
{
	if (Total_Voie > 0)
		DiscardGraphTab();
}

void init_liste_voie(int panel, int control_id)
{
	int cpt_voie;
	char tatoo_voie[30];
	
	ClearListCtrl (panel, control_id); // Efface tous les lments du ring
	InsertListItem (panel, control_id, -1, "(aucun)", ""); // Insre un tatoo invalide pour pouvoir ne rien choisir
	
	for (cpt_voie=0;cpt_voie<Total_Voie;cpt_voie++)
	{
		sprintf(tatoo_voie, "%d;%d", buffer_circulaire[cpt_voie].tatoo, buffer_circulaire[cpt_voie].voie);
		InsertListItem (panel, control_id, -1, buffer_circulaire[cpt_voie].nom_voie, tatoo_voie);
	}
}

void init_liste_voie2D(int panel, int control_id)
{
	int cpt_voie;
	char tatoo_voie[30];
	
	ClearListCtrl (panel, control_id); // Efface tous les lments du ring
	InsertListItem (panel, control_id, -1, "(aucun)", ""); // Insre un tatoo invalide pour pouvoir ne rien choisir
	
	for (cpt_voie=0;cpt_voie<nb_voie2D;cpt_voie++)
	{
		sprintf(tatoo_voie, "%d;%d", buffer2D_circulaire[cpt_voie].tatoo, buffer2D_circulaire[cpt_voie].voie);
		InsertListItem (panel, control_id, -1, buffer2D_circulaire[cpt_voie].nom_voie, tatoo_voie);
	}
}

void interpreter_variables(char *chaine, float *variable)
{
	char *chaine_g, *chaine_m, *chaine_d;
	char chaine_tmp[255], format_printf[50];
	int taille = 0;
	
	while ( (chaine_m = strchr(chaine, '$')) != NULL) // une variable est prsente
	{
		chaine_g = chaine; // partie gauche
		*chaine_m = NULL; // on termine chaine_g en enlevant le $
		chaine_d = chaine_m+1;
		if (isdigit(*chaine_d)) // 'taille' (optionnelle)
		{
			taille = (*chaine_d)-48;
			chaine_d++;
		}	
		if (isalpha(*chaine_d))
		{
			sprintf(format_printf, "%%s%%0%if%%s", taille);
			// on ne se risque pas a remplir chaine avec des morceaux de lui meme, on passe par 'chaine_tmp'
			sprintf(chaine_tmp, format_printf, chaine_g, variable[tolower(*chaine_d)-97], chaine_d+1);
		}
		else
		{
			sprintf(chaine_tmp, "%sBADVAR%s", chaine_g, chaine_d);
		}
		sprintf(chaine, "%s", chaine_tmp);
	}
}

void commander_appareil(char *commande, char *message, tmaillon *list_i) // !! Modifie 'commande' !!
{
	char *c_char; // Pour les arguments de la commande
	char *i_char; // Pour s'occuper du sparateur
	char chaine[255];
	
	c_char = strchr (commande, ':');
	i_char = c_char;
	c_char++;
	while (*c_char == ' ') // on ignore les espaces aprs ':'
		c_char++;
	i_char--;
	while (*i_char == ' ') // on ignore les espaces avant ':'
		i_char--;
	i_char[1] = NULL; // on termine le nom de l'instrument
	
	sprintf(message, "Commande impossible \"%s\" non trouv, vrifier le nom.", commande);
	
	while (list_i)
	{
		if (list_i->plugin->get_nom_instru)
		{
			list_i->plugin->get_nom_instru(list_i->plugin, chaine);
			if (!stricmp(commande, chaine)) // Comparaison sans respecter la casse
			{
				if (list_i->plugin->execute)
				{
					list_i->plugin->execute(list_i->plugin, c_char);
					sprintf(message, "Commande de \"%s\" avec \"%s\"", commande, c_char);
				}
				else
				{
					sprintf(message, "Commande impossible (%s) non fonctionnel", commande);
				}
			}
		}
		list_i = list_i->suivant;
	}

}

void Mode_boutons_acq(int panelCommande, int panelInstru, int panelGraphs)
{
	
	// Onglet instruments
	SetCtrlAttribute (panelInstru, P_Instru_Ajouter, ATTR_DIMMED, 1);
	SetCtrlAttribute (panelInstru, P_Instru_Supprimer, ATTR_DIMMED, 1);
	SetCtrlAttribute (panelInstru, P_Instru_RAZ, ATTR_DIMMED, 1);
	SetCtrlAttribute (panelInstru, P_Instru_Renommer, ATTR_DIMMED, 1);
	SetCtrlAttribute (panelInstru, P_Instru_Proprietes, ATTR_DIMMED, 1);
	SetCtrlAttribute (panelInstru, P_Instru_Piloter,ATTR_DIMMED, 0);
	
	SetCtrlAttribute (panelCommande, P_Commande_PICTUREBUTTON_Load, ATTR_DIMMED, 1);
	SetCtrlAttribute (panelCommande, P_Commande_GPIB_SCAN, ATTR_DIMMED, 1);
	SetCtrlAttribute (panelCommande, P_Commande_Mode_Fichier, ATTR_DIMMED, 1);
	SetCtrlAttribute (panelCommande, P_Commande_COMMANDBUTTON_Quit, ATTR_DIMMED, 1);

	SetCtrlAttribute (panelCommande, P_Commande_N_sous_ech_2D, ATTR_DIMMED, 1);
	SetCtrlAttribute (panelCommande, P_Commande_N_TEch, ATTR_DIMMED, 1);
	SetCtrlAttribute (panelCommande, P_Commande_TimeLimit, ATTR_DIMMED, 1);


	// Onglet Graphes
	SetCtrlAttribute (panelGraphs, P_Graphs_N_nbpointsgraphs, ATTR_DIMMED, 1);
	SetCtrlAttribute (panelGraphs, P_Graphs_N_mid, ATTR_DIMMED, 1);
	SetCtrlAttribute (panelGraphs, P_Graphs_N_long, ATTR_DIMMED, 1);
	
}

void Mode_boutons_stopped(int panelCommande, int panelInstru, int panelGraphs)
{
	// Onglet instruments
	SetCtrlAttribute (panelInstru, P_Instru_Ajouter, ATTR_DIMMED, 0);
	SetCtrlAttribute (panelInstru, P_Instru_Supprimer, ATTR_DIMMED, 0);
	SetCtrlAttribute (panelInstru, P_Instru_RAZ, ATTR_DIMMED, 0);
	SetCtrlAttribute (panelInstru, P_Instru_Renommer, ATTR_DIMMED, 0);
	SetCtrlAttribute (panelInstru, P_Instru_Proprietes, ATTR_DIMMED, 0);
	SetCtrlAttribute (panelInstru, P_Instru_Piloter,ATTR_DIMMED, 1);
	
	SetCtrlAttribute (panelCommande, P_Commande_PICTUREBUTTON_Load, ATTR_DIMMED, 0);
	SetCtrlAttribute (panelCommande, P_Commande_GPIB_SCAN, ATTR_DIMMED, 0);
	SetCtrlAttribute (panelCommande, P_Commande_Mode_Fichier, ATTR_DIMMED, 0);
	SetCtrlAttribute (panelCommande, P_Commande_COMMANDBUTTON_Quit, ATTR_DIMMED, 0);
	
	SetCtrlAttribute (panelCommande, P_Commande_N_sous_ech_2D, ATTR_DIMMED, 0);
	SetCtrlAttribute (panelCommande, P_Commande_N_TEch, ATTR_DIMMED, 0);
	SetCtrlAttribute (panelCommande, P_Commande_TimeLimit, ATTR_DIMMED, 0);

	SetCtrlAttribute (panelCommande, P_Commande_CHECKBOX, ATTR_DIMMED, 1);

	// Onglet Graphe
	SetCtrlAttribute (panelGraphs, P_Graphs_N_nbpointsgraphs, ATTR_DIMMED, 0);
	SetCtrlAttribute (panelGraphs, P_Graphs_N_mid, ATTR_DIMMED, 0);
	SetCtrlAttribute (panelGraphs, P_Graphs_N_long, ATTR_DIMMED, 0);

}

void Reserver_buffer_circu(tmaillon *list_choix_ax)
{
	// Doit tre appell pour mettre a jour la liste des voies
	int cpt_voie, voie_inst;
	char nom_instru[TAILLE_NOM_INSTRU];
	char nom_voie[TAILLE_NOM_VOIE];
	
	tmaillon *list_inst = list_choix_ax; // indispensable, on parcourt 2 fois !
	cpt_voie = 0;

	//////////////
	// Voies 1D //		Attention ! Bien s'assurer que toutes les voies calculees sont aprs !
	//////////////		Sinon voir mettre_donnees_dans_Bcirc et un peu dessous
	// Plugin instruments
	list_inst = list_choix_ax;
	while (list_inst)
	{
		list_inst->plugin->get_nom_instru(list_inst->plugin, nom_instru);
		if (list_inst->plugin->nb_voie_1D && list_inst->plugin->get_nom_voie_1D &&
			list_inst->plugin->mesure_1D && list_inst->plugin->numero_1D)
			for (voie_inst=1;voie_inst<=list_inst->plugin->nb_voie_1D(list_inst->plugin); voie_inst++)
			{
				(ptr_buff_circu *)buffer_circulaire = (ptr_buff_circu *)realloc(buffer_circulaire, (cpt_voie+1) * sizeof (ptr_buff_circu));
			
				buffer_circulaire[cpt_voie].instrument = list_inst->plugin;
			
				list_inst->plugin->get_nom_voie_1D(list_inst->plugin, voie_inst, nom_voie);
				sprintf(buffer_circulaire[cpt_voie].nom_voie, "%s %s", nom_instru, nom_voie);
			
				buffer_circulaire[cpt_voie].mesure = NULL;
				buffer_circulaire[cpt_voie].numero = NULL;
				buffer_circulaire[cpt_voie].points_long = NULL;
				buffer_circulaire[cpt_voie].points_mid = NULL;				
				
				buffer_circulaire[cpt_voie].ptr_mobile = 0;
				buffer_circulaire[cpt_voie].dernier_indice = 0;
			
				buffer_circulaire[cpt_voie].tatoo = list_inst->tatoo;
				buffer_circulaire[cpt_voie].voie = voie_inst;
				cpt_voie++;
			}
		list_inst = list_inst->suivant;
	}

	////////////////		Attention, il ne doit y avoir
	// Calculs 1D //		aucune voie 1D *mesure* aprs les voies calcules !
	////////////////		Sinon voir mettre_donnees_dans_Bcirc et un peu dessus
	//Plugin calculs
	list_inst = list_choix_ax;
	while (list_inst)
	{
		list_inst->plugin->get_nom_instru(list_inst->plugin, nom_instru);
		if (list_inst->plugin->nb_voie_calcul && list_inst->plugin->get_nom_voie_calcul &&
			list_inst->plugin->mesure_calcul && list_inst->plugin->calculer_1D)
			for (voie_inst=1;voie_inst<=list_inst->plugin->nb_voie_calcul(list_inst->plugin); voie_inst++)
			{
				(ptr_buff_circu *)buffer_circulaire = (ptr_buff_circu *)realloc(buffer_circulaire, (cpt_voie+1) * sizeof (ptr_buff_circu));
			
				buffer_circulaire[cpt_voie].instrument = list_inst->plugin;
			
				list_inst->plugin->get_nom_voie_calcul(list_inst->plugin, voie_inst, nom_voie);
				sprintf(buffer_circulaire[cpt_voie].nom_voie, "%s %s", nom_instru, nom_voie);
			
				buffer_circulaire[cpt_voie].mesure = NULL;
				buffer_circulaire[cpt_voie].numero = NULL;
				buffer_circulaire[cpt_voie].points_long = NULL;
				buffer_circulaire[cpt_voie].points_mid = NULL;
				
				buffer_circulaire[cpt_voie].ptr_mobile = 0;
				buffer_circulaire[cpt_voie].dernier_indice = 0;
			
				buffer_circulaire[cpt_voie].tatoo = list_inst->tatoo;
				buffer_circulaire[cpt_voie].voie = voie_inst;
				cpt_voie++;
			}
		list_inst = list_inst->suivant;
	}
	
	Total_Voie = cpt_voie;
	
	//////////////
	// Voies 2D //
	//////////////
	cpt_voie = 0;

	list_inst = list_choix_ax; // on reparcourt
	while (list_inst) // Mesures 2D
	{
		if (list_inst->plugin->get_nom_instru && list_inst->plugin->nb_voie2D &&
			list_inst->plugin->get_nom_voie2D && list_inst->plugin->get_taille_voie2D)
		{
			list_inst->plugin->get_nom_instru(list_inst->plugin, nom_instru);
			for (voie_inst=1;voie_inst<=list_inst->plugin->nb_voie2D(list_inst->plugin); voie_inst++)
			{
				(ptr_buff2D_circu *)buffer2D_circulaire = (ptr_buff2D_circu *)realloc(buffer2D_circulaire, (cpt_voie+1) * sizeof (ptr_buff2D_circu));
			
				buffer2D_circulaire[cpt_voie].instrument = list_inst->plugin;
			
				list_inst->plugin->get_nom_voie2D(list_inst->plugin, voie_inst, nom_voie);
				sprintf(buffer2D_circulaire[cpt_voie].nom_voie, "%s %s", nom_instru, nom_voie);
			
				buffer2D_circulaire[cpt_voie].ptr_mobile = 0;
				buffer2D_circulaire[cpt_voie].dernier_indice = 0;
			
				buffer2D_circulaire[cpt_voie].tatoo = list_inst->tatoo;
				buffer2D_circulaire[cpt_voie].voie = voie_inst;
			
				buffer2D_circulaire[cpt_voie].taille_voie = list_inst->plugin->get_taille_voie2D(list_inst->plugin, voie_inst);
			
				cpt_voie++;
			}
		}
		list_inst = list_inst->suivant;
	}

	////////////////
	// Calculs 2D //
	////////////////
	list_inst = list_choix_ax; // on reparcourt
	while (list_inst) // Calculs 2D
	{
		if (list_inst->plugin->get_nom_instru && list_inst->plugin->nb_voie_calcul2D &&
			list_inst->plugin->get_nom_voie_calcul_2D && list_inst->plugin->get_taille_voie_calcul2D)
		{
			list_inst->plugin->get_nom_instru(list_inst->plugin, nom_instru);
			for (voie_inst=1;voie_inst<=list_inst->plugin->nb_voie_calcul2D(list_inst->plugin); voie_inst++)
			{
				(ptr_buff2D_circu *)buffer2D_circulaire = (ptr_buff2D_circu *)realloc(buffer2D_circulaire, (cpt_voie+1) * sizeof (ptr_buff2D_circu));
			
				buffer2D_circulaire[cpt_voie].instrument = list_inst->plugin;
			
				list_inst->plugin->get_nom_voie_calcul_2D(list_inst->plugin, voie_inst, nom_voie);
				sprintf(buffer2D_circulaire[cpt_voie].nom_voie, "%s %s", nom_instru, nom_voie);
			
				buffer2D_circulaire[cpt_voie].ptr_mobile = 0;
				buffer2D_circulaire[cpt_voie].dernier_indice = 0;
			
				buffer2D_circulaire[cpt_voie].tatoo = list_inst->tatoo;
				buffer2D_circulaire[cpt_voie].voie = voie_inst;
			
				buffer2D_circulaire[cpt_voie].taille_voie = list_inst->plugin->get_taille_voie_calcul2D(list_inst->plugin, voie_inst);
			
				cpt_voie++;
			}
		}
		list_inst = list_inst->suivant;
	}

	nb_voie2D = cpt_voie;
}

void Init_buffer_circu(int panelCommande, int panelGraphs)
{
	int Cpt_Voie;
	int i;

	// Rcupration du nombre de points
	GetCtrlVal(panelGraphs, P_Graphs_N_nbpointsgraphs, &nbpointsgraph);
	GetCtrlVal(panelCommande, P_Commande_N_sous_ech_2D, &sous_ech_2D);
	GetCtrlVal(panelGraphs, P_Graphs_N_mid, &diviseur_short_mid);
	GetCtrlVal(panelGraphs, P_Graphs_N_long, &diviseur_mid_long);
					
	for (Cpt_Voie=0;Cpt_Voie<Total_Voie;Cpt_Voie++)
	{
		buffer_circulaire[Cpt_Voie].profondeur = nbpointsgraph;
		buffer_circulaire[Cpt_Voie].mesure = malloc(nbpointsgraph * sizeof(double)); // Allocation de nbpointsgraph double pour chaque mesure
		//memset (buffer_circulaire[Cpt_Voie].mesure, 0, nbpointsgraph*sizeof(double));
		for(i=0;i<nbpointsgraph;i++)
			(buffer_circulaire[Cpt_Voie].mesure)[i] = NotANumber();
			
		buffer_circulaire[Cpt_Voie].numero = malloc(nbpointsgraph * sizeof(double)); // Allocation de nbpointsgraph double pour chaque numero
		memset (buffer_circulaire[Cpt_Voie].numero, 0, nbpointsgraph*sizeof(double));
		
		
		// Affichage des graphes a moyen / long terme.
		buffer_circulaire[Cpt_Voie].points_mid = malloc(nbpointsgraph * sizeof(double));
		//memset(buffer_circulaire[Cpt_Voie].points_mid, 0, nbpointsgraph*sizeof(double));
		for(i=0;i<nbpointsgraph;i++)
			(buffer_circulaire[Cpt_Voie].points_mid)[i] = NotANumber();
		
		buffer_circulaire[Cpt_Voie].points_long = malloc(nbpointsgraph * sizeof(double));
		//memset(buffer_circulaire[Cpt_Voie].points_long, 0, nbpointsgraph*sizeof(double));
		for(i=0;i<nbpointsgraph;i++)
			(buffer_circulaire[Cpt_Voie].points_long)[i] = NotANumber();
		
		buffer_circulaire[Cpt_Voie].cpt_mid = 0;
		buffer_circulaire[Cpt_Voie].cpt_long = 0;		
		
	}
}

void Liberer_buffer_circu(void)
{
	int Cpt_Voie;
	// Libration des tableaux de points
	for (Cpt_Voie=0;Cpt_Voie<Total_Voie;Cpt_Voie++)
	{
		if (buffer_circulaire[Cpt_Voie].mesure)
			free(buffer_circulaire[Cpt_Voie].mesure);
		if (buffer_circulaire[Cpt_Voie].numero)
			free(buffer_circulaire[Cpt_Voie].numero);
		if (buffer_circulaire[Cpt_Voie].points_mid)
			free(buffer_circulaire[Cpt_Voie].points_mid);
		if (buffer_circulaire[Cpt_Voie].points_long)
			free(buffer_circulaire[Cpt_Voie].points_long);
	}
}

void Liberer_buffer2D_circu(void)
{
	int cpt_voie, cpt_num;
	for (cpt_voie=0; cpt_voie<nb_voie2D; cpt_voie++)
		for (cpt_num=0; cpt_num<HISTORIQUE_2D; cpt_num++)
		{
			if (buffer2D_circulaire[cpt_voie].mesure[cpt_num])
				free(buffer2D_circulaire[cpt_voie].mesure[cpt_num]);
			if (buffer2D_circulaire[cpt_voie].indices[cpt_num])
				free(buffer2D_circulaire[cpt_voie].indices[cpt_num]);
		}
}

int Init_buffer2D_circu(tmaillon *list_ins)
{
	int voie_inst, cpt_voie, cpt_num, nb_voie;
	tmaillon *list_inst;
	int err=0;
	
	cpt_voie = 0;
	list_inst = list_ins;
	
	// On reserve les buffers mesures/indices 2D (d'ou le nom "init" de la fonction...)
	while (list_inst) // Mesures 2D
	{
		if (list_inst->plugin->get_nom_instru && list_inst->plugin->nb_voie2D &&
			list_inst->plugin->get_nom_voie2D && list_inst->plugin->get_taille_voie2D)
		{
			for (voie_inst=1;voie_inst<=list_inst->plugin->nb_voie2D(list_inst->plugin); voie_inst++)
			{
				buffer2D_circulaire[cpt_voie].instrument = list_inst->plugin;
			
				for (cpt_num=0; cpt_num<HISTORIQUE_2D; cpt_num++)
				{
					buffer2D_circulaire[cpt_voie].numero[cpt_num] = 0;
					buffer2D_circulaire[cpt_voie].mesure[cpt_num] =
						malloc(buffer2D_circulaire[cpt_voie].taille_voie * sizeof(double));
					if (buffer2D_circulaire[cpt_voie].mesure[cpt_num] == NULL)
						err--; // Problme de malloc
					else
						memset(buffer2D_circulaire[cpt_voie].mesure[cpt_num],0,buffer2D_circulaire[cpt_voie].taille_voie * sizeof(double));
					buffer2D_circulaire[cpt_voie].indices[cpt_num] =
						malloc(buffer2D_circulaire[cpt_voie].taille_voie * sizeof(double));
					if (buffer2D_circulaire[cpt_voie].indices[cpt_num] == NULL)
						err--; // Problme de malloc
					else
						memset(buffer2D_circulaire[cpt_voie].indices[cpt_num],0,buffer2D_circulaire[cpt_voie].taille_voie * sizeof(double));
				}
				cpt_voie++;
			}
		}
		list_inst = list_inst->suivant;
	}
	list_inst = list_ins;
	while (list_inst) // Calculs 2D
	{
		if (list_inst->plugin->get_nom_instru && list_inst->plugin->nb_voie_calcul2D &&
			list_inst->plugin->get_nom_voie_calcul_2D && list_inst->plugin->get_taille_voie_calcul2D)
		{
			for (voie_inst=1;voie_inst<=list_inst->plugin->nb_voie_calcul2D(list_inst->plugin); voie_inst++)
			{
				buffer2D_circulaire[cpt_voie].instrument = list_inst->plugin;
			
				for (cpt_num=0; cpt_num<HISTORIQUE_2D; cpt_num++)
				{
					buffer2D_circulaire[cpt_voie].numero[cpt_num] = 0;
					buffer2D_circulaire[cpt_voie].mesure[cpt_num] =
						malloc(buffer2D_circulaire[cpt_voie].taille_voie * sizeof(double));
					if (buffer2D_circulaire[cpt_voie].mesure[cpt_num] == NULL)
						err--; // Problme de malloc
					else
						memset(buffer2D_circulaire[cpt_voie].mesure[cpt_num],0,buffer2D_circulaire[cpt_voie].taille_voie * sizeof(double));
					buffer2D_circulaire[cpt_voie].indices[cpt_num] =
						malloc(buffer2D_circulaire[cpt_voie].taille_voie * sizeof(double));
					if (buffer2D_circulaire[cpt_voie].indices[cpt_num] == NULL)
						err--; // Problme de malloc
					else
						memset(buffer2D_circulaire[cpt_voie].indices[cpt_num],0,buffer2D_circulaire[cpt_voie].taille_voie * sizeof(double));
				}
				cpt_voie++;
			}
		}
		list_inst = list_inst->suivant;
	}
	return err; // OK
}

void afficher_status(int panelCommande, char *input_chaine)
{
	int err;
	int nb;
	char *chaine;
	char *heure;
	
	heure = TimeStr ();
	
	chaine = malloc((strlen(heure)+strlen("\033vline")+strlen(input_chaine)+1)*sizeof(char));
	
	sprintf(chaine, "%s\033vline%s", heure, input_chaine);
	
	InsertListItem(panelCommande,P_Commande_STATUS,-1,chaine,0);
	GetNumListItems(panelCommande,P_Commande_STATUS,&err);
	if (err > 400)
		DeleteListItem(panelCommande, P_Commande_STATUS, 0, err-400);

	GetNumListItems(panelCommande,P_Commande_STATUS,&err);
	GetCtrlAttribute (panelCommande, P_Commande_STATUS, ATTR_VISIBLE_LINES, &nb);
	if (err > nb)
		SetCtrlAttribute (panelCommande, P_Commande_STATUS, ATTR_FIRST_VISIBLE_LINE, err-nb); // scrolling "auto"
	ProcessDrawEvents ();
	free(chaine);
}

void init_gestion_lock(void)
{
	if (Lock_gestion_lock == 0)
		CmtNewLock(NULL, 0, &Lock_gestion_lock);
}

void fin_gestion_lock(void)
{
	CmtDiscardLock(Lock_gestion_lock);
}

int gestion_lock(char *lock_requis)
{
	int cpt_lock;
	static lock_count = 0; // indice du nouveau lock a demander
	static struct { char nom_lock[TAILLE_NOM_LOCK]; int lock; } locklist[10];
	
	if (Lock_gestion_lock == 0)
		init_gestion_lock(); // Protection anti-boulet (vaguement efficace)
	
	CmtGetLock(Lock_gestion_lock); // besoin de locker pour (eventuellement) demander un nouveau lock
	for (cpt_lock=0; cpt_lock<lock_count; cpt_lock++)
		if (!strcmp(locklist[cpt_lock].nom_lock, lock_requis)) // lock existant
		{
			CmtReleaseLock(Lock_gestion_lock); // pas besoin de demander un nouveau (et de toute facon, faut liberer le lock)
			return locklist[cpt_lock].lock;
		}
	CmtNewLock(NULL, 0, &locklist[lock_count].lock); // on demande
	strcpy(locklist[lock_count].nom_lock, lock_requis); // on memorise le nom
	lock_count++;
	CmtReleaseLock(Lock_gestion_lock); // on a fait la demande d'un nouveau lock, on peut liberer
	return locklist[lock_count-1].lock;
}

