#ifndef LISTE_H
#define LISTE_H

#include "plugin.h"

typedef struct fichei
{
	struct fichei *suivant;
	char Type_Apareil[255];
	PInstrument *plugin;
	int tatoo;
	FILE *fichier;
} tmaillon;

PInstrument *Nouvel_instrument(char *chaine);
void remplir_liste_instru(int panel);

void init_tatoo(int init_unique);
int get_tatoo(void);
int status_tatoo(void);

tmaillon *Inserer_instru(tmaillon *list_instru, char *Type_App, PInstrument *structu_inst, int tatoo);
tmaillon *Supprimer_instru (tmaillon *list_instru, tmaillon *repere_suppr);
tmaillon *Effacer_liste_inst(tmaillon *list_instru);

void arret_instru(tmaillon *list_acq);

int Init_buffer2D_circu(tmaillon *list_inst);
void Liberer_buffer2D_circu(void);

void Reserver_buffer_circu(tmaillon *list_choix_axe);
void Init_buffer_circu(int panelCommande, int panelGraphs);
void Liberer_buffer_circu(void);

int mettre_donnees_dans_Bcirc(tmaillon *list_result);
int mettre_donnees2D_dans_Bcirc2D(tmaillon *list_result);
void lancer_calculs_1D(tmaillon *list_result);
void lancer_calculs_2D(tmaillon *list_cal2);
void mettre_calculs_dans_Bcirc(int Cpt_Voie, tmaillon *list_result);
void mettre_calculs2D_dans_Bcirc2D(int Cpt_Voie2D, tmaillon *list_inst);

void generer_graphes_moyens(void);

void init_liste_voie(int panel, int control_id);
void init_liste_voie2D(int panel, int control_id);
ptr_buff_circu *get_buffer_from_tatoo(char *tatoo_voie);
ptr_buff2D_circu *get_buffer2D_from_tatoo(char *tatoo_voie);

int Ouvrir_enregistrement(char *nom_fichier, tmaillon *list_acq);
void Fermer_enregistrement(tmaillon *list_wave);
void Marquer_donnees(char *chaine, int panel, int control);
void Ecriture_donnees(tmaillon *list_result);
void Visu(void);
void Echantilloner(tmaillon *list_result);
void Init2D(int);
void MAJ2D(int);
void Discard2D(void);
void Init3D(void);
void Discard3D(void);

void interpreter_variables(char *chaine, float *variable);
void commander_appareil(char *commande, char *message, tmaillon *list_i);

void Mode_boutons_acq(int panelCommande, int panelInstru, int panelCourbe);
void Mode_boutons_stopped(int panelCommande, int panelInstru, int panelCourbe);
void afficher_status(int panelCommande, char *chaine);
void init_gestion_lock(void);
void fin_gestion_lock(void);
int gestion_lock(char *lock_requis);

// temporaire
extern PInstrument cred_4v;
extern PInstrument freq2v;
extern PInstrument freq;
extern PInstrument freq_sw;
extern PInstrument power_simple;
extern PInstrument power_switch;
extern PInstrument multi;
extern PInstrument pilote_bidon;
extern PInstrument enc_ther;
extern PInstrument pilote_valve;
extern PInstrument Calculatrice;
extern PInstrument boucleur;
extern PInstrument calcul_extremum;
extern PInstrument calcul_moy_stddev;
extern PInstrument tek;
extern PInstrument bode_hp;
extern PInstrument anritsu;
extern PInstrument fitter;
extern PInstrument pouet;
extern PInstrument Regul_Acoustic;
extern PInstrument Pousse_Seringue;
extern PInstrument Pompe_Ismatec;
extern PInstrument Electrovanne;
extern PInstrument GBF_HP3312A;
extern PInstrument HP53131_phase;
extern PInstrument rheometre_temperature;
extern PInstrument rheometre_temperature;
extern PInstrument DGM110;
//@@@extern PInstrument @@NOM_C@@;

#endif
