/* multimetre.h
 contient les initialisations, mise en place, et fonction d'interruption
 pour un frquencemtre sur une voie 
 Contient aussi des fonctions propres pour afficher les messages d'erreur*/

#include "plugin.h"

typedef struct	
	{
	int identificateur;
	int adresse_gpib;
	int digits;
	int Volt_Ampere;
	int handmulti;
	int stop_interruption;
	unsigned int numero_mesure[1];
	double zone_memoire[1];
	char nom_instru[128];
	}infos_multi;


//int initialisation_multi_int(infos_multi *data_multi);
//int miseenplace_int_multi(infos_multi *data_multi);
int __stdcall CB_interruption_multi(int boardOrDevice, int sta, int err, long cntl,void *callbackData);
//int arreter_interruption_multi(infos_multi *data_multi);

static void multimetre_nouveau(PInstrument **multimetre);
static void multimetre_liberer(PInstrument *instru);
static void multimetre_get_nom(PInstrument *instrument, char *nom_instru);
static void multimetre_set_nom(PInstrument *instrument, char *nom_instru);
static void multimetre_configure(PInstrument *multimetre);
static void multimetre_getconfig(PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool);
static int multimetre_nb_voie(PInstrument *frequencemetre);
static void multimetre_get_nom_voie(PInstrument *multimetre, int voie, char *nom_voie);
static double multimetre_mesure(PInstrument *multimetre, int voie);
static unsigned int multimetre_numero(PInstrument *multimetre, int voie);
static int multimetre_digits(PInstrument *multimetre);

static void arreter_interruption_multi(PInstrument *multimetre);
int miseenplace_int_multi(PInstrument *multimetre);
int initialisation_multi_int(PInstrument *multimetre);
