#include "toolbox.h"
#include <ansi_c.h>
#include "globales.h" 
#include <gpib.h>
#include <userint.h>
#include "powermeter.h"
#include "UIR_power.h"
// fichier powermeter.c

#include "plugin.h"

PInstrument power_simple =
{
	NULL, // Rempli par 'nouveau'

	NULL, // rempli aprs nouveau (par liste.c)
	NULL,
	NULL,
	NULL,
	NULL,

	power_nouveau,
	power_liberer,
	power_configure,
	power_getconfig,
	power_get_nom,
	power_set_nom,
	arreter_interruption_powermeter_AB,
	miseenplace_int_powermeter_AB,
	initialisation_powermeter_AB_int,
	NULL,
	NULL,
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	
	power_nb_voie,
	power_get_nom_voie,
	power_mesure,
	power_numero,
	
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

int initialisation_powermeter_AB_int(PInstrument *power)
{
	infos_power *data_power = power->structure;
	char chaine[255];
	char bufM[256];
	short shorttmp=0;
	int err=0,statuscapteurspowermeter,tmpvar=0,id_powermeter=0;


	// Initialisation Zone Mmoire.
	data_power->zone_memoire[0]=NotANumber();
	data_power->zone_memoire[1]=NotANumber();

	//Initialisation Numro Mesure.
	data_power->numero_mesure[0] = 0;
	data_power->numero_mesure[1] = 0;

	// Dtection powermeter 
	id_powermeter = ibdev (0, data_power->adresse_gpib, NO_SAD, T10s, 1, 1);
	ibclr (id_powermeter);		// Erreur CVI si branche mais pas allume !?
	ibln (id_powermeter, data_power->adresse_gpib, NO_SAD, &shorttmp); 
	if (shorttmp== 0) 
		{
		MessagePopup ("Attention", "Il faudrait penser  brancher le Powermeter");
		return -1;
		}
	
	ibecr(id_powermeter, "*IDN?");
	ibrd(id_powermeter, chaine, 250);
	if (strstr (chaine, "HEWLETT-PACKARD,E4419B,") == NULL) // module test seulement avec le 4419B
	{
		MessagePopup ("Erreur", "Modle non support par ce module !");
		return -1;
	}

	// Reset du powermeter
	//err = ibecr(*id_powermeter,"*RST");
				
	// Vrification du branchement des capteurs
	err = ibecr (id_powermeter,"stat:dev:cond?");
	if (err & ERR)
		{
		MessagePopup("Attention", "erreur  la vrification du branchement des sondes");
		return err;
		}
	err = ibrd (id_powermeter, bufM, 50);
	if (err & ERR)
		{
		MessagePopup("Attention", "erreur  la vrification du statut des sondes") ;
		return err;
		}
	sscanf (bufM, "%d", &statuscapteurspowermeter);

	if (!(statuscapteurspowermeter & 0x02))
			{
			MessagePopup ("Attention", "Il faudrait vrifier les branchements de la sonde A");
			QuitUserInterface (0);
			}
	if (!(statuscapteurspowermeter & 0x04))
			{
			MessagePopup ("Attention", "Il faudrait vrifier les branchements de la sonde B");
			QuitUserInterface (0);
			}


	// dfinition du comportement  la rception de *TRG		
	sprintf(bufM,"*DDT \"TRIG1;TRIG2\"");err = ibecr(id_powermeter,bufM);
		if (err & ERR) {MessagePopup("Attention","Configurationd de la frquence de d'interpollation des sondes");return err;}		

	//configuration des voies
	for (tmpvar=1;tmpvar<3;tmpvar++)
		{	
			// Capteur i --> fentre i
			sprintf(bufM,"CONF%d:POW:AC DEF,4,(@%d)",tmpvar,tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Capteur i --> fentre i");return err;}
			// Rglages du dclenchement
			// Mettre en IDLE
			sprintf(bufM,":ABOR%d",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);
				if (err & ERR) {MessagePopup("Attention","Pour mettre en Idle");return err;}
			// Dclenchement par *TRG
			sprintf(bufM,"TRIG%d:SOUR BUS",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);
				if (err & ERR) MessagePopup("Attention","Dclenchement par *TRG");
			// Mesure en continu
			sprintf(bufM,"INIT%d:CONT ON",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);
				if (err & ERR) {MessagePopup("Attention","Mesure en continu");return err;}
			// mettre en wait for trigger
			//sprintf(bufM,"INIT%d",tmpvar);err = ibecr(id_powermeter,bufM);
				if (err & ERR) {MessagePopup("Attention","Mettre en wait for trigger");return err;}			
			// Pour laisser au powermeter le temps de mettre  jour les filtres numriques
			sprintf(bufM,"TRIG%d:DEL:AUTO ON",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);
				if (err & ERR) {MessagePopup("Attention","Pour laisser au powermeter le temps de mettre  jour les filtres numriques");return err;}		
		// Rglages des mesures
			// Rglage des units de mesure
			sprintf(bufM,"UNIT%d:POW DBM",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Rglage des units de mesure");return err;}
			// Configuration & activation du filtre
			sprintf(bufM,"SENS%d:SPE 20",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Configuration & activation du filtre");return err;}
			// Configuration du filtre dbruiteur
			sprintf(bufM,"SENS%d:AVER:COUN:AUTO ON",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Configuration du filtre dbruiteur");return err;}
			// auto nettoyage du filtre numrique
			sprintf(bufM,"SENS%d:AVER:SDET OFF",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Configuration du filtre dbruiteur");return err;}
			// Configuration du filtre dbruiteur
			sprintf(bufM,"SENS%d:AVER:COUN 4",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Configuration du filtre dbruiteur");return err;}
			// Activation du filtre dbruiteur
			sprintf(bufM,"SENS%d:AVER:STAT ON",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Activation du filtre dbruiteur");return err;}
			// Configurationd de la frquence de d'interpollation des sondes
			sprintf(bufM,"SENS%d:FREQ:FIX %dMHz",tmpvar,data_power->frequence_fonctionnement);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Configuration de la frquence d'interpollation des sondes");return err;}
			}

	// Mise  jour des donnes de la structure.
	data_power->stop_interruption = RQS;
	data_power->identificateur = id_powermeter;

	return err;		
}			

int miseenplace_int_powermeter_AB(PInstrument *power)
{
	infos_power *data_power = power->structure;
	int err=0;
	char chaine[255];

	//initialisation de la section de code critique
	//InitializeCriticalSection(&criticalSection);

	verif_erreur(data_power->identificateur);	
	// Activation du transfert du rsum du Standard Event byte dans le Status byte
	err=ibecr(data_power->identificateur,"*ESE 1");
	// Activation de l'interruption lorsque le bit du rsum du Standard Event pass  1
	if ((err = ibecr (data_power->identificateur, "*SRE 32")) & ERR) // Activation
		{
		sprintf(chaine,"Impossible d'initialiser l'interruption\nsur le frquencemtre d'identificateur %d\n iberr=%x \n ibsta=%x\nibcntl=%x",data_power->identificateur,iberr,ibsta,ibcntl);
		MessagePopup("Attention !!!",chaine);
		return err;
		}
	verif_erreur(data_power->identificateur);	

	//Mise  0 de tous les bits d'interruption
	ibecr(data_power->identificateur,"*ESR?");
	ibrd (data_power->identificateur,chaine,10); verif_erreur(data_power->identificateur);

	// Mise en place de l'interruption
	err = ibnotify (data_power->identificateur, data_power->stop_interruption, CB_interruption_powermeter_AB,data_power);
	if (err==ERR)
		{
		sprintf(chaine,"Impossible d'initialiser le frquencemtre\nd'adresse %d",(unsigned short)data_power->identificateur);
		MessagePopup("Attention !!!",chaine);
		return -1;
		}
	verif_erreur(data_power->identificateur);	
	// lancement d'une mesure
	if ((err = ibecr (data_power->identificateur, "*TRG;*OPC"))& ERR) // dclenchement immdiat
	{
		sprintf(chaine,"Impossible de lancer une mesure\nsur le frquencemtre d'identificateur %d\n iberr=%x \n ibsta=%x\nibcntl=%x",data_power->identificateur,ibsta,ibcntl);
		MessagePopup("Attention !!!",chaine);
		ibnotify (data_power->identificateur, 0, CB_interruption_powermeter_AB,data_power); //Dsactivation de l'interruption
		return err;
	}
	return err;
}

int __stdcall CB_interruption_powermeter_AB(int boardOrDevice, int localsta, int localerr, long localcntl,void *callbackData)
{
	infos_power *data_power;

	char chaine[256];
	int err;

	// Enlever le bit RQS 
	err = ibrsp(boardOrDevice,chaine);        
	switch (localsta)
	{
		case ERR:
			return 0;
		default:

			data_power = (infos_power *)callbackData;
	
			//Vrification que l'interruption est bien lie  la fin d'une mesure
			ibecr(boardOrDevice,"*ESR?");
			ibrd(boardOrDevice,chaine,10);
			sscanf(chaine,"%d",&err);
			if (!(err & 1)) // 1 = OPC
				return data_power->stop_interruption; // Pour ractiver l'interruption  
	
			// Enlever le bit RQS
			err = ibrsp(boardOrDevice,chaine); 
			// Demander la premiere voie
			err = ibecr(boardOrDevice,"FETCH1?");
		    err = ibrd(boardOrDevice,chaine,50);
		    chaine[ThreadIbcntl()]='\0'; //Ajout du caractere de fin de chaine
		    err = sscanf (chaine, "%lf", &(data_power->zone_memoire[0])); //transformation en flottant
    
		    // Demander la deuxime voie
			err = ibecr(boardOrDevice,"FETCH2?");
		    err = ibrd(boardOrDevice,chaine,50);
		    chaine[ThreadIbcntl()]='\0'; //Ajout du caractere de fin de chaine
		    err = sscanf (chaine, "%lf", &(data_power->zone_memoire[1])); //transformation en flottant
    
			// Incrmentation du nombre de mesures.
		    data_power->numero_mesure[0]++;
		    data_power->numero_mesure[1]++;

			// relancement d'une mesure
		   	ibecr (boardOrDevice, "*TRG;*WAI;*TRG;*WAI;*TRG;*WAI;*TRG;*WAI;*TRG;*OPC"); // dclenchement immdiat
	
			//LeaveCriticalSection(&criticalSection);
			return data_power->stop_interruption; // Pour ractiver l'interruption
	}
}

static void arreter_interruption_powermeter_AB(PInstrument *power)
{
	infos_power *data_power = power->structure;
	
	if (data_power->stop_interruption == 0) // dj arrt
		return;

	//dsactivation de l'interruption
	data_power->stop_interruption = 0;
	
	//libration de l'identificateur
	//ibonl (data_power->identificateur, 0);
}

static void power_nouveau(PInstrument **power)
{
	*power = (PInstrument *)malloc(sizeof(PInstrument));
	memcpy (*power, &power_simple, sizeof(PInstrument));
	(*power)->structure = malloc(sizeof(infos_power));
	((infos_power *)(*power)->structure)->adresse_gpib = 7;
	((infos_power *)(*power)->structure)->frequence_fonctionnement = 110;
	sprintf(((infos_power *)(*power)->structure)->nom_instru, "Powermeter");
}

static void power_liberer(PInstrument *instru)
{
	free(instru->structure);
	free(instru);
}

static void power_get_nom(PInstrument *instrument, char *nom_instru)
{
	memcpy(nom_instru, ((infos_power *)instrument->structure)->nom_instru, TAILLE_NOM_INSTRU-1);
}

static void power_set_nom(PInstrument *instrument, char *nom_instru)
{
	memcpy(((infos_power *)instrument->structure)->nom_instru, nom_instru, TAILLE_NOM_INSTRU-1);
	((infos_power *)instrument->structure)->nom_instru[TAILLE_NOM_INSTRU-1] = NULL;
}

static void power_configure(PInstrument *power)
{
	infos_power *data_power = power->structure;
	
	int panel;
	if ((panel = LoadPanel (0, "UIR_power.uir", Conf_Pow)) < 0)
		return ;
					   
	SetCtrlVal (panel, Conf_Pow_NUM_Conf_Adr_Power, data_power->adresse_gpib);
	SetCtrlVal (panel, Conf_Pow_RING_Conf_Capt_Power, data_power->capteur);
	SetCtrlVal (panel, Conf_Pow_NUM_Conf_Freq_Fct_Pow, data_power->frequence_fonctionnement);
	 
	SetCtrlAttribute (panel, Conf_Pow_OK_POWER, ATTR_CALLBACK_DATA, data_power);
	DisplayPanel (panel);
}

static void power_getconfig(PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool)
{
	infos_power *data = instrument->structure;
	
	*p_strct = (void*)data;
	*p_size = sizeof(infos_power);
	
	*p_bool = 1;
}

static int power_nb_voie(PInstrument *power)
{
	infos_power *data_power = power->structure;
	return data_power->nombre_voie;
}

static void power_get_nom_voie(PInstrument *power, int voie, char *nom_voie)
{
	infos_power *data_power = power->structure;
	
	if ( (data_power->capteur  & 2) && (voie == 1) )
		strcpy(nom_voie, "Voie A");
	
	if ( (data_power->capteur == 4) && (voie == 1) ) // Voie B seule
		strcpy(nom_voie, "Voie B");
	if ( (data_power->capteur == 6) && (voie == 2) ) // Voie B (Voie A active)
		strcpy(nom_voie, "Voie B");
}

static double power_mesure(PInstrument *power, int voie)
{
	infos_power *result_power = power->structure;
	
	if (result_power->capteur == 4) // Voie B seule
		return result_power->zone_memoire[1];
	return result_power->zone_memoire[voie-1];
}

static unsigned int power_numero(PInstrument *power, int voie)
{
	infos_power *result_power = power->structure;
	
	if (result_power->capteur == 4) // Voie B seule
		return result_power->numero_mesure[1];
	return result_power->numero_mesure[voie-1];
}

static int power_digits(PInstrument *power)
{
	return 4; // Pierre, c'est sur ?
}

int CVICALLBACK Power_OK (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{

int Valeurs_Configuration_Adresse_GPIB = 0;
int Valeurs_Configuration_Capteur = 0;
int Valeurs_Configuration_Frequence_Fonctionnement = 0;

infos_power *structu_inst;

structu_inst = (infos_power *)callbackData;
	
	switch (event)
		{
		case EVENT_COMMIT:
			
			GetCtrlVal (panel, Conf_Pow_NUM_Conf_Adr_Power, &Valeurs_Configuration_Adresse_GPIB); // Rcupration de l'adresse GPIB
			GetCtrlVal (panel, Conf_Pow_RING_Conf_Capt_Power, &Valeurs_Configuration_Capteur); // Rcupration du capteur utilis
			GetCtrlVal (panel, Conf_Pow_NUM_Conf_Freq_Fct_Pow, &Valeurs_Configuration_Frequence_Fonctionnement); // Rcupration de la frquence de fonctionnement
			
			structu_inst->adresse_gpib = Valeurs_Configuration_Adresse_GPIB;
			structu_inst->capteur = Valeurs_Configuration_Capteur;
			structu_inst->frequence_fonctionnement = Valeurs_Configuration_Frequence_Fonctionnement;
			
			if (Valeurs_Configuration_Capteur != 6)
				structu_inst->nombre_voie = 1;
			else
				structu_inst->nombre_voie = 2;
				
			DiscardPanel (panel); // Dtruit la fentre "CONFIGURATION D'UN APPAREIL" pour un powermeter
			
			break;
		}
	return 0;
}
