#include "toolbox.h"
//#include "Interface.h"
#include <utility.h>
#include <ansi_c.h>
#include "globales.h" 
#include <gpib.h>
#include <userint.h>
#include "powswitch.h"
#include "UIR_power_SW.h"

#include "plugin.h"

PInstrument power_switch =
{
	NULL, // Rempli par 'nouveau'

	NULL, // rempli aprs nouveau (par liste.c)
	NULL,
	NULL,
	NULL,
	NULL,

	power_SW_nouveau,
	power_SW_liberer,
	power_SW_configure,
	power_SW_getconfig,
	power_SW_get_nom,
	power_SW_set_nom,
	arreter_interruption_powermeter_AB_switch,
	miseenplace_int_powermeter_AB_switch,
	initialisation_powermeter_AB_switch_int,
	NULL,
	NULL,
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	
	power_SW_nb_voie,
	power_SW_get_nom_voie,
	power_SW_mesure,
	power_SW_numero,
	
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

int initialisation_powermeter_AB_switch_int(PInstrument *power_SW)
{
	infos_power_switch *data_switch = power_SW->structure;
	char bufM[256],chaine[255];
	short shorttmp=0;
	int err=0,statuscapteurspowermeter,tmpvar=0,id_powermeter=0,val_port_para;


	// Initialisation Zone Mmoire.
	data_switch->zone_memoire[0]=NotANumber();
	data_switch->zone_memoire[1]=NotANumber();
	data_switch->zone_memoire[2]=NotANumber();
	data_switch->zone_memoire[3]=NotANumber();


	//Initialisation Numro Mesure.
	data_switch->numero_mesure[0] = 0;
	data_switch->numero_mesure[1] = 0;
	data_switch->numero_mesure[2] = 0;
	data_switch->numero_mesure[3] = 0;



	// Dtection powermeter
	id_powermeter = ibdev (0, data_switch->adresse_gpib, NO_SAD, T10s, 1, 1);
	if (id_powermeter<0)
		{
		MessagePopup("Attention","Impossible de dtecter le powermeter");
		return ERR;
		}

	ibecr(id_powermeter, "*IDN?");
	ibrd(id_powermeter, chaine, 250);
	if (strstr (chaine, "HEWLETT-PACKARD,E4419B,") == NULL) // module test seulement avec le 4419B
	{
		MessagePopup ("Erreur", "Modle non support par ce module !");
		return -1;
	}

	ibecr (id_powermeter,"*RST"); // Reset du powermeter
	ibecr (id_powermeter,"*ESR 0"); // remise  0 du OPC de l'exec prcdent
	//On vide les ventuelles erreurs 
	do
		{
		ibecr(id_powermeter,"SYST:ERR?");
		ibrd(id_powermeter,chaine,255);
		sscanf(chaine,"%d",&err);
		} while (err!=0);

	ibclr (id_powermeter);		// Erreur CVI si branche mais pas allume !?
	ibln (id_powermeter, data_switch->adresse_gpib, NO_SAD, &shorttmp); 
	if (shorttmp== 0) 
		{
		MessagePopup ("Attention", "Il faudrait penser  brancher le Powermeter");
		QuitUserInterface (0);
		}

	// Vrification du branchement des capteurs
	err = ibecr (id_powermeter,"stat:dev:cond?");
	if (err & ERR)
		{
		MessagePopup("Attention", "erreur  la vrification du branchement des sondes");
		return err;
		}
	err = ibrd (id_powermeter, bufM, 50);
	if (err & ERR)
		{
		MessagePopup("Attention", "erreur  la vrification du statut des sondes") ;
		return err;
		}
	sscanf (bufM, "%d", &statuscapteurspowermeter);

	if (!(statuscapteurspowermeter & 0x02))
			{
			MessagePopup ("Attention", "Il faudrait vrifier les branchements de la sonde A");
			QuitUserInterface (0);
			}
	if (!(statuscapteurspowermeter & 0x04))
			{
			MessagePopup ("Attention", "Il faudrait vrifier les branchements de la sonde B");
			QuitUserInterface (0);
			}


	// dfinition du comportement  la rception de *TRG		
	sprintf(bufM,"*DDT \"TRIG1;TRIG2\"");err = ibecr(id_powermeter,bufM);
		if (err & ERR) {MessagePopup("Attention","Configurationd de la frquence de d'interpollation des sondes");return err;}		

	//configuration des voies
	for (tmpvar=1;tmpvar<3;tmpvar++)
		{	
			// Capteur i --> fentre i
			sprintf(bufM,"CONF%d:POW:AC DEF,4,(@%d)",tmpvar,tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Capteur i --> fentre i");return err;}
			// Rglages du dclenchement
			// Mettre en IDLE
			sprintf(bufM,":ABOR%d",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);
				if (err & ERR) {MessagePopup("Attention","Pour mettre en Idle");return err;}
			// Dclenchement par *TRG
			sprintf(bufM,"TRIG%d:SOUR BUS",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);
				if (err & ERR) MessagePopup("Attention","Dclenchement par *TRG");
			// Mesure en continu
			sprintf(bufM,"INIT%d:CONT ON",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);
				if (err & ERR) {MessagePopup("Attention","Mesure en continu");return err;}
			// mettre en wait for trigger
			//sprintf(bufM,"INIT%d",tmpvar);err = ibecr(id_powermeter,bufM);
				if (err & ERR) {MessagePopup("Attention","Mettre en wait for trigger");return err;}			
			// Pour laisser au powermeter le temps de mettre  jour les filtres numriques
			sprintf(bufM,"TRIG%d:DEL:AUTO ON",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);
				if (err & ERR) {MessagePopup("Attention","Pour laisser au powermeter le temps de mettre  jour les filtres numriques");return err;}		
		// Rglages des mesures
			// Rglage des units de mesure
			sprintf(bufM,"UNIT%d:POW DBM",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Rglage des units de mesure");return err;}
			// Configuration & activation du filtre
			sprintf(bufM,"SENS%d:SPE 20",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Configuration & activation du filtre");return err;}
			// Configuration du filtre dbruiteur
			sprintf(bufM,"SENS%d:AVER:COUN:AUTO ON",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Configuration du filtre dbruiteur");return err;}
			// auto nettoyage du filtre numrique
			sprintf(bufM,"SENS%d:AVER:SDET OFF",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Configuration du filtre dbruiteur");return err;}
			// Configuration du filtre dbruiteur
			sprintf(bufM,"SENS%d:AVER:COUN 4",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Configuration du filtre dbruiteur");return err;}
			// Activation du filtre dbruiteur
			sprintf(bufM,"SENS%d:AVER:STAT ON",tmpvar);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Activation du filtre dbruiteur");return err;}
			// Configurationd de la frquence de d'interpollation des sondes
			sprintf(bufM,"SENS%d:FREQ:FIX %dMHz",tmpvar,data_switch->frequence_fonctionnement);err = ibecr(id_powermeter,bufM);verif_erreur(id_powermeter);   
				if (err & ERR) {MessagePopup("Attention","Configuration de la frquence d'interpollation des sondes");return err;}
			}

	// Initialisation du port parallle pour mesurer RF1.
	val_port_para = inp (0x378);
	val_port_para = val_port_para & (~(data_switch->bit_choisi));
	outp (0x378,val_port_para);


	// Mise  jour des donnes de la structure.
	data_switch->stop_interruption = RQS; 
	data_switch->identificateur = id_powermeter;

	return err; 
}			

int miseenplace_int_powermeter_AB_switch(PInstrument *power_SW)
{
	infos_power_switch *data_switch = power_SW->structure;
	int err=0;
	char chaine[255];

	//initialisation de la section de code critique
	//InitializeCriticalSection(&criticalSection);

	verif_erreur(data_switch->identificateur);	
	// Activation du transfert du rsum du Standard Event byte dans le Status byte
	err=ibecr(data_switch->identificateur,"*ESE 1");
	// Activation de l'interruption lorsque le bit du rsum du Standard Event pass  1
	if ((err = ibecr (data_switch->identificateur, "*SRE 32")) & ERR) // Activation
		{
		sprintf(chaine,"Impossible d'initialiser l'interruption\nsur le frquencemtre d'identificateur %d\n iberr=%x \n ibsta=%x\nibcntl=%x",data_switch->identificateur,iberr,ibsta,ibcntl);
		MessagePopup("Attention !!!",chaine);
		return err;
		}
	verif_erreur(data_switch->identificateur);	

	//Mise  0 de tous les bits d'interruption
	ibecr(data_switch->identificateur,"*ESR?");
	ibrd (data_switch->identificateur,chaine,10); verif_erreur(data_switch->identificateur);

	// Mise en place de l'interruption
	err = ibnotify (data_switch->identificateur, data_switch->stop_interruption, CB_interruption_powermeter_AB_switch,data_switch);
	if (err==ERR)
		{
		sprintf(chaine,"Impossible d'initialiser le frquencemtre\nd'adresse %d",(unsigned short)data_switch->identificateur);
		MessagePopup("Attention !!!",chaine);
		return -1;
		}
	verif_erreur(data_switch->identificateur);	
	// lancement d'une mesure
	if ((err = ibecr (data_switch->identificateur, "*TRG;*OPC"))& ERR) // dclenchement immdiat
		{
		sprintf(chaine,"Impossible de lancer une mesure\nsur le frquencemtre d'identificateur %d\n iberr=%x \n ibsta=%x\nibcntl=%x",data_switch->identificateur,ibsta,ibcntl);
		MessagePopup("Attention !!!",chaine);
		ibnotify (data_switch->identificateur, 0, CB_interruption_powermeter_AB_switch,data_switch); //Dsactivation de l'interruption
		return err;
		}
	return err;
}

int __stdcall CB_interruption_powermeter_AB_switch(int boardOrDevice, int localsta, int localerr, long localcntl,void *callbackData)
{
	infos_power_switch *data_switch;
	int val_port_para = 0;
	extern int Lock_port_parallele;
	char chaine[256];
	int err;

	// Enlever le bit RQS 
	err = ibrsp(boardOrDevice,chaine);        
	switch (localsta)
	{
		case ERR:
			return 0;
	
		default:
			//Rcupration de la structure de donnes
			data_switch = (infos_power_switch *)callbackData;
	
			//Vrification que l'interruption est bien lie  la fin d'une mesure
			ibecr(boardOrDevice,"*ESR?");
			ibrd(boardOrDevice,chaine,10);
			sscanf(chaine,"%d",&err);
			if (!(err & 1)) // 1 = OPC
				return data_switch->stop_interruption; // Pour ractiver l'interruption  
	
			// Prise du port parallle
			CmtGetLock (Lock_port_parallele);
			if (data_switch->etat_switch == 1)
			{
				val_port_para = inp (0x378);
				val_port_para = val_port_para & (~(data_switch->bit_choisi));
				outp (0x378,val_port_para); // La mesure s'effectue sur RF1
			}
			else
			{
				val_port_para = inp (0x378);
				val_port_para = val_port_para | data_switch->bit_choisi;
				outp (0x378,val_port_para); // La mesure s'effectue sur RF2
			}
			// Prise du port parallle
			CmtReleaseLock (Lock_port_parallele);		
		
	
			// Enlever le bit RQS
			err = ibrsp(boardOrDevice,chaine); 
			// Demander la premiere voie
			err = ibecr(boardOrDevice,"FETCH1?");
		    err = ibrd(boardOrDevice,chaine,50);
		    chaine[ThreadIbcntl()]='\0'; //Ajout du caractere de fin de chaine
		    err = sscanf (chaine, "%lf", &(data_switch->zone_memoire[data_switch->etat_switch])); //transformation en flottant
		    // Demander la deuxime voie
			err = ibecr(boardOrDevice,"FETCH2?");
		    err = ibrd(boardOrDevice,chaine,50);
		    chaine[ThreadIbcntl()]='\0'; //Ajout du caractere de fin de chaine
		    err = sscanf (chaine, "%lf", &(data_switch->zone_memoire[data_switch->etat_switch+2])); //transformation en flottant

			// Incrmentation du nombre de mesures.
		    data_switch->numero_mesure[data_switch->etat_switch]++;
		    data_switch->numero_mesure[data_switch->etat_switch+2]++;
      
			// Basculement du switch.
			data_switch->etat_switch = (!data_switch->etat_switch); 
	
			// relancement d'une mesure
		   	ibecr (boardOrDevice, "*TRG;*WAI;*TRG;*WAI;*TRG;*WAI;*TRG;*WAI;*TRG;*OPC"); // dclenchement immdiat

			return data_switch->stop_interruption; // Pour ractiver l'interruption
	}
}

static void arreter_interruption_powermeter_AB_switch(PInstrument *power_SW)
{
	infos_power_switch *data_switch = power_SW->structure;
	
	if (data_switch->stop_interruption == 0) // dj arrt
		return;

	//dsactivation de l'interruption
	data_switch->stop_interruption = 0;
	
	//libration de l'identificateur
	//ibonl (data_switch->identificateur, 0);
}

static void power_SW_nouveau(PInstrument **power_SW)
{
	*power_SW = (PInstrument *)malloc(sizeof(PInstrument));
	memcpy (*power_SW, &power_switch, sizeof(PInstrument));
	(*power_SW)->structure = malloc(sizeof(infos_power_switch));
	((infos_power_switch *)(*power_SW)->structure)->adresse_gpib = 7;
	((infos_power_switch *)(*power_SW)->structure)->frequence_fonctionnement = 110;
	sprintf(((infos_power_switch *)(*power_SW)->structure)->nom_instru, "Powermeter Switch");
}

static void power_SW_liberer(PInstrument *instru)
{
	free(instru->structure);
	free(instru);
}

static void power_SW_get_nom(PInstrument *instrument, char *nom_instru)
{
	memcpy(nom_instru, ((infos_power_switch *)instrument->structure)->nom_instru, TAILLE_NOM_INSTRU-1);
}

static void power_SW_set_nom(PInstrument *instrument, char *nom_instru)
{
	memcpy(((infos_power_switch *)instrument->structure)->nom_instru, nom_instru, TAILLE_NOM_INSTRU-1);
	((infos_power_switch *)instrument->structure)->nom_instru[TAILLE_NOM_INSTRU-1] = NULL;
}

static void power_SW_configure(PInstrument *power_SW)
{
	infos_power_switch *data_power_switch = power_SW->structure;
	int panel;
	if ((panel = LoadPanel (0, "UIR_power_SW.uir", Conf_PowSw)) < 0)
		return ;
					   
	SetCtrlVal (panel, Conf_PowSw_NUM_Conf_Adr_Power, data_power_switch->adresse_gpib);
	SetCtrlVal (panel, Conf_PowSw_RING_Conf_Sw_Power, data_power_switch->bit_choisi); // soucis !
	SetCtrlVal (panel, Conf_PowSw_RING_Conf_Capt_Power, data_power_switch->capteur);
	SetCtrlVal (panel, Conf_PowSw_NUM_Conf_Freq_Fct_Pow, data_power_switch->frequence_fonctionnement); 
	
	SetCtrlAttribute (panel, Conf_PowSw_OK_POWSW, ATTR_CALLBACK_DATA, data_power_switch);
	
	DisplayPanel (panel);
}

static void power_SW_getconfig(PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool)
{
	infos_power_switch *data = instrument->structure;
	
	*p_strct = (void*)data;
	*p_size = sizeof(infos_power_switch);
	
	*p_bool = 1;

}

static int power_SW_nb_voie(PInstrument *power_SW)
{
	infos_power_switch *data_power_switch = power_SW->structure;
	return data_power_switch->nombre_voie;
}

static void power_SW_get_nom_voie(PInstrument *power_SW, int voie, char *nom_voie)
{
	infos_power_switch *data_power = power_SW->structure;
	if ( (data_power->capteur == 6) && ( voie < 3) ) // Voie A (Voie B active)
		sprintf(nom_voie, "Voie A RF%i", voie);

	if ( (data_power->capteur == 6) && ( voie > 2) ) // Voie B (Voie A active)
		sprintf(nom_voie, "Voie B RF%i", voie-2);

	if (data_power->capteur == 4) // Voie B seule
		sprintf(nom_voie, "Voie B RF%i", voie);
	
	if (data_power->capteur == 2) // Voie A seule
		sprintf(nom_voie, "Voie A RF%i", voie);
}

static double power_SW_mesure(PInstrument *power_SW, int voie)
{
	infos_power_switch *result_power = power_SW->structure;
	if (result_power->capteur == 4) // Voie B seule
		return result_power->zone_memoire[voie+1]; // indices 2 et 3
	return result_power->zone_memoire[voie-1];
}

static unsigned int power_SW_numero(PInstrument *power_SW, int voie)
{
	infos_power_switch *result_power = power_SW->structure;
	if (result_power->capteur == 4) // Voie B seule
		return result_power->numero_mesure[voie+1]; // indices 2 et 3
	return result_power->numero_mesure[voie-1];
}

static int power_SW_digits(PInstrument *power_SW)
{
	return 4; // Pierre, c'est sur ? (bis)
}

int verif_erreur(int identificateur)
{
char chaine[255];
int err;
ibecr(identificateur,"SYST:ERR?");
ibrd(identificateur,chaine,255);
sscanf(chaine,"%d",&err);
if (err !=0)
	MessagePopup("Erreur Powermeter",chaine);
	
return err;
}

int CVICALLBACK PowSw_OK (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{

int Valeurs_Configuration_Adresse_GPIB = 0;
int Valeurs_Configuration_Switch = 0;
int Valeurs_Configuration_2ndSwitch = 0;
int Valeurs_Configuration_Capteur = 0;
int Valeurs_Configuration_Frequence_Fonctionnement = 0;

infos_power_switch *structu_inst_sw;

structu_inst_sw = (infos_power_switch *)callbackData;
	
	switch (event)
		{
		case EVENT_COMMIT:
			
			GetCtrlVal (panel, Conf_PowSw_NUM_Conf_Adr_Power, &Valeurs_Configuration_Adresse_GPIB); // Rcupration de l'adresse GPIB
			GetCtrlVal (panel, Conf_PowSw_RING_Conf_Sw_Power, &Valeurs_Configuration_Switch); // Rcupration du bit port parallle pour voie A ou B
			GetCtrlVal (panel, Conf_PowSw_RING_Conf_2ndSw_Power, &Valeurs_Configuration_2ndSwitch); // Rcupration du bit port parallle pour voie A et B			
			GetCtrlVal (panel, Conf_PowSw_RING_Conf_Capt_Power, &Valeurs_Configuration_Capteur); // Rcupration du capteur utilis
			GetCtrlVal (panel, Conf_PowSw_NUM_Conf_Freq_Fct_Pow, &Valeurs_Configuration_Frequence_Fonctionnement); // Rcupration de la frquence de fonctionnement
			
			structu_inst_sw->adresse_gpib = Valeurs_Configuration_Adresse_GPIB;
			
			if (Valeurs_Configuration_Capteur != 6)
			{
				structu_inst_sw->bit_choisi = Valeurs_Configuration_Switch;
				structu_inst_sw->nombre_voie = 2;
			}
			else
			{
				structu_inst_sw->bit_choisi = (Valeurs_Configuration_Switch | Valeurs_Configuration_2ndSwitch);
				structu_inst_sw->nombre_voie = 4;
			}
				
			structu_inst_sw->capteur = Valeurs_Configuration_Capteur;
			structu_inst_sw->frequence_fonctionnement = Valeurs_Configuration_Frequence_Fonctionnement;
			
			DiscardPanel (panel); // Dtruit la fentre "CONFIGURATION D'UN APPAREIL" pour un powermeter
			
			break;
		}
	return 0;
}

int CVICALLBACK Prog_Configuration_Power_Choix_Voie (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
int Valeur_Choix_Voie = 0;
int swa=0,swb=0;	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlAttribute (panel, Conf_PowSw_RING_Conf_Sw_Power, ATTR_DIMMED, &swa); // Rend le choix du "switch utilis" de la fentre "CONFIGURATION DE L'APPAREIL" pour un powermeter inactif
			GetCtrlAttribute (panel, Conf_PowSw_RING_Conf_2ndSw_Power, ATTR_DIMMED, &swb); // Rend le choix du "switch utilis" de la fentre "CONFIGURATION DE L'APPAREIL" pour un powermeter inactif
			swa+=swb;
			
			if (swa) // au moins un des deux contrles tait actif => switch => il faut continuer  les grer
				{
				GetCtrlVal (panel, Conf_PowSw_RING_Conf_Capt_Power, &Valeur_Choix_Voie);

				if (Valeur_Choix_Voie == 2)
					{
					SetCtrlAttribute (panel, Conf_PowSw_RING_Conf_2ndSw_Power, ATTR_DIMMED, 1); // inactif
					}
				
				if (Valeur_Choix_Voie == 4)
					{
					SetCtrlAttribute (panel, Conf_PowSw_RING_Conf_2ndSw_Power, ATTR_DIMMED, 1); // inactif
					}
				
				if (Valeur_Choix_Voie == 6)
					{
					SetCtrlAttribute (panel, Conf_PowSw_RING_Conf_2ndSw_Power, ATTR_DIMMED, 0); // actif
					}
				 }
			break;
		}
	return 0;
}
