/*-------------------------------------------
reader.h
Lecture des en-tte des sauvegardes des configs
JD.
07/07/2006
--------------------------------------------*/


typedef struct
{

	char** int_words;
	int*   int_values;
	int int_N;
	
	char**  double_words;
	double* double_values;
	int double_N;
	
	char** string_words;
	char** string_values;
	int string_N;


}DICTIONARY;


// Initialise la structure
int reader_init(DICTIONARY* dico);

// Libre la mmoire
int reader_free(DICTIONARY* dico);

// Lit un fichier, le parse et stocke tout ce qui va bien.
int reader_load_file( char* filename, DICTIONARY* dico);

// Retourne l'entier associ au mot pass en paramtre
int reader_return_int( char* word, DICTIONARY* dico);

// Retourne le double associ au mot pass en paramtre
double reader_return_double( char* word, DICTIONARY* dico);

// Retourne la chaine associ au mot pass en paramtre
char* reader_return_string( char* word, DICTIONARY* dico);




// Rajoute la string pass en param  la liste.
int reader_add_string_to_list(char*,char***,int);

// Rajoute l'int pass en param  la liste.
int reader_add_int_to_list(int,int**,int);

// Rajoute le double pass en param  la liste.
int reader_add_double_to_list(double,double**,int);

// Extrait la partie utile d'une chaine
int reader_extract_string( char* string );

// Extrait la valeur de gauche et celle de droite
int reader_extract_values( char*, char*, char* );

// Retourne le type de la rvalue.
// 1-int 2-double 3-string   
int reader_return_rvalue_type( char* rvalue );

// Convertit la rvalue vers une string.
int reader_convert_rvalue_to_string( char* rvalue, char* string );

// Convertit la rvalue vers un int.
int reader_convert_rvalue_to_int( char* rvalue, int* value );   

// Convertit la rvalue vers un double.
int reader_convert_rvalue_to_double( char* rvalue, double* value );   
