#include <userint.h>
#include <ansi_c.h>
#include "plugin.h"
#include "reboucleur.h"
#include <utility.h>
#include "UIR_boucleur.h"

PInstrument boucleur =
{
	NULL, // rempli par nouveau
	
	NULL, // rempli aprs nouveau (par liste.c)
	NULL,
	NULL,
	NULL,
	NULL,

	boucle_nouveau,
	boucle_liberer,
	boucle_configure,
	boucle_get_config,
	boucle_get_nom,
	boucle_set_nom,
	NULL,
	NULL,
	boucle_init,
	NULL, // status
	boucle_execute, // execute
	boucle_configure, // configurer et piloter, dans ce cas, c'est la meme fonction

	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,

	boucle_nb_voie,
	boucle_get_nom_voie,
	boucle_mesure,
	boucle_calculer,

	NULL,
	NULL,
	NULL,
	NULL,
	
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

static void boucle_nouveau (PInstrument **boucle)
{
	*boucle = (PInstrument *)malloc(sizeof(PInstrument));
	memcpy (*boucle, &boucleur, sizeof(PInstrument));
	(*boucle)->structure = malloc(sizeof(infos_boucleur));
	sprintf(((infos_boucleur *)(*boucle)->structure)->nom, "Reboucleur");
	sprintf(((infos_boucleur *)(*boucle)->structure)->inputstr, "toto=$$");
	// total: 3 malloc
}

static void boucle_liberer (PInstrument *boucle)
{
	free(boucle->structure);
	free(boucle);
	// total: 3 free
}

static void boucle_configure (PInstrument *boucle)
{
	infos_boucleur *data = boucle->structure;

	int panel;
	if ((panel = LoadPanel (0, "UIR_boucleur.uir", P_config)) < 0)
		return;
	SetCtrlAttribute (panel, P_config_COMMANDBUTTON, ATTR_CALLBACK_DATA, data);
	SetCtrlAttribute (panel, P_config_CACHER, ATTR_CALLBACK_DATA, data);
	SetCtrlAttribute (panel, P_config_ENVOI, ATTR_CALLBACK_DATA, data);
	
	boucle->init_liste_voie(panel, P_config_RING1);
	SetCtrlVal(panel, P_config_RING1, data->tatoo_voie1);
	
	boucle->init_liste_voie2D(panel, P_config_RING2);
	SetCtrlVal(panel, P_config_RING2, data->tatoo_instru);
	
	SetCtrlVal(panel, P_config_STRING, data->inputstr);

	SetCtrlVal(panel, P_config_MODE, data->mode);
	
	affichage_selon_mode(panel);
	
	DisplayPanel (panel); // Affiche la fentre
}

static void boucle_get_config (PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool)
{
	infos_boucleur* data = instrument->structure;
	
	*p_strct = (void*)data;
	*p_size = sizeof(infos_boucleur);
	
	*p_bool = 1;
}

static int boucle_nb_voie (PInstrument *instrument)
{
	return 0;
}

static void boucle_get_nom_voie (PInstrument *instrument, int voie, char *nom_voie)
{
	sprintf(nom_voie, "Inconnue");
}

static void boucle_get_nom (PInstrument *boucle, char *nom_instru)
{
	memcpy(nom_instru, ((infos_boucleur *)boucle->structure)->nom, TAILLE_NOM_INSTRU-1);
}

static void boucle_set_nom (PInstrument *boucle, char *nom_instru)
{
	memcpy(((infos_boucleur *)boucle->structure)->nom, nom_instru, TAILLE_NOM_INSTRU-1);
	((infos_boucleur *)boucle->structure)->nom[TAILLE_NOM_INSTRU-1] = NULL;
}

static double boucle_mesure (PInstrument *instrument, int voie)
{
	return 0;
}

static void boucle_calculer (PInstrument *instrument)//, ptr_buff_circu *buffer_circu, ptr_buff2D_circu *buffer2D_circu)
{
	double mesure1 = 0;
	char chaine[255];
	infos_boucleur *data = instrument->structure;
	ptr_buff_circu *buffer1D;
	ptr_buff2D_circu *buffer;
	
	PInstrument *instru;

	if (data->mode == 0) // Off
		return;

	if (data->mode == 2) // Manu
	{
		if (data->schedule_cmd == 0) return;
		data->schedule_cmd = 0;
	}

	buffer1D = instrument->get_buffer_from_tatoo(((infos_boucleur *)instrument->structure)->tatoo_voie1);
	if ( ((strstr (data->inputstr, "$$") != NULL)) && (buffer1D !=NULL) )
	{
		mesure1 = buffer1D->mesure[buffer1D->dernier_indice];
		sprintf(chaine, data->template, mesure1);
	}
	else
		strcpy(chaine, data->inputstr);
	
	buffer = instrument->get_buffer2D_from_tatoo(((infos_boucleur *)instrument->structure)->tatoo_instru);
	if (buffer == NULL) return;

	instru = buffer->instrument;
	if (instru && instru->execute)
		instru->execute(instru, chaine);
	
	return;
}

static int boucle_init (PInstrument *instrument)
{
	return 0;
}

static void	boucle_execute (PInstrument *instrument, char *chaine)
{
	infos_boucleur *data = instrument->structure;
	// une seule commande reconnue, autant ne pas la reconnaitre (je sais, c pas terrible)
	data->schedule_cmd = 1;
}

static void template_get(char *dest, char *source)
{
	char *ptr;
	
	strcpy(dest, source);
	
	ptr = strstr (dest, "$$");
	if (ptr != NULL)
	{
		ptr[0]='%';
		ptr[1]='e';
	}
	// TODO: remplacer les ventuels % par %% pour que printf ne les interprete pas
}
static void affichage_selon_mode(int panel)
{
	int mode;
	
	GetCtrlVal(panel, P_config_MODE, &mode);
	
	switch(mode)
	{
		case 0: // Off
			//SetCtrlAttribute (panel, P_config_RING1, ATTR_DIMMED, 0);
			SetCtrlAttribute (panel, P_config_ENVOI, ATTR_DIMMED, 1);
			break;
		case 1: // Auto
			//SetCtrlAttribute (panel, P_config_RING1, ATTR_DIMMED, 0);
			SetCtrlAttribute (panel, P_config_ENVOI, ATTR_DIMMED, 1);
			break;
		case 2: // Manu
			//SetCtrlAttribute (panel, P_config_RING1, ATTR_DIMMED, 0);
			SetCtrlAttribute (panel, P_config_ENVOI, ATTR_DIMMED, 0);
			break;
	}
}

int CVICALLBACK OK_config_calcul_boucle (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	infos_boucleur *structu_boucle;
	structu_boucle = (infos_boucleur *)callbackData;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal(panel, P_config_RING1, structu_boucle->tatoo_voie1);
			GetCtrlVal(panel, P_config_RING2, structu_boucle->tatoo_instru);
			GetCtrlVal(panel, P_config_STRING, structu_boucle->inputstr);
			GetCtrlVal(panel, P_config_MODE, &structu_boucle->mode);
			
			template_get(structu_boucle->template, structu_boucle->inputstr);
			break;
		}
	return 0;
}

int CVICALLBACK CACHER_config_calcul_boucle (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			DiscardPanel(panel);
			break;
		}
	return 0;
}

int CVICALLBACK MODE_config_calcul_boucle (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			affichage_selon_mode(panel);
			break;
		}
	return 0;
}

int CVICALLBACK ENVOI_config_calcul_boucle (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	infos_boucleur *data;
	data = (infos_boucleur *)callbackData;
	switch (event)
		{
		case EVENT_COMMIT:
			data->schedule_cmd = 1;
			break;
		}
	return 0;
}
