
/*-------------------------------------------
save.c
Sauvegarde des configs des instruments.
JD.
07/07/2006
--------------------------------------------*/

#include <ansi_c.h>
#include "save.h"

// Initialise la structure. NE PAS OUBLIER SINON .... BOUM !
void init_save(SAVE_INFOS* p_sifs)
{
	p_sifs->structures = NULL;
	p_sifs->endings = NULL;
	p_sifs->names = NULL;
	p_sifs->tatoos = NULL;
	p_sifs->noms = NULL;
	p_sifs->N = 0;

	return;
}

void add_struct_to_save_B( SAVE_INFOS* p_sifs, void* p_struct, size_t size, char* name, int tatoo, char* nom)
{
	add_struct_to_save_A(p_sifs, p_struct, (void*)((int)p_struct + size ), name, tatoo, nom);
	
	return;
}

// Ajoute une sauvegarde  faire dans la pile.
void add_struct_to_save_A( SAVE_INFOS* p_sifs, void* p_struct, void* p_end, char* name, int tatoo, char* nom)
{

	if( (p_sifs->structures == NULL)&&(p_sifs->endings == NULL) )
	{
		// On alloue un elem dans chaque tableau.
		p_sifs->N = 1;
		if( !(p_sifs->structures = (void**)malloc(sizeof(void*)) ) ) return;
		if( !(p_sifs->endings	 = (void**)malloc(sizeof(void*)) ) ) return;
		if( !(p_sifs->names 	 = (char**)malloc(sizeof(char*)) ) ) return;		
		if( !(p_sifs->tatoos 	 = (int*)malloc(sizeof(int)) ) ) return;
		if( !(p_sifs->noms	 	 = (char**)malloc(sizeof(char*)) ) ) return;		
		
		*(p_sifs->structures) = p_struct;
		*(p_sifs->endings) = p_end;
		*(p_sifs->names) = malloc((strlen(name) + 1)*sizeof(char));
		strcpy(*(p_sifs->names),name);
		*(p_sifs->tatoos) = tatoo;
		*(p_sifs->noms) = malloc((strlen(nom) + 1)*sizeof(char));
		strcpy(*(p_sifs->noms),nom);
	}
	else
	{
		p_sifs->N++;
		if( !( p_sifs->structures = (void**)realloc(p_sifs->structures, (p_sifs->N)*sizeof(void*)) ) ) return;
		if( !( p_sifs->endings	  = (void**)realloc(p_sifs->endings,    (p_sifs->N)*sizeof(void*)) ) ) return;
		if( !( p_sifs->names	  = (char**)realloc(p_sifs->names,      (p_sifs->N)*sizeof(char*)) ) ) return;
		if( !( p_sifs->tatoos	  = (int*)realloc(p_sifs->tatoos,       (p_sifs->N)*sizeof(int)) ) ) return;
		if( !( p_sifs->noms		  = (char**)realloc(p_sifs->noms,       (p_sifs->N)*sizeof(char*)) ) ) return;
		
		(p_sifs->structures)[(p_sifs->N)-1] = p_struct;
		(p_sifs->endings)[(p_sifs->N)-1] = p_end;
		(p_sifs->names)[(p_sifs->N)-1] = malloc((strlen(name) + 1)*sizeof(char));
		strcpy((p_sifs->names)[(p_sifs->N)-1],name);
		(p_sifs->tatoos)[(p_sifs->N)-1] = tatoo;
		(p_sifs->noms)[(p_sifs->N)-1] = malloc((strlen(nom) + 1)*sizeof(char));
		strcpy((p_sifs->noms)[(p_sifs->N)-1],nom);
	}
	
	return;
}

// Sauvegarde tout dans le fichier de config.
void save_all(char* filename, SAVE_INFOS* p_sifs)
{
	int i;
	int i_tmp;

	FILE* f = fopen(filename,"w");
	
	// On ajoute une chaine avec les noms des types d'instruments, le tatoo
	for(i=0;i<(p_sifs->N);i++)
		fprintf(f,"#%s %d",(p_sifs->names)[i],(p_sifs->tatoos)[i]);
	
	fprintf(f,"#\n");
	
	// On commence par crire le nombre d'lments dans un int.
	fwrite(&(p_sifs->N),sizeof(int),1,f);
	
	// Pour chaque lment on ajoute ensuite un entier correspondant  la taille 
	// de la structure  stocker.
	for(i=0;i<(p_sifs->N);i++)
	{
		i_tmp = (int)((p_sifs->endings)[i]) - (int)((p_sifs->structures)[i]);
		fwrite(&i_tmp,sizeof(int),1,f);
	}
	
	// Puis on ajoute, enfin, les structures.
	for(i=0;i<(p_sifs->N);i++)
		fwrite((p_sifs->structures)[i],
		   (int)((p_sifs->endings)[i]) - (int)((p_sifs->structures)[i]), 1, f);
	
	
	
	fclose(f);

	return;
}

// Charge tout depuis le fichier de config vers les structures empils
// NOTE : Elles doivent etre empils dans le mme ordre que lors de la svgde
void load_all(char* filename, SAVE_INFOS* p_sifs)
{
	int i,N;
	char c;
	
	int tailles[256]; // Pense que 256 instruments a devrait suffir... :)
	
	FILE* f = fopen(filename,"r");
	
	if(!f) return;
	
	// On avance jusqu'en bout de ligne.
	while ( (c = fgetc(f)) != '\n');
	
	// Donc logiquement l on vient de passer devant la lignes des noms.
	
	// On chope l'entier rep. le nombre d'entiers sotckant les tailles de strct
	fread(&N,sizeof(int),1,f);
	
	// On lit les N entiers.
	for(i=0;i<N;i++)
		fread(tailles + i, sizeof(int), 1, f);
	
	// On lit les structures et on les injectes.
	for(i=0;i<N;i++)
		fread((p_sifs->structures)[i],
			(int)((p_sifs->endings)[i]) - (int)((p_sifs->structures)[i]), 1, f);
	
	fclose(f);
}

// Renvoie le type d'instrument de la structure n dans le fichier.
int get_struct_type(char* filename, int n, char* string)
{
	int err;

	char tmp[256];
	
	err = get_struct_string(filename, n,tmp);
	
	sscanf(tmp,"%s %*d",string);

	return err;
}

// Renvoie le tatoo de la structure n dans le fichier.
int get_struct_tatoo(char* filename, int n, int* tatoo)
{
	int err;

	char tmp[256];
	
	err = get_struct_string(filename, n,tmp);
	
	sscanf(tmp,"%*s %d",tatoo);
					  
	return err;
}

// Renvoie le nom de la structure n
int get_struct_string(char* filename, int N, char* string)
{

	char str[256];

	int i = 0;

	char c;
	
	int n = 0;

	FILE* f = fopen(filename,"r");
	
	while( 1 )
	{
		while( (c = fgetc(f)) != '#' )
			if( c == '\n' )
			{	
				fclose(f);
				return 0;		
			}
				
		n++;
		
		if( n == N )
		{
			while( (c = fgetc(f)) != '#' )
			{
				if( c == '\n' )
				{
					fclose(f);
					return 0;
				}
				
				str[i++] = c;
			}
			
			str[i++] = '\0';
				
			strcpy(string,str);
			
			fclose(f);			
			
			return 1;
		}
	}
	
	fclose(f);
	
	return 1;
}


// Detruit les allocs.
void free_all(SAVE_INFOS* p_sifs)
{
	
	int i;
	
	for(i=0;i<(p_sifs->N);i++)
		free( (p_sifs->names)[i] );
	
	if( !(p_sifs->structures) )	free( p_sifs->structures );
	if( !(p_sifs->endings) )	free( p_sifs->endings );
	if( !(p_sifs->names) ) 		free( p_sifs->names );
	if( !(p_sifs->tatoos) ) 	free( p_sifs->tatoos );
	if( !(p_sifs->noms) ) 		free( p_sifs->noms );
	
	return;
}
