/*-------------------------------------------
save.h
Sauvegarde des configs des instruments.
JD.
07/07/2006
--------------------------------------------*/

typedef struct 
{

	void** structures;
	
	void** endings;
	
	char** names;
	
	int* tatoos;
	
	char** noms;
	
	int N;

}SAVE_INFOS;

// Initialise la structure. NE PAS OUBLIER SINON .... BOUM !
void init_save(SAVE_INFOS*);

// Ajoute une sauvegarde  faire dans la pile.
// Version Debut / Fin
void add_struct_to_save_A( SAVE_INFOS*, void* p_struct, void* p_end, char* name, int tatoo, char* nom);

// Ajoute une sauvegarde  faire dans la pile.
// Version Debut / Taille
void add_struct_to_save_B( SAVE_INFOS*, void* p_struct, size_t size, char* name, int tatoo, char* nom);

// Sauvegarde tout dans le fichier de config.
void save_all(char* filename, SAVE_INFOS*); 

// Charge tout depuis le fichier de config vers les structures empils
// NOTE : Elles doivent etre empils dans le mme ordre que lors de la svgde
void load_all(char* filename, SAVE_INFOS*);

// Renvoie le type d'instrument de la structure n dans le fichier.
int get_struct_type(char* filename, int n, char* string);

// Renvoie le tatoo de la structure n dans le fichier.
int get_struct_tatoo(char* filename, int n, int* tatoo);

// Renvoie la chaine "brute" de la structure n dans le fichier.
int get_struct_string(char* filename, int n, char* string);

// Detruit les allocs.
void free_all(SAVE_INFOS*);
