#include <ansi_c.h>
#include <userint.h>
#include <gpib.h>
#include "globales.h"
#include <formatio.h>
#include "tektro3052.h"
#include "UIR_tektro3052.h"
#include "plugin.h"

PInstrument tek =
{
	NULL, // Rempli par 'nouveau'

	NULL, // rempli aprs nouveau (par liste.c)
	NULL,
	NULL,
	NULL,
	NULL,

	tek_nouveau,
	tek_liberer,
	tek_configure,
	tek_getconfig,
	tek_get_nom,
	tek_set_nom,
	arreter_interruption_tek,
	miseenplace_int_tek,
	tek_init,
	NULL,
	NULL,
	NULL,
	
	tek_nb_voie,
	tek_get_nom_voie,
	tek_get_taille_voie,
	tek_mesure,
	tek_indices,
	tek_numero,

	NULL,
	NULL,
	NULL,
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

int CVICALLBACK TEK_OK (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	infos_tektro *structu;
	structu = (infos_tektro *)callbackData;

	switch (event)
		{
		case EVENT_COMMIT:
		
			GetCtrlVal (panel, P_CFG_TEK_GPIB, &structu->adresse_gpib);
			
			GetCtrlVal (panel, P_CFG_TEK_ACQMOD, structu->acqmod);
			GetCtrlVal (panel, P_CFG_TEK_ACQNUMAV, &structu->acqnumav);
			GetCtrlVal (panel, P_CFG_TEK_ACQNUME, &structu->acqnume);
			GetCtrlVal (panel, P_CFG_TEK_CH1BAN, structu->ch1ban);
			GetCtrlVal (panel, P_CFG_TEK_CH2BAN, structu->ch2ban);
			GetCtrlVal (panel, P_CFG_TEK_CH1COUP, structu->ch1coup);
			GetCtrlVal (panel, P_CFG_TEK_CH2COUP, structu->ch2coup);
			GetCtrlVal (panel, P_CFG_TEK_CH1IMP, structu->ch1imp);
			GetCtrlVal (panel, P_CFG_TEK_CH2IMP, structu->ch2imp);
			GetCtrlVal (panel, P_CFG_TEK_CH1INV, &structu->ch1inv);
			GetCtrlVal (panel, P_CFG_TEK_CH2INV, &structu->ch2inv);
			GetCtrlVal (panel, P_CFG_TEK_CH1OFF, &structu->ch1off);
			GetCtrlVal (panel, P_CFG_TEK_CH2OFF, &structu->ch2off);
			GetCtrlVal (panel, P_CFG_TEK_CH1PROBE, &structu->ch1probe);
			GetCtrlVal (panel, P_CFG_TEK_CH2PROBE, &structu->ch2probe);
			GetCtrlVal (panel, P_CFG_TEK_CH1SCA, &structu->ch1sca);
			GetCtrlVal (panel, P_CFG_TEK_CH2SCA, &structu->ch2sca);
			GetCtrlVal (panel, P_CFG_TEK_HORMAISCA, &structu->hormaisca);
			GetCtrlVal (panel, P_CFG_TEK_HOR_unit, &structu->hor_unit);
			GetCtrlVal (panel, P_CFG_TEK_HORRECORD, &structu->horrecord);
			GetCtrlVal (panel, P_CFG_TEK_HORTRIGPOS, &structu->hortrigpos);
			GetCtrlVal (panel, P_CFG_TEK_TRIGAEDGCOUP, structu->trigaedgcoup);
			GetCtrlVal (panel, P_CFG_TEK_TRIGAEDGCOUP, structu->trigaedgcoup);
			GetCtrlVal (panel, P_CFG_TEK_TRIGAEDGSLO, structu->trigaedgslo);
			GetCtrlVal (panel, P_CFG_TEK_TRIGAEDGSOU, structu->trigaedgsou);
			GetCtrlVal (panel, P_CFG_TEK_TRIGALEV, &structu->trigalev);
			GetCtrlVal (panel, P_CFG_TEK_MATH1, structu->math1);
			GetCtrlVal (panel, P_CFG_TEK_MATH2, structu->math2);
			GetCtrlVal (panel, P_CFG_TEK_MATHF, structu->mathf);
			GetCtrlVal (panel, P_CFG_TEK_FENETRE, structu->fenetre);
			GetCtrlVal (panel, P_CFG_TEK_LINLOG, structu->linlog);
			GetCtrlVal (panel, P_CFG_TEK_SELCH1, &structu->selch1);
			GetCtrlVal (panel, P_CFG_TEK_SELCH2, &structu->selch2);
			GetCtrlVal (panel, P_CFG_TEK_SELMATH, &structu->selmath);
			
			DiscardPanel (panel); // Dtruit la fentre "CONFIGURATION D'UN APPAREIL" pour un frquencemtre
			
			break;
		}
	return 0;
}

static int tek_init(PInstrument *tektro)
{
	infos_tektro *data_osc = tektro->structure;
	char chaine[255];
	int err=0, id_cont=0, cpt_voie;
	short err_short=0;
	
	err = ibfind("GPIB0");
	if (err & ERR)
	{
		MessagePopup ("Problme de carte", "Carte GPIB non dtecte");
		return -1;
	}
	
	// Dtection d'un instrument  l'adresse indique
	id_cont = ibdev (0, data_osc->adresse_gpib, NO_SAD, T10s, 1, 1);
	ibclr (id_cont);
	ibln (id_cont, data_osc->adresse_gpib, NO_SAD, &err_short); 

	if (err_short == 0) 
		{
		sprintf(chaine,"Il faudrait penser  brancher l'oscilloscope  l'adresse %d !!!",data_osc->adresse_gpib);
		MessagePopup ("PAS BON", chaine);
		return -1;
		}
	
	ibecr(id_cont,"HEADER ON");
	ibecr(id_cont,"VERB OFF");
	
	ibecr(id_cont, "*IDN?");
	ibrd(id_cont, chaine, 250);
	if (strstr (chaine, "TEKTRONIX,TDS 3052") == NULL)
	{
		MessagePopup ("Erreur", "Modle non support par ce module !");
		return -1;
	}

	// initialisation
	sprintf(chaine, "ACQ:MOD %s", data_osc->acqmod); ibecr(id_cont, chaine);
	sprintf(chaine, "ACQ:NUMAV %i", data_osc->acqnumav); ibecr(id_cont, chaine);
	sprintf(chaine, "ACQ:NUME %i", data_osc->acqnume); ibecr(id_cont, chaine);
	ibecr(id_cont, "ACQ:STOPA SEQ");
	sprintf(chaine, "CH1:BAN %s", data_osc->ch1ban); ibecr(id_cont, chaine);
	sprintf(chaine, "CH2:BAN %s", data_osc->ch2ban); ibecr(id_cont, chaine);
	sprintf(chaine, "CH1:COUP %s", data_osc->ch1coup); ibecr(id_cont, chaine);
	sprintf(chaine, "CH2:COUP %s", data_osc->ch2coup); ibecr(id_cont, chaine);
	sprintf(chaine, "CH1:IMP %s", data_osc->ch1imp); ibecr(id_cont, chaine);
	sprintf(chaine, "CH2:IMP %s", data_osc->ch2imp); ibecr(id_cont, chaine);
	sprintf(chaine, "CH1:INV %i", data_osc->ch1inv); ibecr(id_cont, chaine);
	sprintf(chaine, "CH2:INV %i", data_osc->ch2inv); ibecr(id_cont, chaine);
	sprintf(chaine, "CH1:OFF %f", data_osc->ch1off); ibecr(id_cont, chaine);
	sprintf(chaine, "CH2:OFF %f", data_osc->ch2off); ibecr(id_cont, chaine);
	sprintf(chaine, "CH1:PROBE %f", data_osc->ch1probe); ibecr(id_cont, chaine);
	sprintf(chaine, "CH2:PROBE %f", data_osc->ch2probe); ibecr(id_cont, chaine);
	sprintf(chaine, "CH1:SCA %f", data_osc->ch1sca); ibecr(id_cont, chaine);
	sprintf(chaine, "CH2:SCA %f", data_osc->ch2sca); ibecr(id_cont, chaine);
	ibecr(id_cont, "HOR:DEL:STATE OFF");
	sprintf(chaine, "HOR:MAI:SCA %ie%i", data_osc->hormaisca, data_osc->hor_unit); ibecr(id_cont, chaine);
	sprintf(chaine, "HOR:RECORD %i", data_osc->horrecord); ibecr(id_cont, chaine);
	sprintf(chaine, "HOR:TRIG:POS %i", data_osc->hortrigpos); ibecr(id_cont, chaine);
	if (!strcmp(data_osc->mathf, "FFT"))
		sprintf(chaine, "MATH:DEFINE \"FFT(%s,%s,%s)\"", data_osc->math1, data_osc->fenetre, data_osc->linlog);
	else
		sprintf(chaine, "MATH:DEFINE \"%s%s%s\"", data_osc->math1, data_osc->mathf, data_osc->math2);
	ibecr(id_cont, chaine);
	sprintf(chaine, "SEL:CH1 %i", data_osc->selch1); ibecr(id_cont, chaine);
	sprintf(chaine, "SEL:CH2 %i", data_osc->selch2); ibecr(id_cont, chaine);
	sprintf(chaine, "SEL:MATH %i", data_osc->selmath); ibecr(id_cont, chaine);
	sprintf(chaine, "TRIG:A:EDG:COUP %s", data_osc->trigaedgcoup); ibecr(id_cont, chaine);
	sprintf(chaine, "TRIG:A:EDG:SLO %s", data_osc->trigaedgslo); ibecr(id_cont, chaine);
	sprintf(chaine, "TRIG:A:EDG:SOU %s", data_osc->trigaedgsou); ibecr(id_cont, chaine);
	ibecr(id_cont, "TRIG:A:HOL:TIM 2.5e-7");
	sprintf(chaine, "TRIG:A:LEV %f", data_osc->trigalev); ibecr(id_cont, chaine);
	ibecr(id_cont, "TRIG:A:MOD NORM");
	ibecr(id_cont, "TRIG:A:TYP EDGE");
	
	ibecr(id_cont, "DAT:ENC SRP");
	ibecr(id_cont, "DAT:WID 2");
	ibecr(id_cont, "DAT:STAR 1");
	sprintf(chaine, "DAT:STOP %i", data_osc->horrecord); ibecr(id_cont, chaine);
	
	// Mise  jour des donnes de la structure.
	data_osc->identificateur = id_cont;
	data_osc->stop_interruption = RQS; 
	data_osc->numero_mesure = 0;
	
	// Voies actives
	data_osc->voie_active[0] = data_osc->selch1;
	data_osc->voie_active[1] = data_osc->selch2;
	data_osc->voie_active[2] = data_osc->selmath;

	// Construction des indices (fixes donc)
	cpt_voie = 0;
	if (data_osc->voie_active[0] != 0)
	{
		recup_axe(id_cont, "CH1", data_osc->indices[cpt_voie]);
		cpt_voie++;
	}
			
	if (data_osc->voie_active[1] != 0)
	{
		recup_axe(id_cont, "CH2", data_osc->indices[cpt_voie]);
		cpt_voie++;
	}
			
	if (data_osc->voie_active[2] != 0)
	{
		recup_axe(id_cont, "MATH", data_osc->indices[cpt_voie]);
		cpt_voie++;
	}
	
	return err;
}

/* Fonction de mise en place de l'interruption Renvoit CMPL (0x0100) en cas de succs.*/
static int miseenplace_int_tek(PInstrument *tektro)
{
	infos_tektro *data_osc = tektro->structure;
	int err=0;
	char chaine[255];
	
	err=ibecr(data_osc->identificateur,"DESE 1");
	err=ibecr(data_osc->identificateur,"*ESE 1");
	// Activation de l'interruption  la fin des mesures sur le frquencemtre
	if ((err = ibecr (data_osc->identificateur, "*SRE 32")) & ERR) // Activation
	{
		sprintf(chaine,"Impossible d'initialiser l'interruption (tektro)");
		MessagePopup("Attention !!!",chaine);
		return err;
	}

	// Nettoyage du registre d'interruptions
	ibecr(data_osc->identificateur,"*ESR?");
	ibrd(data_osc->identificateur,chaine,10);
	
	// Mise en place de l'interruption
	err = ibnotify (data_osc->identificateur, data_osc->stop_interruption, CB_interruption_tek, data_osc);
	if (err & ERR)
	{
		sprintf(chaine,"Impossible d'initialiser le tektro");
		MessagePopup("Attention !!!",chaine);
		return -1;
	}
	
	// lancement d'une mesure
	if ((err = ibecr (data_osc->identificateur, "ACQ:STATE RUN;*OPC"))& ERR) // dclenchement immdiat
	{
		sprintf(chaine,"Impossible de lancer une mesure");
		MessagePopup("Attention !!!",chaine);
		ibnotify (data_osc->identificateur, 0, CB_interruption_tek, NULL); //Dsactivation de l'interruption
		return err;
	}
	return err;
}
	

int __stdcall CB_interruption_tek(int boardOrDevice, int localsta, int localerr, long localcntl, void *callbackData)
{
	infos_tektro *data_osc;

	char chaine[256];
	//double tabdou[10000];
	int cpt_voie;
	
	switch (localsta)
	{
		case ERR:
			return 0;
		default:
	
			ibrsp(boardOrDevice,chaine);
			
			data_osc = (infos_tektro *)callbackData;
			cpt_voie = 0;
			
			if (data_osc->voie_active[0] != 0)
			{
				recup_curve(boardOrDevice, "CH1", data_osc->mesures[cpt_voie]);
				cpt_voie++;
			}
			
			if (data_osc->voie_active[1] != 0)
			{
				recup_curve(boardOrDevice, "CH2", data_osc->mesures[cpt_voie]);
				cpt_voie++;
			}
			
			if (data_osc->voie_active[2] != 0)
			{
				recup_curve(boardOrDevice, "MATH", data_osc->mesures[cpt_voie]);
				cpt_voie++;
			}
	/*if ( (data_osc->mesures[cpt_voie-1][0]>-10) )
		chaine[0]=0;*/ // pour breaker
			
			// Incrmentation du nombre de mesures.
		    data_osc->numero_mesure++; 

			// Nettoyage du registre d'interruptions
			ibecr(boardOrDevice,"*ESR?");
			ibrd(boardOrDevice,chaine,10);
	
			// relancement d'une mesure
			ibecr (boardOrDevice, "ACQ:STATE RUN;*OPC"); // dclenchement immdiat
	
			return data_osc->stop_interruption; // Pour ractiver l'interruption
	
	}
}

static void recup_curve(int device, char *channel, double *tabdou)
{
	int taille_nbbyte, nbbyte;
	int err1, err2, err3, err4, err5;
	char chaine[50];
	unsigned short int tabint[10000];
	float yof, ymu, yze;
	int cpt_point;
	
	sprintf(chaine, "DAT:SOU %s", channel);
	err1 = ibecr(device, chaine);
	
	err2= ibecr(device, "CURVE?");
	ibrd(device, chaine, strlen(":CURV #"));
	ibrd(device, chaine, 1);
	sscanf(chaine, "%d", &taille_nbbyte);
	ibrd(device, chaine, taille_nbbyte);
	sscanf(chaine, "%d", &nbbyte);
	ibrd(device, tabint, nbbyte);
	ibrd(device, chaine, 1);
	
	err3 = ibecr(device, "WFMP:YOF?");
	ibrd(device, chaine, 50);
	sscanf(chaine, ":WFMP:YOF %f", &yof);
	
	err4 = ibecr(device, "WFMP:YMU?");
	ibrd(device, chaine, 50);
	sscanf(chaine, ":WFMP:YMU %f", &ymu);
	
	err5 = ibecr(device, "WFMP:YZE?");
	ibrd(device, chaine, 50);
	sscanf(chaine, ":WFMP:YZE %f", &yze);

	// pt = (curve - yof) * ymu + yze
	for (cpt_point = 0; cpt_point<nbbyte/2; cpt_point++)
		tabdou[cpt_point] = yze + ymu * (tabint[cpt_point] - yof);
	/*if (strcmp(channel, "MATH") == 0)
		if (tabdou[0]>-10) 
			chaine[0]=0;*/ // pour breaker
						
}

static void recup_axe(int device, char *channel, double *tabdou)
{
	char chaine[50];
	float xin, xze;
	int nbpoints, cpt_point;
	
	sprintf(chaine, "DAT:SOU %s", channel);
	ibecr(device, chaine);
	
	ibecr(device, "WFMP:NR_P?");
	ibrd(device, chaine, 50);
	sscanf(chaine, ":WFMP:NR_P %i", &nbpoints);
	
	ibecr(device, "WFMP:XIN?");
	ibrd(device, chaine, 50);
	sscanf(chaine, ":WFMP:XIN %f", &xin);
	
	ibecr(device, "WFMP:XZE?");
	ibrd(device, chaine, 50);
	sscanf(chaine, ":WFMP:XZE %f", &xze);
	
	for (cpt_point = 0; cpt_point<nbpoints; cpt_point++)
		tabdou[cpt_point] = xze + xin * cpt_point;
			
}

static void arreter_interruption_tek(PInstrument *tektro)
{
	infos_tektro *data_osc = tektro->structure;
	
	if (data_osc->stop_interruption == 0) // dj arrt
		return;
		
	//dsactivation de l'interruption
	data_osc->stop_interruption = 0;
	
	//libration de l'identificateur
	//ibonl (data_freq->identificateur, 0);
}

static void tek_nouveau(PInstrument **tektro)
{
	*tektro = (PInstrument *)malloc(sizeof(PInstrument));
	memcpy (*tektro, &tek, sizeof(PInstrument));
	(*tektro)->structure = malloc(sizeof(infos_tektro));
	((infos_tektro *)(*tektro)->structure)->adresse_gpib = 4;
	sprintf(((infos_tektro *)(*tektro)->structure)->nom_instru, "Oscillo 500MHz");
}

static void tek_liberer(PInstrument *tektro)
{
	free(tektro->structure);
	free(tektro);
}

static void tek_get_nom(PInstrument *tektro, char *nom_instru)
{
	memcpy(nom_instru, ((infos_tektro *)tektro->structure)->nom_instru, TAILLE_NOM_INSTRU-1);
}

static void tek_set_nom(PInstrument *tektro, char *nom_instru)
{
	memcpy(((infos_tektro *)tektro->structure)->nom_instru, nom_instru, TAILLE_NOM_INSTRU-1);
	((infos_tektro *)tektro->structure)->nom_instru[TAILLE_NOM_INSTRU-1] = NULL;
}

static void tek_configure(PInstrument *tektro)
{
	infos_tektro *structu = tektro->structure;
	int panel;
	if ((panel = LoadPanel (0, "UIR_tektro3052.uir", P_CFG_TEK)) < 0)
		return ;
	
	SetCtrlVal (panel, P_CFG_TEK_GPIB, structu->adresse_gpib);
	
	SetCtrlVal (panel, P_CFG_TEK_ACQMOD, structu->acqmod);
	SetCtrlVal (panel, P_CFG_TEK_ACQNUMAV, structu->acqnumav);
	SetCtrlVal (panel, P_CFG_TEK_ACQNUME, structu->acqnume);
	SetCtrlVal (panel, P_CFG_TEK_CH1BAN, structu->ch1ban);
	SetCtrlVal (panel, P_CFG_TEK_CH2BAN, structu->ch2ban);
	SetCtrlVal (panel, P_CFG_TEK_CH1COUP, structu->ch1coup);
	SetCtrlVal (panel, P_CFG_TEK_CH2COUP, structu->ch2coup);
	SetCtrlVal (panel, P_CFG_TEK_CH1IMP, structu->ch1imp);
	SetCtrlVal (panel, P_CFG_TEK_CH2IMP, structu->ch2imp);
	SetCtrlVal (panel, P_CFG_TEK_CH1INV, structu->ch1inv);
	SetCtrlVal (panel, P_CFG_TEK_CH2INV, structu->ch2inv);
	SetCtrlVal (panel, P_CFG_TEK_CH1OFF, structu->ch1off);
	SetCtrlVal (panel, P_CFG_TEK_CH2OFF, structu->ch2off);
	SetCtrlVal (panel, P_CFG_TEK_CH1PROBE, structu->ch1probe);
	SetCtrlVal (panel, P_CFG_TEK_CH2PROBE, structu->ch2probe);
	SetCtrlVal (panel, P_CFG_TEK_CH1SCA, structu->ch1sca);
	SetCtrlVal (panel, P_CFG_TEK_CH2SCA, structu->ch2sca);
	SetCtrlVal (panel, P_CFG_TEK_HORMAISCA, structu->hormaisca);
	SetCtrlVal (panel, P_CFG_TEK_HOR_unit, structu->hor_unit);
	SetCtrlVal (panel, P_CFG_TEK_HORRECORD, structu->horrecord);
	SetCtrlVal (panel, P_CFG_TEK_HORTRIGPOS, structu->hortrigpos);
	SetCtrlVal (panel, P_CFG_TEK_TRIGAEDGCOUP, structu->trigaedgcoup);
	SetCtrlVal (panel, P_CFG_TEK_TRIGAEDGSLO, structu->trigaedgslo);
	SetCtrlVal (panel, P_CFG_TEK_TRIGAEDGSOU, structu->trigaedgsou);
	SetCtrlVal (panel, P_CFG_TEK_TRIGALEV, structu->trigalev);
	SetCtrlVal (panel, P_CFG_TEK_MATH1, structu->math1);
	SetCtrlVal (panel, P_CFG_TEK_MATH2, structu->math2);
	SetCtrlVal (panel, P_CFG_TEK_MATHF, structu->mathf);
	SetCtrlVal (panel, P_CFG_TEK_FENETRE, structu->fenetre);
	SetCtrlVal (panel, P_CFG_TEK_LINLOG, structu->linlog);
	SetCtrlVal (panel, P_CFG_TEK_SELCH1, structu->selch1);
	SetCtrlVal (panel, P_CFG_TEK_SELCH2, structu->selch2);
	SetCtrlVal (panel, P_CFG_TEK_SELMATH, structu->selmath);
			
	SetCtrlAttribute (panel, P_CFG_TEK_COMMANDBUTTON, ATTR_CALLBACK_DATA, structu);
	
	DisplayPanel (panel);
}

static void tek_getconfig(PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool)
{
	infos_tektro *data = instrument->structure;
	
	*p_strct = (void*)data;
	*p_member = (void*)&(data->mesures);
	
	*p_bool = 0;
	
}

static int tek_nb_voie(PInstrument *tektro)
{
	int cpt_voie, num_voies_actives = 0;
	infos_tektro *data_osc = tektro->structure;
	
	for (cpt_voie=0; cpt_voie<3; cpt_voie++)
		if (data_osc->voie_active[cpt_voie] == 1)
			num_voies_actives++;
	
	return num_voies_actives;
}

static void tek_get_nom_voie(PInstrument *tektro, int voie, char *nom_voie)
{
	int cpt_voie;
	infos_tektro *data_osc = tektro->structure;
	nom_voie[0] = NULL;
	for (cpt_voie = 0; cpt_voie<3; cpt_voie++)
		if ( (data_osc->voie_active[cpt_voie] == 0) && (cpt_voie<voie) )
			voie++; // on recale le numero de voie demandee par rapport a la position dans la structure
	//voie++;
	switch(voie)
	{
		case 1:
			sprintf(nom_voie, "Channel 1");
			break;
		case 2:
			sprintf(nom_voie, "Channel 2");
			break;
		case 3:
			sprintf(nom_voie, "Math");
			break;
	}
}

static int tek_get_taille_voie(PInstrument *tektro, int voie)
{
	infos_tektro *data_osc = tektro->structure;
	return data_osc->horrecord; // Toujours vrai ?
}

static void tek_mesure(PInstrument *tektro, int voie, double *mesure)
{
	infos_tektro *data_osc = tektro->structure;
	memcpy(mesure, data_osc->mesures[voie-1], data_osc->horrecord * sizeof(double));
}

static void tek_indices(PInstrument *tektro, int voie, double *indices)
{
	infos_tektro *data_osc = tektro->structure;
	memcpy(indices, data_osc->indices[voie-1], data_osc->horrecord * sizeof(double));
}

static unsigned int tek_numero(PInstrument *tektro, int voie)
{
	infos_tektro *data_osc = tektro->structure;
	return data_osc->numero_mesure;
}
