#include "plugin.h"

typedef struct	
{
	int identificateur;
	int adresse_gpib;
	int stop_interruption;
	int voie_select[3]; // booleen pour savoir s'il faut recuperer la voie
	int voie_active[3]; // booleen pour determiner si la voie est active (sur l'oscillo)
	unsigned int numero_mesure;
	int taille_voie[3];
	char nom_instru[128];
	
	char acqmod[6];
	int acqnumav;
	int acqnume;
	char ch1ban[6];
	char ch2ban[6];
	char ch1coup[6];
	char ch2coup[6];
	char ch1imp[6];
	char ch2imp[6];
	int ch1inv;
	int ch2inv;
	float ch1off;
	float ch2off;
	float ch1probe;
	float ch2probe;
	float ch1sca;
	float ch2sca;
	int hormaisca;
	int hor_unit;
	int horrecord;
	int hortrigpos;
	char trigaedgcoup[6];
	char trigaedgslo[6];
	char trigaedgsou[6];
	float trigalev;
	char math1[6];
	char math2[6];
	char mathf[6];
	char fenetre[6];
	char linlog[6];
	int selch1;
	int selch2;
	int selmath;
	
	// Zone  ne pas sauvegarder.
	
	double mesures[3][10000]; // CH1 CH2 MATH
	double indices[3][10000];
	
} infos_tektro;

static int tek_init(PInstrument *tektro);
static int miseenplace_int_tek(PInstrument *frequencemetre);
int __stdcall CB_interruption_tek(int boardOrDevice, int localsta, int localerr, long localcntl, void *callbackData);
static void arreter_interruption_tek(PInstrument *frequencemetre);
static void tek_nouveau(PInstrument **frequencemetre);
static void tek_liberer(PInstrument *instru);
static void tek_get_nom(PInstrument *instrument, char *nom_instru);
static void tek_set_nom(PInstrument *instrument, char *nom_instru);
static void tek_configure(PInstrument *frequencemetre);
static void tek_getconfig(PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool);
static int tek_nb_voie(PInstrument *frequencemetre);
static void tek_get_nom_voie(PInstrument *frequencemetre, int voie, char *nom_voie);
static int tek_get_taille_voie(PInstrument *instrument, int voie);
static void tek_mesure(PInstrument *instrument, int voie, double *mesure);
static void tek_indices(PInstrument *tektro, int voie, double *indices);
static unsigned int tek_numero(PInstrument *frequencemetre, int voie);

static void recup_curve(int device, char *channel, double *tabdou);
static void recup_axe(int device, char *channel, double *tabdou);
