#include "toolbox.h"
#include <utility.h>
#include <ansi_c.h>
#include <cvirte.h>		
#include <userint.h>
#include "plugin.h"
#include "valve.h"
#include "UIR_valve.h"

/* COMMANDES
pschit
duree=0.25
*/

int pschit_lock = 0;
char val_port_para;
int Lock_port_parallele;
	


PInstrument pilote_valve =
{
	NULL, // Rempli par 'nouveau'
	
	NULL, // rempli aprs nouveau (par liste.c)
	NULL,
	NULL,
	NULL,
	NULL,

	valve_nouveau,
	valve_liberer,
	valve_configure,
	valve_getconfig,
	valve_get_nom,
	valve_set_nom,
	NULL,
	NULL,
	valve_init,

	valve_status,
	valve_execute,
	valve_piloter,

	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,

	NULL,
	NULL,
	NULL,
	NULL,
	
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

static void valve_nouveau(PInstrument **valve)
{
	*valve = (PInstrument *)malloc(sizeof(PInstrument));
	memcpy (*valve, &pilote_valve, sizeof(PInstrument));
	(*valve)->structure = malloc(sizeof(infos_valve));
	((infos_valve *)(*valve)->structure)->panel_pilotage = 0;
	sprintf(((infos_valve *)(*valve)->structure)->nom_pilot, "Valve EFD");
}

static void valve_liberer(PInstrument *bidon)
{
	DiscardPanel(((infos_valve *)bidon->structure)->panel_pilotage);
	free(bidon->structure);
	free(bidon);
}

static void valve_configure(PInstrument *bidon)
{
	infos_valve *data = bidon->structure;
	 
	int panel;
	if ((panel = LoadPanel (0, "UIR_valve.uir", P_config)) < 0)
		return ;
	SetCtrlAttribute (panel, P_config_BUTTON_OK, ATTR_CALLBACK_DATA, data);
	DisplayPanel (panel); // Affiche la fentre
}

static void valve_getconfig (PInstrument *instrument, void** p_strct, void** p_member, size_t* p_size, char* p_bool)
{

	infos_valve* data = instrument->structure;
	
	*p_strct = (void*)data;
	*p_size = sizeof(infos_valve);
	
	*p_bool = 1;
}

static void valve_get_nom (PInstrument *bidon, char *nom_pilot)
{
	memcpy(nom_pilot, ((infos_valve *)bidon->structure)->nom_pilot, TAILLE_NOM_INSTRU-1);
}

static void valve_set_nom (PInstrument *bidon, char *nom_pilot)
{
	memcpy(((infos_valve *)bidon->structure)->nom_pilot, nom_pilot, TAILLE_NOM_INSTRU-1);
	((infos_valve *)bidon->structure)->nom_pilot[TAILLE_NOM_INSTRU-1] = NULL;
}

static int valve_status (PInstrument *bidon) // La fonction devrait, dans l'idal, ne pas tre blocante (pour le bon fonctionnement du squenceur)
{
	if(pschit_lock)
		return STATUS_OQP;
	else
		return STATUS_PRET;
	
}

static void valve_execute (PInstrument *bidon, char *chaine) // La fonction devrait, dans l'idal, ne pas tre blocante (pour le bon fonctionnement du squenceur)
{
	// Interprtation de 'chaine'
	// Envoi vers l'appareil
	// Mise  jour du panel pour le pilotage manuel
	double valeur;
	infos_valve *structu_bidon = bidon->structure;

	if (!strcmp(chaine, "pschit"))
	{
		pschit_valve(((infos_valve *)bidon->structure)->duree);
	}
	else
	if (sscanf(chaine, "duree=%lf", &valeur) == 1)
	{
		structu_bidon->duree = valeur;
		SetCtrlVal (structu_bidon->panel_pilotage, P_PILOT_NUMERIC, structu_bidon->duree);
	}
	
	return;
}

static int valve_init (PInstrument *bidon)
{
	// Dtection de l'appareil
	// Configuration
	// ...

	// Chargement du panel pour le pilotage manuel (et mmorisation du panel_handle dans la structure)
	if ( ((infos_valve *)bidon->structure)->panel_pilotage == 0)
		if ( ( ((infos_valve *)bidon->structure)->panel_pilotage = LoadPanel (0, "UIR_valve.uir", P_PILOT)) < 0)
			return -1;
	
	SetCtrlAttribute ( ((infos_valve *)bidon->structure)->panel_pilotage,
		P_PILOT_NUMERIC, ATTR_CALLBACK_DATA, bidon->structure); // duree
	SetCtrlAttribute ( ((infos_valve *)bidon->structure)->panel_pilotage,
		P_PILOT_COMMANDBUTTON_2, ATTR_CALLBACK_DATA, bidon->structure); // pschit

	return 0; // ngatif = erreur
}

static void valve_piloter(PInstrument *bidon)
{
	infos_valve *structu_bidon = bidon->structure;
	DisplayPanel(structu_bidon->panel_pilotage);
}

int CVICALLBACK duree_valve (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	infos_valve *structu_bidon;
	structu_bidon = (infos_valve *)callbackData;
	
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (structu_bidon->panel_pilotage, P_PILOT_NUMERIC, &structu_bidon->duree);
			break;
		}
	return 0;
}

int CVICALLBACK OK_config_valve (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	// utiliser callbackdata si besoin de memoriser un parametre.
	switch (event)
		{
		case EVENT_COMMIT:
			DiscardPanel(panel);
			break;
		}
	return 0;
}

int CVICALLBACK Pschit_valve (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	infos_valve *structu_bidon;
	structu_bidon = (infos_valve *)callbackData;

	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (structu_bidon->panel_pilotage, P_PILOT_NUMERIC, &structu_bidon->duree);
			pschit_valve(structu_bidon->duree);
			break;
		}
	return 0;
}

int CVICALLBACK Cacher_Pilotage_Valve (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{													  
		case EVENT_COMMIT:
			HidePanel(panel);
			break;
		}
	return 0;
}

static void pschit_valve(double duree)
{
	if( pschit_lock ) return;
	
	pschit_lock = 1;
	
	CmtGetLock (Lock_port_parallele);

	val_port_para = inp (0x378); // peut mieux faire: utiliser la structure pour l'adresse
	val_port_para = val_port_para | 1;
	outp (0x378,val_port_para);
	
	PostDelayedCall(CB_pschit_delayed,NULL,duree);
	
	return;
	
	/*
	CmtGetLock (Lock_port_parallele);

	val_port_para = inp (0x378); // peut mieux faire: utiliser la structure pour l'adresse
	val_port_para = val_port_para | 1;
	outp (0x378,val_port_para);
	Delay(duree); // peut mieux faire...
	val_port_para = val_port_para & 0xfe;
	outp (0x378,val_port_para);

	CmtReleaseLock (Lock_port_parallele);				
	*/
}

void CVICALLBACK CB_pschit_delayed(void *callbackData)
{

	val_port_para = val_port_para & 0xfe;
	outp (0x378,val_port_para);

	CmtReleaseLock (Lock_port_parallele);
	
	//MessagePopup("Hep !","Fin du pschit !");
	
	pschit_lock = 0;
	
	return;

}
